diff -pruN 1:4.6.2-1/CMakeLists.txt 1:4.7.1-1/CMakeLists.txt
--- 1:4.6.2-1/CMakeLists.txt	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/CMakeLists.txt	2020-08-14 10:34:26.000000000 +0000
@@ -18,7 +18,7 @@ if(ENABLE_ARCUS)
     # We want to have access to protobuf_generate_cpp and other FindProtobuf features.
     # However, if ProtobufConfig is used instead, there is a CMake option that controls
     # this, which defaults to OFF. We need to force this option to ON instead.
-    set(protobuf_MODULE_COMPATIBLE ON CACHE "" INTERNAL FORCE)
+    set(protobuf_MODULE_COMPATIBLE ON CACHE INTERNAL "" FORCE)
     find_package(Protobuf 3.0.0 REQUIRED)
     find_package(Arcus REQUIRED)
     add_definitions(-DARCUS)
@@ -176,8 +176,6 @@ set(engine_SRCS # Except main.cpp.
     src/infill/ZigzagConnectorProcessor.cpp
     src/infill/SierpinskiFill.cpp
     src/infill/SierpinskiFillProvider.cpp
-    src/infill/SpaghettiInfill.cpp
-    src/infill/SpaghettiInfillPathGenerator.cpp
     src/infill/SubDivCube.cpp
     src/infill/GyroidInfill.cpp
 
diff -pruN 1:4.6.2-1/debian/changelog 1:4.7.1-1/debian/changelog
--- 1:4.6.2-1/debian/changelog	2020-08-19 09:53:16.000000000 +0000
+++ 1:4.7.1-1/debian/changelog	2020-09-07 08:36:14.000000000 +0000
@@ -1,3 +1,10 @@
+cura-engine (1:4.7.1-1) unstable; urgency=medium
+
+  * Team upload.
+  * New upstream version 4.7.1.
+
+ -- Christoph Berg <myon@debian.org>  Mon, 07 Sep 2020 10:36:14 +0200
+
 cura-engine (1:4.6.2-1) unstable; urgency=medium
 
   * Team upload.
diff -pruN 1:4.6.2-1/debian/tests/fdmextruder.def.json 1:4.7.1-1/debian/tests/fdmextruder.def.json
--- 1:4.6.2-1/debian/tests/fdmextruder.def.json	2020-08-19 09:42:54.000000000 +0000
+++ 1:4.7.1-1/debian/tests/fdmextruder.def.json	2020-09-07 08:36:14.000000000 +0000
@@ -6,7 +6,7 @@
         "type": "extruder",
         "author": "Ultimaker",
         "manufacturer": "Unknown",
-        "setting_version": 14,
+        "setting_version": 15,
         "visible": false,
         "position": "0"
     },
diff -pruN 1:4.6.2-1/debian/tests/fdmprinter.def.json 1:4.7.1-1/debian/tests/fdmprinter.def.json
--- 1:4.6.2-1/debian/tests/fdmprinter.def.json	2020-08-19 09:43:04.000000000 +0000
+++ 1:4.7.1-1/debian/tests/fdmprinter.def.json	2020-09-07 08:36:14.000000000 +0000
@@ -5,9 +5,8 @@
     {
         "type": "machine",
         "author": "Ultimaker",
-        "category": "Other",
         "manufacturer": "Unknown",
-        "setting_version": 14,
+        "setting_version": 15,
         "file_formats": "text/x-gcode;application/x-stl-ascii;application/x-stl-binary;application/x-wavefront-obj;application/x3g",
         "visible": false,
         "has_materials": true,
@@ -220,6 +219,16 @@
                     "settable_per_extruder": false,
                     "settable_per_meshgroup": false
                 },
+                "machine_always_write_active_tool":
+                {
+                    "label": "Always Write Active Tool",
+                    "description": "Write active tool after sending temp commands to inactive tool. Required for Dual Extruder printing with Smoothie or other firmware with modal tool commands.",
+                    "default_value": false,
+                    "type": "bool",
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": false,
+                    "settable_per_meshgroup": false
+                },
                 "machine_center_is_zero":
                 {
                     "label": "Is Center Origin",
@@ -878,7 +887,7 @@
                             "maximum_value_warning": "3 * machine_nozzle_size",
                             "default_value": 0.4,
                             "type": "float",
-                            "enabled": "(support_enable or support_tree_enable)",
+                            "enabled": "(support_enable or support_meshes_present)",
                             "value": "line_width",
                             "limit_to_extruder": "support_infill_extruder_nr",
                             "settable_per_mesh": false,
@@ -894,7 +903,7 @@
                             "minimum_value_warning": "0.1 + 0.4 * machine_nozzle_size",
                             "maximum_value_warning": "2 * machine_nozzle_size",
                             "type": "float",
-                            "enabled": "(support_enable or support_tree_enable) and support_interface_enable",
+                            "enabled": "(support_enable or support_meshes_present) and support_interface_enable",
                             "limit_to_extruder": "support_interface_extruder_nr",
                             "value": "line_width",
                             "settable_per_mesh": false,
@@ -911,7 +920,7 @@
                                     "minimum_value_warning": "0.4 * machine_nozzle_size",
                                     "maximum_value_warning": "2 * machine_nozzle_size",
                                     "type": "float",
-                                    "enabled": "(support_enable or support_tree_enable) and support_roof_enable",
+                                    "enabled": "(support_enable or support_meshes_present) and support_roof_enable",
                                     "limit_to_extruder": "support_roof_extruder_nr",
                                     "value": "extruderValue(support_roof_extruder_nr, 'support_interface_line_width')",
                                     "settable_per_mesh": false,
@@ -927,7 +936,7 @@
                                     "minimum_value_warning": "0.4 * machine_nozzle_size",
                                     "maximum_value_warning": "2 * machine_nozzle_size",
                                     "type": "float",
-                                    "enabled": "(support_enable or support_tree_enable) and support_bottom_enable",
+                                    "enabled": "(support_enable or support_meshes_present) and support_bottom_enable",
                                     "limit_to_extruder": "support_bottom_extruder_nr",
                                     "value": "extruderValue(support_bottom_extruder_nr, 'support_interface_line_width')",
                                     "settable_per_mesh": false,
@@ -1501,11 +1510,12 @@
                 {
                     "label": "Extra Skin Wall Count",
                     "description": "Replaces the outermost part of the top/bottom pattern with a number of concentric lines. Using one or two lines improves roofs that start on infill material.",
+                    "value": "0 if top_bottom_pattern == 'concentric' and top_bottom_pattern_0 == 'concentric' and roofing_layer_count <= 0 else 1",
                     "default_value": 1,
                     "minimum_value": "0",
                     "maximum_value_warning": "10",
                     "type": "int",
-                    "enabled": "top_layers > 0 or bottom_layers > 0",
+                    "enabled": "(top_layers > 0 or bottom_layers > 0) and (top_bottom_pattern != 'concentric' or top_bottom_pattern_0 != 'concentric' or (roofing_layer_count > 0 and roofing_pattern != 'concentric'))",
                     "limit_to_extruder": "top_bottom_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -1576,7 +1586,7 @@
                     "type": "float",
                     "unit": "mm",
                     "default_value": 0.35,
-                    "value": "wall_line_width_0 / 2",
+                    "value": "wall_line_width_0 / 2 + (ironing_line_spacing - skin_line_width * (1.0 + ironing_flow / 100) / 2 if ironing_pattern == 'concentric' else skin_line_width * (1.0 - ironing_flow / 100) / 2)",
                     "minimum_value_warning": "0",
                     "maximum_value_warning": "wall_line_width_0",
                     "enabled": "ironing_enabled",
@@ -1762,7 +1772,7 @@
                     "description": "A list of integer line directions to use. Elements from the list are used sequentially as the layers progress and when the end of the list is reached, it starts at the beginning again. The list items are separated by commas and the whole list is contained in square brackets. Default is an empty list which means use the traditional default angles (45 and 135 degrees for the lines and zig zag patterns and 45 degrees for all other patterns).",
                     "type": "[int]",
                     "default_value": "[ ]",
-                    "enabled": "infill_pattern != 'concentric' and infill_pattern != 'cubicsubdiv' and infill_sparse_density > 0",
+                    "enabled": "infill_pattern != 'concentric' and infill_sparse_density > 0",
                     "limit_to_extruder": "infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -1807,7 +1817,7 @@
                     "type": "int",
                     "minimum_value": "1",
                     "maximum_value_warning": "infill_line_distance / infill_line_width",
-                    "enabled": "infill_sparse_density > 0 and not spaghetti_infill_enabled and infill_pattern != 'zigzag'",
+                    "enabled": "infill_sparse_density > 0 and infill_pattern != 'zigzag'",
                     "limit_to_extruder": "infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -1818,7 +1828,7 @@
                     "default_value": 0,
                     "type": "int",
                     "minimum_value": "0",
-                    "enabled": "infill_sparse_density > 0 and not spaghetti_infill_enabled",
+                    "enabled": "infill_sparse_density > 0",
                     "limit_to_extruder": "infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -1889,9 +1899,9 @@
                     "default_value": 0.1,
                     "minimum_value": "resolveOrValue('layer_height') / 2 if infill_line_distance > 0 else -999999",
                     "maximum_value_warning": "0.75 * machine_nozzle_size",
-                    "maximum_value": "resolveOrValue('layer_height') * (1.45 if spaghetti_infill_enabled else 8) if infill_line_distance > 0 else 999999",
+                    "maximum_value": "resolveOrValue('layer_height') * 8 if infill_line_distance > 0 else 999999",
                     "value": "resolveOrValue('layer_height')",
-                    "enabled": "infill_sparse_density > 0 and not spaghetti_infill_enabled",
+                    "enabled": "infill_sparse_density > 0",
                     "limit_to_extruder": "infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -1903,8 +1913,8 @@
                     "type": "int",
                     "minimum_value": "0",
                     "maximum_value_warning": "1 if (infill_pattern == 'cross' or infill_pattern == 'cross_3d' or support_pattern == 'concentric') else 5",
-                    "maximum_value": "0 if spaghetti_infill_enabled else (999999 if infill_line_distance == 0 else (20 - math.log(infill_line_distance) / math.log(2)))",
-                    "enabled": "infill_sparse_density > 0 and infill_pattern != 'cubicsubdiv' and not spaghetti_infill_enabled",
+                    "maximum_value": "999999 if infill_line_distance == 0 else (20 - math.log(infill_line_distance) / math.log(2))",
+                    "enabled": "infill_sparse_density > 0 and infill_pattern != 'cubicsubdiv'",
                     "limit_to_extruder": "infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -2073,7 +2083,7 @@
                             "description": "Skin areas narrower than this are not expanded. This avoids expanding the narrow skin areas that are created when the model surface has a slope close to the vertical.",
                             "unit": "mm",
                             "type": "float",
-                            "default_value": 2.24,
+                            "default_value": 0,
                             "value": "top_layers * layer_height / math.tan(math.radians(max_skin_angle_for_expansion))",
                             "minimum_value": "0",
                             "enabled": "(top_layers > 0 or bottom_layers > 0) and (top_skin_expand_distance > 0 or bottom_skin_expand_distance > 0)",
@@ -2615,7 +2625,7 @@
                             "minimum_value": "5",
                             "minimum_value_warning": "50",
                             "maximum_value_warning": "150",
-                            "enabled": "support_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "limit_to_extruder": "support_infill_extruder_nr",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
@@ -2631,7 +2641,7 @@
                             "minimum_value": "5",
                             "minimum_value_warning": "50",
                             "maximum_value_warning": "150",
-                            "enabled": "support_enable and support_interface_enable",
+                            "enabled": "(support_enable or support_meshes_present) and support_interface_enable",
                             "limit_to_extruder": "support_interface_extruder_nr",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true,
@@ -2648,7 +2658,7 @@
                                     "minimum_value": "5",
                                     "minimum_value_warning": "50",
                                     "maximum_value_warning": "150",
-                                    "enabled": "support_enable and support_roof_enable",
+                                    "enabled": "(support_enable or support_meshes_present) and support_roof_enable",
                                     "limit_to_extruder": "support_roof_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
@@ -2664,7 +2674,7 @@
                                     "minimum_value": "5",
                                     "minimum_value_warning": "50",
                                     "maximum_value_warning": "150",
-                                    "enabled": "support_enable and support_bottom_enable",
+                                    "enabled": "(support_enable or support_meshes_present) and support_bottom_enable",
                                     "limit_to_extruder": "support_bottom_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
@@ -2837,7 +2847,7 @@
                             "maximum_value_warning": "150",
                             "default_value": 60,
                             "value": "speed_print",
-                            "enabled": "support_enable or support_tree_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "settable_per_mesh": false,
                             "limit_to_extruder": "support_extruder_nr",
                             "settable_per_extruder": true,
@@ -2854,7 +2864,7 @@
                                     "maximum_value": "math.sqrt(machine_max_feedrate_x ** 2 + machine_max_feedrate_y ** 2)",
                                     "maximum_value_warning": "150",
                                     "value": "speed_support",
-                                    "enabled": "support_enable or support_tree_enable",
+                                    "enabled": "support_enable or support_meshes_present",
                                     "limit_to_extruder": "support_infill_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
@@ -2869,7 +2879,7 @@
                                     "minimum_value": "0.1",
                                     "maximum_value": "math.sqrt(machine_max_feedrate_x ** 2 + machine_max_feedrate_y ** 2)",
                                     "maximum_value_warning": "150",
-                                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                                     "limit_to_extruder": "support_interface_extruder_nr",
                                     "value": "speed_support / 1.5",
                                     "settable_per_mesh": false,
@@ -2886,7 +2896,7 @@
                                             "minimum_value": "0.1",
                                             "maximum_value": "math.sqrt(machine_max_feedrate_x ** 2 + machine_max_feedrate_y ** 2)",
                                             "maximum_value_warning": "150",
-                                            "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                                            "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                                             "limit_to_extruder": "support_roof_extruder_nr",
                                             "value": "extruderValue(support_roof_extruder_nr, 'speed_support_interface')",
                                             "settable_per_mesh": false,
@@ -2902,7 +2912,7 @@
                                             "minimum_value": "0.1",
                                             "maximum_value": "math.sqrt(machine_max_feedrate_x ** 2 + machine_max_feedrate_y ** 2)",
                                             "maximum_value_warning": "150",
-                                            "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                                            "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                                             "limit_to_extruder": "support_bottom_extruder_nr",
                                             "value": "extruderValue(support_bottom_extruder_nr, 'speed_support_interface')",
                                             "settable_per_mesh": false,
@@ -3177,7 +3187,7 @@
                             "maximum_value_warning": "10000",
                             "default_value": 3000,
                             "value": "acceleration_print",
-                            "enabled": "resolveOrValue('acceleration_enabled') and (support_enable or support_tree_enable)",
+                            "enabled": "resolveOrValue('acceleration_enabled') and (support_enable or support_meshes_present)",
                             "settable_per_mesh": false,
                             "limit_to_extruder": "support_extruder_nr",
                             "settable_per_extruder": true,
@@ -3194,7 +3204,7 @@
                                     "minimum_value": "0.1",
                                     "minimum_value_warning": "100",
                                     "maximum_value_warning": "10000",
-                                    "enabled": "resolveOrValue('acceleration_enabled') and (support_enable or support_tree_enable)",
+                                    "enabled": "resolveOrValue('acceleration_enabled') and (support_enable or support_meshes_present)",
                                     "limit_to_extruder": "support_infill_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
@@ -3210,7 +3220,7 @@
                                     "minimum_value": "0.1",
                                     "minimum_value_warning": "100",
                                     "maximum_value_warning": "10000",
-                                    "enabled": "resolveOrValue('acceleration_enabled') and support_interface_enable and (support_enable or support_tree_enable)",
+                                    "enabled": "resolveOrValue('acceleration_enabled') and support_interface_enable and (support_enable or support_meshes_present)",
                                     "limit_to_extruder": "support_interface_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true,
@@ -3227,7 +3237,7 @@
                                             "minimum_value": "0.1",
                                             "minimum_value_warning": "100",
                                             "maximum_value_warning": "10000",
-                                            "enabled": "acceleration_enabled and support_roof_enable and (support_enable or support_tree_enable)",
+                                            "enabled": "acceleration_enabled and support_roof_enable and (support_enable or support_meshes_present)",
                                             "limit_to_extruder": "support_roof_extruder_nr",
                                             "settable_per_mesh": false,
                                             "settable_per_extruder": true
@@ -3243,7 +3253,7 @@
                                             "minimum_value": "0.1",
                                             "minimum_value_warning": "100",
                                             "maximum_value_warning": "10000",
-                                            "enabled": "acceleration_enabled and support_bottom_enable and (support_enable or support_tree_enable)",
+                                            "enabled": "acceleration_enabled and support_bottom_enable and (support_enable or support_meshes_present)",
                                             "limit_to_extruder": "support_bottom_extruder_nr",
                                             "settable_per_mesh": false,
                                             "settable_per_extruder": true
@@ -3462,7 +3472,7 @@
                             "maximum_value_warning": "50",
                             "default_value": 20,
                             "value": "jerk_print",
-                            "enabled": "resolveOrValue('jerk_enabled') and (support_enable or support_tree_enable)",
+                            "enabled": "resolveOrValue('jerk_enabled') and (support_enable or support_meshes_present)",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true,
                             "limit_to_extruder": "support_extruder_nr",
@@ -3478,7 +3488,7 @@
                                     "value": "jerk_support",
                                     "minimum_value": "0",
                                     "maximum_value_warning": "50",
-                                    "enabled": "resolveOrValue('jerk_enabled') and (support_enable or support_tree_enable)",
+                                    "enabled": "resolveOrValue('jerk_enabled') and (support_enable or support_meshes_present)",
                                     "limit_to_extruder": "support_infill_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
@@ -3493,7 +3503,7 @@
                                     "value": "jerk_support",
                                     "minimum_value": "0",
                                     "maximum_value_warning": "50",
-                                    "enabled": "resolveOrValue('jerk_enabled') and support_interface_enable and (support_enable or support_tree_enable)",
+                                    "enabled": "resolveOrValue('jerk_enabled') and support_interface_enable and (support_enable or support_meshes_present)",
                                     "limit_to_extruder": "support_interface_extruder_nr",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true,
@@ -3509,7 +3519,7 @@
                                             "value": "extruderValue(support_roof_extruder_nr, 'jerk_support_interface')",
                                             "minimum_value": "0",
                                             "maximum_value_warning": "50",
-                                            "enabled": "resolveOrValue('jerk_enabled') and support_roof_enable and (support_enable or support_tree_enable)",
+                                            "enabled": "resolveOrValue('jerk_enabled') and support_roof_enable and (support_enable or support_meshes_present)",
                                             "limit_to_extruder": "support_roof_extruder_nr",
                                             "settable_per_mesh": false,
                                             "settable_per_extruder": true
@@ -3524,7 +3534,7 @@
                                             "value": "extruderValue(support_roof_extruder_nr, 'jerk_support_interface')",
                                             "minimum_value": "0",
                                             "maximum_value_warning": "50",
-                                            "enabled": "resolveOrValue('jerk_enabled') and support_bottom_enable and (support_enable or support_tree_enable)",
+                                            "enabled": "resolveOrValue('jerk_enabled') and support_bottom_enable and (support_enable or support_meshes_present)",
                                             "limit_to_extruder": "support_bottom_extruder_nr",
                                             "settable_per_mesh": false,
                                             "settable_per_extruder": true
@@ -3768,7 +3778,7 @@
                     "description": "Omit retraction when moving from support to support in a straight line. Enabling this setting saves print time, but can lead to excessive stringing within the support structure.",
                     "type": "bool",
                     "default_value": true,
-                    "enabled": "retraction_enable and (support_enable or support_tree_enable)",
+                    "enabled": "retraction_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
                 },
@@ -4098,7 +4108,7 @@
                     "type": "extruder",
                     "default_value": "0",
                     "value": "int(defaultExtruderPosition())",
-                    "enabled": "(support_enable or support_tree_enable) and extruders_enabled_count > 1",
+                    "enabled": "(support_enable or support_meshes_present) and extruders_enabled_count > 1",
                     "settable_per_mesh": false,
                     "settable_per_extruder": false,
                     "children": {
@@ -4109,7 +4119,7 @@
                             "type": "extruder",
                             "default_value": "0",
                             "value": "support_extruder_nr",
-                            "enabled": "(support_enable or support_tree_enable) and extruders_enabled_count > 1",
+                            "enabled": "(support_enable or support_meshes_present) and extruders_enabled_count > 1",
                             "settable_per_mesh": false,
                             "settable_per_extruder": false
                         },
@@ -4120,7 +4130,7 @@
                             "type": "extruder",
                             "default_value": "0",
                             "value": "support_extruder_nr",
-                            "enabled": "(support_enable or support_tree_enable) and extruders_enabled_count > 1",
+                            "enabled": "(support_enable or support_meshes_present) and extruders_enabled_count > 1",
                             "settable_per_mesh": false,
                             "settable_per_extruder": false
                         },
@@ -4131,7 +4141,7 @@
                             "type": "extruder",
                             "default_value": "0",
                             "value": "support_extruder_nr",
-                            "enabled": "(support_enable or support_tree_enable) and extruders_enabled_count > 1",
+                            "enabled": "(support_enable or support_meshes_present) and extruders_enabled_count > 1",
                             "settable_per_mesh": false,
                             "settable_per_extruder": false,
                             "children":
@@ -4143,7 +4153,7 @@
                                     "type": "extruder",
                                     "default_value": "0",
                                     "value": "support_interface_extruder_nr",
-                                    "enabled": "(support_enable or support_tree_enable) and extruders_enabled_count > 1",
+                                    "enabled": "(support_enable or support_meshes_present) and extruders_enabled_count > 1",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": false
                                 },
@@ -4154,7 +4164,7 @@
                                     "type": "extruder",
                                     "default_value": "0",
                                     "value": "support_interface_extruder_nr",
-                                    "enabled": "(support_enable or support_tree_enable) and extruders_enabled_count > 1",
+                                    "enabled": "(support_enable or support_meshes_present) and extruders_enabled_count > 1",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": false
                                 }
@@ -4162,6 +4172,93 @@
                         }
                     }
                 },
+                "support_structure":
+                {
+                    "label": "Support Structure",
+                    "description": "Chooses between the techniques available to generate support. \"Normal\" support creates a support structure directly below the overhanging parts and drops those areas straight down. \"Tree\" support creates branches towards the overhanging areas that support the model on the tips of those branches, and allows the branches to crawl around the model to support it from the build plate as much as possible.",
+                    "type": "enum",
+                    "options":
+                    {
+                        "normal": "Normal",
+                        "tree": "Tree"
+                    },
+                    "enabled": "support_enable",
+                    "default_value": "normal",
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": false
+                },
+                "support_tree_angle":
+                {
+                    "label": "Tree Support Branch Angle",
+                    "description": "The angle of the branches. Use a lower angle to make them more vertical and more stable. Use a higher angle to be able to have more reach.",
+                    "unit": "°",
+                    "type": "float",
+                    "minimum_value": "0",
+                    "maximum_value": "90",
+                    "maximum_value_warning": "60",
+                    "default_value": 40,
+                    "limit_to_extruder": "support_infill_extruder_nr",
+                    "enabled": "support_enable and support_structure=='tree'",
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": true
+                },
+                "support_tree_branch_distance":
+                {
+                    "label": "Tree Support Branch Distance",
+                    "description": "How far apart the branches need to be when they touch the model. Making this distance small will cause the tree support to touch the model at more points, causing better overhang but making support harder to remove.",
+                    "unit": "mm",
+                    "type": "float",
+                    "minimum_value": "0.001",
+                    "default_value": 1,
+                    "limit_to_extruder": "support_infill_extruder_nr",
+                    "enabled": "support_enable and support_structure=='tree'",
+                    "settable_per_mesh": true
+                },
+                "support_tree_branch_diameter":
+                {
+                    "label": "Tree Support Branch Diameter",
+                    "description": "The diameter of the thinnest branches of tree support. Thicker branches are more sturdy. Branches towards the base will be thicker than this.",
+                    "unit": "mm",
+                    "type": "float",
+                    "minimum_value": "0.001",
+                    "minimum_value_warning": "support_line_width * 2",
+                    "default_value": 2,
+                    "limit_to_extruder": "support_infill_extruder_nr",
+                    "enabled": "support_enable and support_structure=='tree'",
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": true
+                },
+                "support_tree_branch_diameter_angle":
+                {
+                    "label": "Tree Support Branch Diameter Angle",
+                    "description": "The angle of the branches' diameter as they gradually become thicker towards the bottom. An angle of 0 will cause the branches to have uniform thickness over their length. A bit of an angle can increase stability of the tree support.",
+                    "unit": "°",
+                    "type": "float",
+                    "minimum_value": "0",
+                    "maximum_value": "89.9999",
+                    "maximum_value_warning": "15",
+                    "default_value": 5,
+                    "limit_to_extruder": "support_infill_extruder_nr",
+                    "enabled": "support_enable and support_structure=='tree'",
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": true
+                },
+                "support_tree_collision_resolution":
+                {
+                    "label": "Tree Support Collision Resolution",
+                    "description": "Resolution to compute collisions with to avoid hitting the model. Setting this lower will produce more accurate trees that fail less often, but increases slicing time dramatically.",
+                    "unit": "mm",
+                    "type": "float",
+                    "minimum_value": "0.001",
+                    "minimum_value_warning": "support_line_width / 4",
+                    "maximum_value_warning": "support_line_width * 2",
+                    "default_value": 0.4,
+                    "value": "support_line_width / 2",
+                    "limit_to_extruder": "support_infill_extruder_nr",
+                    "enabled": "support_enable and support_structure=='tree' and support_tree_branch_diameter_angle > 0",
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": true
+                },
                 "support_type":
                 {
                     "label": "Support Placement",
@@ -4174,7 +4271,7 @@
                     },
                     "default_value": "everywhere",
                     "resolve": "'everywhere' if 'everywhere' in extruderValues('support_type') else 'buildplate'",
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable",
                     "settable_per_mesh": false,
                     "settable_per_extruder": false
                 },
@@ -4189,7 +4286,7 @@
                     "maximum_value_warning": "80",
                     "default_value": 50,
                     "limit_to_extruder": "support_roof_extruder_nr if support_roof_enable else support_infill_extruder_nr",
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable",
                     "settable_per_mesh": true
                 },
                 "support_pattern":
@@ -4208,7 +4305,7 @@
                         "gyroid": "Gyroid"
                     },
                     "default_value": "zigzag",
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -4220,10 +4317,10 @@
                     "default_value": 1,
                     "minimum_value": "0",
                     "minimum_value_warning": "1 if support_pattern == 'concentric' else 0",
-                    "maximum_value_warning": "3",
+                    "maximum_value_warning": "0 if (support_skip_some_zags and support_pattern == 'zigzag') else 3",
                     "type": "int",
-                    "value": "1 if support_tree_enable else (1 if (support_pattern == 'grid' or support_pattern == 'triangles' or support_pattern == 'concentric') else 0)",
-                    "enabled": "support_enable or support_tree_enable",
+                    "value": "1 if support_enable and support_structure == 'tree' else (1 if (support_pattern == 'grid' or support_pattern == 'triangles' or support_pattern == 'concentric') else 0)",
+                    "enabled": "support_enable or support_meshes_present",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -4235,7 +4332,7 @@
                     "type": "bool",
                     "default_value": false,
                     "value": "support_pattern == 'cross' or support_pattern == 'gyroid'",
-                    "enabled": "(support_enable or support_tree_enable) and (support_pattern == 'grid' or support_pattern == 'triangles' or support_pattern == 'cross' or support_pattern == 'gyroid')",
+                    "enabled": "(support_enable or support_meshes_present) and (support_pattern == 'lines' or support_pattern == 'grid' or support_pattern == 'triangles' or support_pattern == 'cross' or support_pattern == 'gyroid')",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -4246,7 +4343,7 @@
                     "description": "Connect the ZigZags. This will increase the strength of the zig zag support structure.",
                     "type": "bool",
                     "default_value": true,
-                    "enabled": "(support_enable or support_tree_enable) and support_pattern == 'zigzag'",
+                    "enabled": "(support_enable or support_meshes_present) and support_pattern == 'zigzag'",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -4260,8 +4357,8 @@
                     "minimum_value": "0",
                     "maximum_value_warning": "100",
                     "default_value": 15,
-                    "value": "15 if support_enable else 0 if support_tree_enable else 15",
-                    "enabled": "support_enable or support_tree_enable",
+                    "value": "15 if support_enable and support_structure == 'normal' else 0 if support_enable and support_structure == 'tree' else 15",
+                    "enabled": "support_enable or support_meshes_present",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
@@ -4276,7 +4373,7 @@
                             "minimum_value": "0",
                             "minimum_value_warning": "support_line_width",
                             "default_value": 2.66,
-                            "enabled": "support_enable or support_tree_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "value": "0 if support_infill_rate == 0 else (support_line_width * 100) / support_infill_rate * (2 if support_pattern == 'grid' else (3 if support_pattern == 'triangles' else 1))",
                             "limit_to_extruder": "support_infill_extruder_nr",
                             "settable_per_mesh": false,
@@ -4291,7 +4388,7 @@
                             "minimum_value": "0",
                             "minimum_value_warning": "support_line_width",
                             "default_value": 2.66,
-                            "enabled": "support_enable or support_tree_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "value": "support_line_distance",
                             "limit_to_extruder": "support_infill_extruder_nr",
                             "settable_per_mesh": false,
@@ -4305,7 +4402,7 @@
                     "description": "A list of integer line directions to use. Elements from the list are used sequentially as the layers progress and when the end of the list is reached, it starts at the beginning again. The list items are separated by commas and the whole list is contained in square brackets. Default is an empty list which means use the default angle 0 degrees.",
                     "type": "[int]",
                     "default_value": "[ ]",
-                    "enabled": "(support_enable or support_tree_enable) and support_pattern != 'concentric' and support_infill_rate > 0",
+                    "enabled": "(support_enable or support_meshes_present) and support_pattern != 'concentric' and support_infill_rate > 0",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -4316,7 +4413,8 @@
                     "description": "Generate a brim within the support infill regions of the first layer. This brim is printed underneath the support, not around it. Enabling this setting increases the adhesion of support to the build plate.",
                     "type": "bool",
                     "default_value": false,
-                    "enabled": "support_enable or support_tree_enable",
+                    "value": "support_structure == 'tree'",
+                    "enabled": "support_enable or support_meshes_present",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -4330,7 +4428,7 @@
                     "default_value": 8.0,
                     "minimum_value": "0.0",
                     "maximum_value_warning": "50.0",
-                    "enabled": "(support_enable or support_tree_enable) and support_brim_enable",
+                    "enabled": "(support_enable or support_meshes_present) and support_brim_enable",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
                     "limit_to_extruder": "support_infill_extruder_nr",
@@ -4345,7 +4443,7 @@
                             "minimum_value": "0",
                             "maximum_value_warning": "50 / skirt_brim_line_width",
                             "value": "math.ceil(support_brim_width / (skirt_brim_line_width * initial_layer_line_width_factor / 100.0))",
-                            "enabled": "(support_enable or support_tree_enable) and support_brim_enable",
+                            "enabled": "(support_enable or support_meshes_present) and support_brim_enable",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true,
                             "limit_to_extruder": "support_infill_extruder_nr"
@@ -4362,7 +4460,7 @@
                     "maximum_value_warning": "machine_nozzle_size",
                     "default_value": 0.1,
                     "limit_to_extruder": "support_interface_extruder_nr if support_interface_enable else support_infill_extruder_nr",
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": true,
                     "children":
                     {
@@ -4375,7 +4473,7 @@
                             "maximum_value_warning": "machine_nozzle_size",
                             "default_value": 0.1,
                             "type": "float",
-                            "enabled": "support_enable or support_tree_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "value": "extruderValue(support_roof_extruder_nr if support_roof_enable else support_infill_extruder_nr, 'support_z_distance')",
                             "limit_to_extruder": "support_roof_extruder_nr if support_roof_enable else support_infill_extruder_nr",
                             "settable_per_mesh": true
@@ -4391,7 +4489,7 @@
                             "value": "extruderValue(support_bottom_extruder_nr if support_bottom_enable else support_infill_extruder_nr, 'support_z_distance') if support_type == 'everywhere' else 0",
                             "limit_to_extruder": "support_bottom_extruder_nr if support_bottom_enable else support_infill_extruder_nr",
                             "type": "float",
-                            "enabled": "(support_enable or support_tree_enable) and resolveOrValue('support_type') == 'everywhere'",
+                            "enabled": "(support_enable or support_meshes_present) and resolveOrValue('support_type') == 'everywhere'",
                             "settable_per_mesh": true
                         }
                     }
@@ -4406,7 +4504,7 @@
                     "maximum_value_warning": "1.5 * machine_nozzle_tip_outer_diameter",
                     "default_value": 0.7,
                     "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": true
                 },
                 "support_xy_overrides_z":
@@ -4421,7 +4519,7 @@
                     },
                     "default_value": "z_overrides_xy",
                     "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": true
                 },
                 "support_xy_distance_overhang":
@@ -4436,7 +4534,7 @@
                     "default_value": 0.2,
                     "value": "machine_nozzle_size / 2",
                     "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_enable and support_xy_overrides_z == 'z_overrides_xy'",
+                    "enabled": "(support_enable or support_meshes_present) and support_xy_overrides_z == 'z_overrides_xy'",
                     "settable_per_mesh": true
                 },
                 "support_bottom_stair_step_height":
@@ -4449,7 +4547,7 @@
                     "limit_to_extruder": "support_bottom_extruder_nr if support_bottom_enable else support_infill_extruder_nr",
                     "minimum_value": "0",
                     "maximum_value_warning": "1.0",
-                    "enabled": "support_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": true
                 },
                 "support_bottom_stair_step_width":
@@ -4462,7 +4560,20 @@
                     "limit_to_extruder": "support_interface_extruder_nr if support_interface_enable else support_infill_extruder_nr",
                     "minimum_value": "0",
                     "maximum_value_warning": "10.0",
-                    "enabled": "support_enable",
+                    "enabled": "support_enable or support_meshes_present",
+                    "settable_per_mesh": true
+                },
+                "support_bottom_stair_step_min_slope":
+                {
+                    "label": "Support Stair Step Minimum Slope Angle",
+                    "description": "The minimum slope of the area for stair-stepping to take effect. Low values should make support easier to remove on shallower slopes, but really low values may result in some very counter-intuitive results on other parts of the model.",
+                    "unit": "°",
+                    "type": "float",
+                    "default_value": 10.0,
+                    "limit_to_extruder": "support_bottom_extruder_nr if support_bottom_enable else support_infill_extruder_nr",
+                    "minimum_value": "0.01",
+                    "maximum_value": "89.99",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": true
                 },
                 "support_join_distance":
@@ -4475,7 +4586,7 @@
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "minimum_value_warning": "0",
                     "maximum_value_warning": "10",
-                    "enabled": "support_enable",
+                    "enabled": "support_enable and support_structure == 'normal'",
                     "settable_per_mesh": true
                 },
                 "support_offset":
@@ -4488,7 +4599,7 @@
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "minimum_value_warning": "-1 * machine_nozzle_size",
                     "maximum_value_warning": "10 * machine_nozzle_size",
-                    "enabled": "support_enable",
+                    "enabled": "(support_enable and support_structure == 'normal') or support_meshes_present",
                     "settable_per_mesh": true
                 },
                 "support_infill_sparse_thickness":
@@ -4502,7 +4613,7 @@
                     "maximum_value_warning": "0.75 * machine_nozzle_size",
                     "maximum_value": "resolveOrValue('layer_height') * 8",
                     "value": "resolveOrValue('layer_height')",
-                    "enabled": "(support_enable or support_tree_enable) and support_infill_rate > 0",
+                    "enabled": "(support_enable or support_meshes_present) and support_infill_rate > 0",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false
                 },
@@ -4515,7 +4626,7 @@
                     "minimum_value": "0",
                     "maximum_value_warning": "1 if (support_pattern == 'cross' or support_pattern == 'lines' or support_pattern == 'zigzag' or support_pattern == 'concentric') else 5",
                     "maximum_value": "999999 if support_line_distance == 0 else (20 - math.log(support_line_distance) / math.log(2))",
-                    "enabled": "(support_enable or support_tree_enable) and support_infill_rate > 0",
+                    "enabled": "(support_enable or support_meshes_present) and support_infill_rate > 0",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false
                 },
@@ -4528,7 +4639,7 @@
                     "default_value": 1,
                     "minimum_value": "0.0001",
                     "minimum_value_warning": "3 * resolveOrValue('layer_height')",
-                    "enabled": "(support_enable or support_tree_enable) and support_infill_rate > 0 and gradual_support_infill_steps > 0",
+                    "enabled": "(support_enable or support_meshes_present) and support_infill_rate > 0 and gradual_support_infill_steps > 0",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false
                 },
@@ -4541,7 +4652,7 @@
                     "default_value": 0.0,
                     "minimum_value": "0",
                     "maximum_value_warning": "5",
-                    "enabled": "support_enable",
+                    "enabled": "support_enable and support_structure == 'normal'",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -4552,7 +4663,7 @@
                     "type": "bool",
                     "default_value": false,
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": true,
                     "children":
                     {
@@ -4564,7 +4675,7 @@
                             "default_value": false,
                             "value": "extruderValue(support_roof_extruder_nr, 'support_interface_enable')",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "support_enable or support_tree_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "settable_per_mesh": true
                         },
                         "support_bottom_enable":
@@ -4575,7 +4686,7 @@
                             "default_value": false,
                             "value": "extruderValue(support_bottom_extruder_nr, 'support_interface_enable')",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "support_enable or support_tree_enable",
+                            "enabled": "support_enable or support_meshes_present",
                             "settable_per_mesh": true
                         }
                     }
@@ -4591,7 +4702,7 @@
                     "minimum_value_warning": "0.2 + layer_height",
                     "maximum_value_warning": "10",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": true,
                     "children":
                     {
@@ -4607,7 +4718,7 @@
                             "maximum_value_warning": "10",
                             "value": "extruderValue(support_roof_extruder_nr, 'support_interface_height')",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": true
                         },
                         "support_bottom_height":
@@ -4622,7 +4733,7 @@
                             "minimum_value_warning": "min(support_bottom_distance + layer_height, support_bottom_stair_step_height)",
                             "maximum_value_warning": "10",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": true
                         }
                     }
@@ -4636,7 +4747,7 @@
                     "minimum_value": "0",
                     "maximum_value_warning": "support_interface_height",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": true
                 },
                 "support_interface_density":
@@ -4649,7 +4760,7 @@
                     "minimum_value": "0",
                     "maximum_value_warning": "100",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
                     "children":
@@ -4664,7 +4775,7 @@
                             "minimum_value": "0",
                             "maximum_value": "100",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                             "value": "extruderValue(support_roof_extruder_nr, 'support_interface_density')",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true,
@@ -4681,7 +4792,7 @@
                                     "minimum_value_warning": "support_roof_line_width - 0.0001",
                                     "value": "0 if support_roof_density == 0 else (support_roof_line_width * 100) / support_roof_density * (2 if support_roof_pattern == 'grid' else (3 if support_roof_pattern == 'triangles' else 1))",
                                     "limit_to_extruder": "support_roof_extruder_nr",
-                                    "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                                    "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
                                 }
@@ -4697,7 +4808,7 @@
                             "minimum_value": "0",
                             "maximum_value": "100",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                             "value": "extruderValue(support_bottom_extruder_nr, 'support_interface_density')",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true,
@@ -4714,7 +4825,7 @@
                                     "minimum_value_warning": "support_bottom_line_width - 0.0001",
                                     "value": "0 if support_bottom_density == 0 else (support_bottom_line_width * 100) / support_bottom_density * (2 if support_bottom_pattern == 'grid' else (3 if support_bottom_pattern == 'triangles' else 1))",
                                     "limit_to_extruder": "support_bottom_extruder_nr",
-                                    "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                                    "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                                     "settable_per_mesh": false,
                                     "settable_per_extruder": true
                                 }
@@ -4737,7 +4848,7 @@
                     },
                     "default_value": "concentric",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
                     "children":
@@ -4758,7 +4869,7 @@
                             "default_value": "concentric",
                             "value": "extruderValue(support_roof_extruder_nr, 'support_interface_pattern')",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
                         },
@@ -4778,7 +4889,7 @@
                             "default_value": "concentric",
                             "value": "extruderValue(support_bottom_extruder_nr, 'support_interface_pattern')",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
                         }
@@ -4794,7 +4905,7 @@
                     "minimum_value": "0",
                     "minimum_value_warning": "minimum_support_area",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": true,
                     "children":
                     {
@@ -4809,7 +4920,7 @@
                             "minimum_value": "0",
                             "minimum_value_warning": "minimum_support_area",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": true
                         },
                         "minimum_bottom_area": 
@@ -4823,7 +4934,7 @@
                             "minimum_value": "0",
                             "minimum_value_warning": "minimum_support_area",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": true
                         }
                     }
@@ -4837,7 +4948,7 @@
                     "default_value": 0.0,
                     "maximum_value": "extruderValue(support_extruder_nr, 'support_offset')",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "support_interface_enable and (support_enable or support_tree_enable)",
+                    "enabled": "support_interface_enable and (support_enable or support_meshes_present)",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
                     "children":
@@ -4852,7 +4963,7 @@
                             "value": "extruderValue(support_roof_extruder_nr, 'support_interface_offset')",
                             "maximum_value": "extruderValue(support_extruder_nr, 'support_offset')",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "support_roof_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_roof_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
                         },
@@ -4866,7 +4977,7 @@
                             "value": "extruderValue(support_bottom_extruder_nr, 'support_interface_offset')",
                             "maximum_value": "extruderValue(support_extruder_nr, 'support_offset')",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "support_bottom_enable and (support_enable or support_tree_enable)",
+                            "enabled": "support_bottom_enable and (support_enable or support_meshes_present)",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
                         }
@@ -4879,7 +4990,7 @@
                     "type": "[int]",
                     "default_value": "[ ]",
                     "limit_to_extruder": "support_interface_extruder_nr",
-                    "enabled": "(support_enable or support_tree_enable) and support_interface_enable and support_interface_pattern != 'concentric'",
+                    "enabled": "(support_enable or support_meshes_present) and support_interface_enable and support_interface_pattern != 'concentric'",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
                     "children":
@@ -4892,7 +5003,7 @@
                             "default_value": "[ ]",
                             "value": "support_interface_angles",
                             "limit_to_extruder": "support_roof_extruder_nr",
-                            "enabled": "(support_enable or support_tree_enable) and support_roof_enable and support_roof_pattern != 'concentric'",
+                            "enabled": "(support_enable or support_meshes_present) and support_roof_enable and support_roof_pattern != 'concentric'",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
                         },
@@ -4904,7 +5015,7 @@
                             "default_value": "[ ]",
                             "value": "support_interface_angles",
                             "limit_to_extruder": "support_bottom_extruder_nr",
-                            "enabled": "(support_enable or support_tree_enable) and support_bottom_enable and support_bottom_pattern != 'concentric'",
+                            "enabled": "(support_enable or support_meshes_present) and support_bottom_enable and support_bottom_pattern != 'concentric'",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
                         }
@@ -4916,7 +5027,7 @@
                     "description": "When enabled, the print cooling fan speed is altered for the skin regions immediately above the support.",
                     "type": "bool",
                     "default_value": false,
-                    "enabled": "support_enable or support_tree_enable",
+                    "enabled": "support_enable or support_meshes_present",
                     "settable_per_mesh": false
                 },
                 "support_supported_skin_fan_speed":
@@ -4928,7 +5039,7 @@
                     "maximum_value": "100",
                     "default_value": 100,
                     "type": "float",
-                    "enabled": "(support_enable or support_tree_enable) and support_fan_enable",
+                    "enabled": "(support_enable or support_meshes_present) and support_fan_enable",
                     "settable_per_mesh": false
                 },
                 "support_use_towers":
@@ -4938,7 +5049,7 @@
                     "type": "bool",
                     "default_value": true,
                     "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_enable",
+                    "enabled": "support_enable and support_structure == 'normal'",
                     "settable_per_mesh": true
                 },
                 "support_tower_diameter":
@@ -4952,7 +5063,7 @@
                     "minimum_value": "0",
                     "minimum_value_warning": "2 * machine_nozzle_size",
                     "maximum_value_warning": "20",
-                    "enabled": "support_enable and support_use_towers",
+                    "enabled": "support_enable and support_structure == 'normal' and support_use_towers",
                     "settable_per_mesh": true
                 },
                 "support_tower_maximum_supported_diameter":
@@ -4967,7 +5078,7 @@
                     "minimum_value_warning": "2 * machine_nozzle_size",
                     "maximum_value_warning": "20",
                     "maximum_value": "support_tower_diameter",
-                    "enabled": "support_enable and support_use_towers",
+                    "enabled": "support_enable and support_structure == 'normal' and support_use_towers",
                     "settable_per_mesh": true
                 },
                 "support_tower_roof_angle":
@@ -4980,7 +5091,7 @@
                     "maximum_value": "90",
                     "default_value": 65,
                     "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_enable and support_use_towers",
+                    "enabled": "support_enable and support_structure == 'normal' and support_use_towers",
                     "settable_per_mesh": true
                 },
                 "support_mesh_drop_down":
@@ -4994,6 +5105,17 @@
                     "settable_per_extruder": false,
                     "settable_per_meshgroup": false,
                     "settable_globally": false
+                },
+                "support_meshes_present":
+                {
+                    "label": "Scene Has Support Meshes",
+                    "description": "There are support meshes present in the scene. This setting is controlled by Cura.",
+                    "type": "bool",
+                    "default_value": false,
+                    "enabled": false,
+                    "settable_per_mesh": false,
+                    "settable_per_extruder": false,
+                    "settable_per_meshgroup": false
                 }
             }
         },
@@ -5164,7 +5286,7 @@
                     "description": "Enforce brim to be printed around the model even if that space would otherwise be occupied by support. This replaces some regions of the first layer of support by brim regions.",
                     "type": "bool",
                     "default_value": true,
-                    "enabled": "resolveOrValue('adhesion_type') == 'brim' and (support_enable or support_tree_enable)",
+                    "enabled": "resolveOrValue('adhesion_type') == 'brim' and (support_enable or support_meshes_present)",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
                     "limit_to_extruder": "support_infill_extruder_nr"
@@ -5682,7 +5804,7 @@
                     "minimum_value": "0",
                     "maximum_value": "min(0.5 * machine_width, 0.5 * machine_depth)",
                     "minimum_value_warning": "max(extruderValues('prime_tower_line_width')) * 2",
-                    "maximum_value_warning": "20",
+                    "maximum_value_warning": "42",
                     "settable_per_mesh": false,
                     "settable_per_extruder": false
                 },
@@ -5948,7 +6070,7 @@
                     "description": "Remove empty layers beneath the first printed layer if they are present. Disabling this setting can cause empty first layers if the Slicing Tolerance setting is set to Exclusive or Middle.",
                     "type": "bool",
                     "default_value": true,
-                    "enabled": "not (support_enable or support_tree_enable)",
+                    "enabled": "not (support_enable or support_meshes_present)",
                     "settable_per_mesh": false,
                     "settable_per_extruder": false
                 },
@@ -5984,7 +6106,7 @@
                     "description": "The maximum deviation allowed when reducing the resolution for the Maximum Resolution setting. If you increase this, the print will be less accurate, but the g-code will be smaller. Maximum Deviation is a limit for Maximum Resolution, so if the two conflict the Maximum Deviation will always be held true.",
                     "type": "float",
                     "unit": "mm",
-                    "default_value": 0.05,
+                    "default_value": 0.025,
                     "minimum_value": "0.001",
                     "minimum_value_warning": "0.01",
                     "maximum_value_warning": "0.3",
@@ -6003,7 +6125,7 @@
                 "print_sequence":
                 {
                     "label": "Print Sequence",
-                    "description": "Whether to print all models one layer at a time or to wait for one model to finish, before moving on to the next. One at a time mode is possible if a) only one extruder is enabled and b) all models are separated in such a way that the whole print head can move in between and all models are lower than the distance between the nozzle and the X/Y axes. ",
+                    "description": "Whether to print all models one layer at a time or to wait for one model to finish, before moving on to the next. One at a time mode is possible if a) only one extruder is enabled and b) all models are separated in such a way that the whole print head can move in between and all models are lower than the distance between the nozzle and the X/Y axes.",
                     "type": "enum",
                     "options":
                     {
@@ -6029,8 +6151,8 @@
                 },
                 "infill_mesh_order":
                 {
-                    "label": "Infill Mesh Order",
-                    "description": "Determines which infill mesh is inside the infill of another infill mesh. An infill mesh with a higher order will modify the infill of infill meshes with lower order and normal meshes.",
+                    "label": "Mesh Processing Rank",
+                    "description": "Determines the priority of this mesh when considering overlapping volumes. Areas where multiple meshes reside will be won by the lower rank mesh. An infill mesh with a higher order will modify the infill of infill meshes with lower order and normal meshes.",
                     "default_value": 0,
                     "value": "1 if infill_mesh else 0",
                     "minimum_value_warning": "1",
@@ -6173,91 +6295,10 @@
             "description": "Features that haven't completely been fleshed out yet.",
             "children":
             {
-                "support_tree_enable":
-                {
-                    "label": "Tree Support",
-                    "description": "Generate a tree-like support with branches that support your print. This may reduce material usage and print time, but greatly increases slicing time.",
-                    "type": "bool",
-                    "default_value": false,
-                    "settable_per_mesh": true,
-                    "settable_per_extruder": false
-                },
-                "support_tree_angle":
-                {
-                    "label": "Tree Support Branch Angle",
-                    "description": "The angle of the branches. Use a lower angle to make them more vertical and more stable. Use a higher angle to be able to have more reach.",
-                    "unit": "°",
-                    "type": "float",
-                    "minimum_value": "0",
-                    "maximum_value": "90",
-                    "maximum_value_warning": "60",
-                    "default_value": 40,
-                    "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_tree_enable",
-                    "settable_per_mesh": false,
-                    "settable_per_extruder": true
-                },
-                "support_tree_branch_distance":
-                {
-                    "label": "Tree Support Branch Distance",
-                    "description": "How far apart the branches need to be when they touch the model. Making this distance small will cause the tree support to touch the model at more points, causing better overhang but making support harder to remove.",
-                    "unit": "mm",
-                    "type": "float",
-                    "minimum_value": "0.001",
-                    "default_value": 1,
-                    "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_tree_enable",
-                    "settable_per_mesh": true
-                },
-                "support_tree_branch_diameter":
-                {
-                    "label": "Tree Support Branch Diameter",
-                    "description": "The diameter of the thinnest branches of tree support. Thicker branches are more sturdy. Branches towards the base will be thicker than this.",
-                    "unit": "mm",
-                    "type": "float",
-                    "minimum_value": "0.001",
-                    "minimum_value_warning": "support_line_width * 2",
-                    "default_value": 2,
-                    "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_tree_enable",
-                    "settable_per_mesh": false,
-                    "settable_per_extruder": true
-                },
-                "support_tree_branch_diameter_angle":
-                {
-                    "label": "Tree Support Branch Diameter Angle",
-                    "description": "The angle of the branches' diameter as they gradually become thicker towards the bottom. An angle of 0 will cause the branches to have uniform thickness over their length. A bit of an angle can increase stability of the tree support.",
-                    "unit": "°",
-                    "type": "float",
-                    "minimum_value": "0",
-                    "maximum_value": "89.9999",
-                    "maximum_value_warning": "15",
-                    "default_value": 5,
-                    "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_tree_enable",
-                    "settable_per_mesh": false,
-                    "settable_per_extruder": true
-                },
-                "support_tree_collision_resolution":
-                {
-                    "label": "Tree Support Collision Resolution",
-                    "description": "Resolution to compute collisions with to avoid hitting the model. Setting this lower will produce more accurate trees that fail less often, but increases slicing time dramatically.",
-                    "unit": "mm",
-                    "type": "float",
-                    "minimum_value": "0.001",
-                    "minimum_value_warning": "support_line_width / 4",
-                    "maximum_value_warning": "support_line_width * 2",
-                    "default_value": 0.4,
-                    "value": "support_line_width / 2",
-                    "limit_to_extruder": "support_infill_extruder_nr",
-                    "enabled": "support_tree_enable and support_tree_branch_diameter_angle > 0",
-                    "settable_per_mesh": false,
-                    "settable_per_extruder": true
-                },
                 "slicing_tolerance":
                 {
                     "label": "Slicing Tolerance",
-                    "description": "How to slice layers with diagonal surfaces. The areas of a layer can be generated based on where the middle of the layer intersects the surface (Middle). Alternatively each layer can have the areas which fall inside of the volume throughout the height of the layer (Exclusive) or a layer has the areas which fall inside anywhere within the layer (Inclusive). Exclusive retains the most details, Inclusive makes for the best fit and Middle takes the least time to process.",
+                    "description": "Vertical tolerance in the sliced layers. The contours of a layer are normally generated by taking cross sections through the middle of each layer's thickness (Middle). Alternatively each layer can have the areas which fall inside of the volume throughout the entire thickness of the layer (Exclusive) or a layer has the areas which fall inside anywhere within the layer (Inclusive). Inclusive retains the most details, Exclusive makes for the best fit and Middle stays closest to the original surface.",
                     "type": "enum",
                     "options":
                     {
@@ -6360,7 +6401,7 @@
                     "description": "Skip some support line connections to make the support structure easier to break away. This setting is applicable to the Zig Zag support infill pattern.",
                     "type": "bool",
                     "default_value": false,
-                    "enabled": "support_enable and (support_pattern == 'zigzag')",
+                    "enabled": "(support_enable  or support_meshes_present) and support_pattern == 'zigzag'",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
@@ -6374,7 +6415,7 @@
                     "default_value": 20,
                     "minimum_value": "0",
                     "minimum_value_warning": "support_line_distance",
-                    "enabled": "support_enable and (support_pattern == 'zigzag') and support_skip_some_zags",
+                    "enabled": "(support_enable or support_meshes_present) and support_pattern == 'zigzag' and support_skip_some_zags",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": false,
                     "settable_per_extruder": true,
@@ -6389,7 +6430,7 @@
                             "value": "0 if support_line_distance == 0 else round(support_skip_zag_per_mm / support_line_distance)",
                             "minimum_value": "1",
                             "minimum_value_warning": "3",
-                            "enabled": "support_enable and (support_pattern == 'zigzag') and support_skip_some_zags",
+                            "enabled": "(support_enable or support_meshes_present) and support_pattern == 'zigzag' and support_skip_some_zags",
                             "limit_to_extruder": "support_infill_extruder_nr",
                             "settable_per_mesh": false,
                             "settable_per_extruder": true
@@ -6551,99 +6592,13 @@
                     "settable_per_mesh": false,
                     "settable_per_extruder": true
                 },
-                "spaghetti_infill_enabled":
-                {
-                    "label": "Spaghetti Infill",
-                    "description": "Print the infill every so often, so that the filament will curl up chaotically inside the object. This reduces print time, but the behaviour is rather unpredictable.",
-                    "type": "bool",
-                    "default_value": false,
-                    "enabled": "infill_sparse_density > 0",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
-                "spaghetti_infill_stepped":
-                {
-                    "label": "Spaghetti Infill Stepping",
-                    "description": "Whether to print spaghetti infill in steps or extrude all the infill filament at the end of the print.",
-                    "type": "bool",
-                    "default_value": true,
-                    "enabled": "infill_sparse_density > 0 and spaghetti_infill_enabled",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
-                "spaghetti_max_infill_angle":
-                {
-                    "label": "Spaghetti Maximum Infill Angle",
-                    "description": "The maximum angle w.r.t. the Z axis of the inside of the print for areas which are to be filled with spaghetti infill afterwards. Lowering this value causes more angled parts in your model to be filled on each layer.",
-                    "unit": "°",
-                    "type": "float",
-                    "default_value": 10,
-                    "minimum_value": "0",
-                    "maximum_value": "90",
-                    "maximum_value_warning": "45",
-                    "enabled": "infill_sparse_density > 0 and spaghetti_infill_enabled and spaghetti_infill_stepped",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
-                "spaghetti_max_height":
-                {
-                    "label": "Spaghetti Infill Maximum Height",
-                    "description": "The maximum height of inside space which can be combined and filled from the top.",
-                    "unit": "mm",
-                    "type": "float",
-                    "default_value": 2.0,
-                    "minimum_value": "layer_height",
-                    "maximum_value_warning": "10.0",
-                    "enabled": "infill_sparse_density > 0 and spaghetti_infill_enabled and spaghetti_infill_stepped",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
-                "spaghetti_inset":
-                {
-                    "label": "Spaghetti Inset",
-                    "description": "The offset from the walls from where the spaghetti infill will be printed.",
-                    "unit": "mm",
-                    "type": "float",
-                    "default_value": 0.2,
-                    "minimum_value_warning": "0",
-                    "maximum_value_warning": "5.0",
-                    "enabled": "infill_sparse_density > 0 and spaghetti_infill_enabled",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
-                "spaghetti_flow":
-                {
-                    "label": "Spaghetti Flow",
-                    "description": "Adjusts the density of the spaghetti infill. Note that the Infill Density only controls the line spacing of the filling pattern, not the amount of extrusion for spaghetti infill.",
-                    "unit": "%",
-                    "type": "float",
-                    "default_value": 20,
-                    "minimum_value": "0",
-                    "maximum_value_warning": "100",
-                    "enabled": "infill_sparse_density > 0 and spaghetti_infill_enabled",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
-                "spaghetti_infill_extra_volume":
-                {
-                    "label": "Spaghetti Infill Extra Volume",
-                    "description": "A correction term to adjust the total volume being extruded each time when filling spaghetti.",
-                    "unit": "mm³",
-                    "type": "float",
-                    "default_value": 0,
-                    "minimum_value_warning": "0",
-                    "maximum_value_warning": "100",
-                    "enabled": "infill_sparse_density > 0 and spaghetti_infill_enabled",
-                    "limit_to_extruder": "infill_extruder_nr",
-                    "settable_per_mesh": true
-                },
                 "support_conical_enabled":
                 {
                     "label": "Enable Conical Support",
                     "description": "Make support areas smaller at the bottom than at the overhang.",
                     "type": "bool",
                     "default_value": false,
-                    "enabled": "support_enable",
+                    "enabled": "support_enable and support_structure != 'tree'",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -6658,7 +6613,7 @@
                     "maximum_value_warning": "45",
                     "maximum_value": "90",
                     "default_value": 30,
-                    "enabled": "support_conical_enabled and support_enable",
+                    "enabled": "support_conical_enabled and support_enable and support_structure != 'tree'",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -6672,7 +6627,7 @@
                     "minimum_value_warning": "machine_nozzle_size * 3",
                     "maximum_value_warning": "100.0",
                     "type": "float",
-                    "enabled": "support_conical_enabled and support_enable and support_conical_angle > 0",
+                    "enabled": "support_conical_enabled and support_enable and support_structure != 'tree' and support_conical_angle > 0",
                     "limit_to_extruder": "support_infill_extruder_nr",
                     "settable_per_mesh": true
                 },
@@ -7198,6 +7153,7 @@
                     "description": "Detect bridges and modify print speed, flow and fan settings while bridges are printed.",
                     "type": "bool",
                     "default_value": false,
+                    "resolve": "any(extruderValues('bridge_settings_enabled'))",
                     "settable_per_mesh": true,
                     "settable_per_extruder": false,
                     "settable_per_meshgroup": false
diff -pruN 1:4.6.2-1/src/Application.cpp 1:4.7.1-1/src/Application.cpp
--- 1:4.6.2-1/src/Application.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/Application.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -140,7 +140,7 @@ void Application::printLicense() const
 {
     logAlways("\n");
     logAlways("Cura_SteamEngine version %s\n", VERSION);
-    logAlways("Copyright (C) 2019 Ultimaker\n");
+    logAlways("Copyright (C) 2020 Ultimaker\n");
     logAlways("\n");
     logAlways("This program is free software: you can redistribute it and/or modify\n");
     logAlways("it under the terms of the GNU Affero General Public License as published by\n");
diff -pruN 1:4.6.2-1/src/FanSpeedLayerTime.h 1:4.7.1-1/src/FanSpeedLayerTime.h
--- 1:4.6.2-1/src/FanSpeedLayerTime.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/FanSpeedLayerTime.h	2020-08-14 10:34:26.000000000 +0000
@@ -1,4 +1,4 @@
-//Copyright (c) 2018 Ultimaker B.V.
+//Copyright (c) 2020 Ultimaker B.V.
 //CuraEngine is released under the terms of the AGPLv3 or higher.
 
 #ifndef FAN_SPEED_LAYER_TIME_H
@@ -11,15 +11,62 @@
 namespace cura 
 {
 
+/*!
+ * A small struct to collate settings related to fan speed and cooling.
+ *
+ * This is similar to the PathConfig struct in its function. You can pass just
+ * a single one around and make it apply to all parts, rather than having to
+ * store these settings over and over again for each part, even though the
+ * settings may be different for each part on a layer.
+ */
 struct FanSpeedLayerTimeSettings 
 {
 public:
+    /*!
+     * Minimum layer time. How long should the layer get to cool down before the
+     * next layer is allowed to begin printing on it?
+     */
     Duration cool_min_layer_time;
+
+    /*!
+     * "Regular/Maximum Fan Speed Threshold". If the layers take longer to print
+     * than this, they'll use the regular fan speed. If they take shorter, we'll
+     * interpolate between regular and maximum fan speed.
+     */
     Duration cool_min_layer_time_fan_speed_max;
+
+    /*!
+     * Fan speed on the initial layer.
+     */
     double cool_fan_speed_0;
+
+    /*!
+     * Regular fan speed, used for most of the print, during layers longer than
+     * the Regular/Maximum Fan Speed Threshold.
+     */
     double cool_fan_speed_min;
+
+    /*!
+     * "Maximum Fan Speed", the fan speed when the minimum layer time is
+     * reached. As the layers get shorter and you're approaching the minimum
+     * layer time, the fan speed is linearly interpolated between the Minimum
+     * Layer Time and the Regular/Maximum Fan Speed Threshold, to approach the
+     * maximum fan speed.
+     */
     double cool_fan_speed_max;
+
+    /*!
+     * Minimum Speed. We'll slow down the print speed if we're at the minimum
+     * layer time, but only up to a point. If it needs to be slowed down too
+     * much, it would degrade the filament. So don't slow down below this value.
+     */
     Velocity cool_min_speed;
+
+    /*!
+     * For the initial layer fan speed we'll gradually increase the fan speed to
+     * the regular fan speed across a number of layers. This is that number of
+     * layers.
+     */
     LayerIndex cool_fan_full_layer;
 };
 
diff -pruN 1:4.6.2-1/src/FffGcodeWriter.cpp 1:4.7.1-1/src/FffGcodeWriter.cpp
--- 1:4.6.2-1/src/FffGcodeWriter.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/FffGcodeWriter.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -17,7 +17,6 @@
 #include "Slice.h"
 #include "wallOverlap.h"
 #include "communication/Communication.h" //To send layer view data.
-#include "infill/SpaghettiInfillPathGenerator.h"
 #include "progress/Progress.h"
 #include "utils/math.h"
 #include "utils/orderOptimizer.h"
@@ -343,7 +342,7 @@ unsigned int FffGcodeWriter::getStartExt
     size_t start_extruder_nr = mesh_group_settings.get<ExtruderTrain&>("adhesion_extruder_nr").extruder_nr;
     if (mesh_group_settings.get<EPlatformAdhesion>("adhesion_type") == EPlatformAdhesion::NONE)
     {
-        if ((mesh_group_settings.get<bool>("support_enable") || mesh_group_settings.get<bool>("support_tree_enable")) && mesh_group_settings.get<bool>("support_brim_enable"))
+        if (mesh_group_settings.get<bool>("support_enable") && mesh_group_settings.get<bool>("support_brim_enable"))
         {
             start_extruder_nr = mesh_group_settings.get<ExtruderTrain&>("support_infill_extruder_nr").extruder_nr;
         }
@@ -1028,13 +1027,14 @@ void FffGcodeWriter::processSkirtBrim(co
         start_close_to = gcode_layer.getLastPlannedPositionOrStartingPosition();
     }
 
+    Polygons first_skirt_brim;
     Polygons skirt_brim;
     // Plan parts that need to be printed first: for example, skirt needs to be printed before support-brim.
     for (size_t i_part = 0; i_part < original_skirt_brim.size(); ++i_part)
     {
         if (i_part < storage.skirt_brim_max_locked_part_order[extruder_nr])
         {
-            gcode_layer.addPolygon(original_skirt_brim[i_part], 0, gcode_layer.configs_storage.skirt_brim_config_per_extruder[extruder_nr]);
+            first_skirt_brim.add(original_skirt_brim[i_part]);
         }
         else
         {
@@ -1042,6 +1042,12 @@ void FffGcodeWriter::processSkirtBrim(co
         }
     }
 
+    if (!first_skirt_brim.empty())
+    {
+        gcode_layer.addTravel(first_skirt_brim.back().closestPointTo(start_close_to));
+        gcode_layer.addPolygonsByOptimizer(first_skirt_brim, gcode_layer.configs_storage.skirt_brim_config_per_extruder[extruder_nr]);
+    }
+
     if (skirt_brim.empty())
     {
         return;
@@ -1392,16 +1398,9 @@ bool FffGcodeWriter::processInfill(const
     {
         return false;
     }
-    if (mesh.settings.get<bool>("spaghetti_infill_enabled"))
-    {
-        return SpaghettiInfillPathGenerator::processSpaghettiInfill(storage, *this, gcode_layer, mesh, extruder_nr, mesh_config, part);
-    }
-    else
-    {
-        bool added_something = processMultiLayerInfill(storage, gcode_layer, mesh, extruder_nr, mesh_config, part);
-        added_something = added_something | processSingleLayerInfill(storage, gcode_layer, mesh, extruder_nr, mesh_config, part);
-        return added_something;
-    }
+    bool added_something = processMultiLayerInfill(storage, gcode_layer, mesh, extruder_nr, mesh_config, part);
+    added_something = added_something | processSingleLayerInfill(storage, gcode_layer, mesh, extruder_nr, mesh_config, part);
+    return added_something;
 }
 
 bool FffGcodeWriter::processMultiLayerInfill(const SliceDataStorage& storage, LayerPlan& gcode_layer, const SliceMeshStorage& mesh, const size_t extruder_nr, const PathConfigStorage::MeshPathConfigs& mesh_config, const SliceLayerPart& part) const
@@ -1792,7 +1791,7 @@ bool FffGcodeWriter::processInsets(const
             // if support is enabled, add the support outlines also so we don't generate bridges over support
 
             const Settings& mesh_group_settings = Application::getInstance().current_slice->scene.current_mesh_group->settings;
-            if (mesh_group_settings.get<bool>("support_enable") || mesh_group_settings.get<bool>("support_tree_enable"))
+            if (mesh_group_settings.get<bool>("support_enable"))
             {
                 const coord_t z_distance_top = mesh.settings.get<coord_t>("support_top_distance");
                 const size_t z_distance_top_layers = round_up_divide(z_distance_top, layer_height) + 1;
@@ -2197,7 +2196,7 @@ void FffGcodeWriter::processTopBottom(co
     int support_layer_nr = -1;
     const SupportLayer* support_layer = nullptr;
 
-    if (mesh_group_settings.get<bool>("support_enable") || mesh_group_settings.get<bool>("support_tree_enable"))
+    if (mesh_group_settings.get<bool>("support_enable"))
     {
         const coord_t layer_height = mesh_config.inset0_config.getLayerThickness();
         const coord_t z_distance_top = mesh.settings.get<coord_t>("support_top_distance");
diff -pruN 1:4.6.2-1/src/FffPolygonGenerator.cpp 1:4.7.1-1/src/FffPolygonGenerator.cpp
--- 1:4.6.2-1/src/FffPolygonGenerator.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/FffPolygonGenerator.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -1,4 +1,4 @@
-//Copyright (c) 2018 Ultimaker B.V.
+//Copyright (c) 2020 Ultimaker B.V.
 //CuraEngine is released under the terms of the AGPLv3 or higher.
 
 #include <algorithm>
@@ -32,7 +32,6 @@
 #include "infill/DensityProvider.h"
 #include "infill/ImageBasedDensityProvider.h"
 #include "infill/SierpinskiFillProvider.h"
-#include "infill/SpaghettiInfill.h"
 #include "infill/SubDivCube.h"
 #include "infill/UniformDensityProvider.h"
 #include "progress/Progress.h"
@@ -226,7 +225,7 @@ bool FffPolygonGenerator::sliceModel(Mes
         // Do not add and process support _modifier_ meshes further, and ONLY skip support _modifiers_. They have been
         // processed in AreaSupport::handleSupportModifierMesh(), but other helper meshes such as infill meshes are
         // processed in a later stage, except for support mesh itself, so an exception is made for that.
-        if (is_support_modifier && ! mesh.settings.get<bool>("support_mesh"))
+        if(is_support_modifier && !mesh.settings.get<bool>("support_mesh"))
         {
             storage.meshes.pop_back();
             continue;
@@ -722,54 +721,48 @@ void FffPolygonGenerator::processInfillM
 
 void FffPolygonGenerator::processDerivedWallsSkinInfill(SliceMeshStorage& mesh)
 {
-    // generate spaghetti infill filling areas and volumes
-    if (mesh.settings.get<bool>("spaghetti_infill_enabled"))
-    {
-        SpaghettiInfill::generateSpaghettiInfill(mesh);
+    if (mesh.settings.get<bool>("infill_support_enabled"))
+    {// create gradual infill areas
+        SkinInfillAreaComputation::generateInfillSupport(mesh);
     }
-    else
-    {
-        if (mesh.settings.get<bool>("infill_support_enabled"))
-        {// create gradual infill areas
-            SkinInfillAreaComputation::generateInfillSupport(mesh);
-        }
 
-        // create gradual infill areas
-        SkinInfillAreaComputation::generateGradualInfill(mesh);
+    // create gradual infill areas
+    SkinInfillAreaComputation::generateGradualInfill(mesh);
 
-        //SubDivCube Pre-compute Octree
-        if (mesh.settings.get<coord_t>("infill_line_distance") > 0
-            && mesh.settings.get<EFillMethod>("infill_pattern") == EFillMethod::CUBICSUBDIV)
+    //SubDivCube Pre-compute Octree
+    if (mesh.settings.get<coord_t>("infill_line_distance") > 0
+        && mesh.settings.get<EFillMethod>("infill_pattern") == EFillMethod::CUBICSUBDIV)
+    {
+        const Point3 mesh_middle = mesh.bounding_box.getMiddle();
+        const Point infill_origin(mesh_middle.x + mesh.settings.get<coord_t>("infill_offset_x"), mesh_middle.y + mesh.settings.get<coord_t>("infill_offset_y"));
+        SubDivCube::precomputeOctree(mesh, infill_origin);
+    }
+
+    // Pre-compute Cross Fractal
+    if (mesh.settings.get<coord_t>("infill_line_distance") > 0
+        && (mesh.settings.get<EFillMethod>("infill_pattern") == EFillMethod::CROSS
+            || mesh.settings.get<EFillMethod>("infill_pattern") == EFillMethod::CROSS_3D)
+    )
+    {
+        const std::string cross_subdivision_spec_image_file = mesh.settings.get<std::string>("cross_infill_density_image");
+        std::ifstream cross_fs(cross_subdivision_spec_image_file.c_str());
+        if (!cross_subdivision_spec_image_file.empty() && cross_fs.good())
         {
-            SubDivCube::precomputeOctree(mesh);
+            mesh.cross_fill_provider = new SierpinskiFillProvider(mesh.bounding_box, mesh.settings.get<coord_t>("infill_line_distance"), mesh.settings.get<coord_t>("infill_line_width"), cross_subdivision_spec_image_file);
         }
-
-        // Pre-compute Cross Fractal
-        if (mesh.settings.get<coord_t>("infill_line_distance") > 0
-            && (mesh.settings.get<EFillMethod>("infill_pattern") == EFillMethod::CROSS
-                || mesh.settings.get<EFillMethod>("infill_pattern") == EFillMethod::CROSS_3D)
-        )
+        else
         {
-            const std::string cross_subdisivion_spec_image_file = mesh.settings.get<std::string>("cross_infill_density_image");
-            std::ifstream cross_fs(cross_subdisivion_spec_image_file.c_str());
-            if (cross_subdisivion_spec_image_file != "" && cross_fs.good())
+            if (!cross_subdivision_spec_image_file.empty() && cross_subdivision_spec_image_file != " ")
             {
-                mesh.cross_fill_provider = new SierpinskiFillProvider(mesh.bounding_box, mesh.settings.get<coord_t>("infill_line_distance"), mesh.settings.get<coord_t>("infill_line_width"), cross_subdisivion_spec_image_file);
-            }
-            else
-            {
-                if (cross_subdisivion_spec_image_file != "" && cross_subdisivion_spec_image_file != " ")
-                {
-                    logError("Cannot find density image \'%s\'.", cross_subdisivion_spec_image_file.c_str());
-                }
-                mesh.cross_fill_provider = new SierpinskiFillProvider(mesh.bounding_box, mesh.settings.get<coord_t>("infill_line_distance"), mesh.settings.get<coord_t>("infill_line_width"));
+                logError("Cannot find density image \'%s\'.", cross_subdivision_spec_image_file.c_str());
             }
+            mesh.cross_fill_provider = new SierpinskiFillProvider(mesh.bounding_box, mesh.settings.get<coord_t>("infill_line_distance"), mesh.settings.get<coord_t>("infill_line_width"));
         }
-
-        // combine infill
-        SkinInfillAreaComputation::combineInfillLayers(mesh);
     }
 
+    // combine infill
+    SkinInfillAreaComputation::combineInfillLayers(mesh);
+
     // fuzzy skin
     if (mesh.settings.get<bool>("magic_fuzzy_skin_enabled"))
     {
@@ -835,7 +828,7 @@ bool FffPolygonGenerator::isEmptyLayer(S
 
 void FffPolygonGenerator::removeEmptyFirstLayers(SliceDataStorage& storage, size_t& total_layers)
 {
-    int n_empty_first_layers = 0;
+    size_t n_empty_first_layers = 0;
     for (size_t layer_idx = 0; layer_idx < total_layers; layer_idx++)
     {
         if (isEmptyLayer(storage, layer_idx))
@@ -854,6 +847,11 @@ void FffPolygonGenerator::removeEmptyFir
         for (SliceMeshStorage& mesh : storage.meshes)
         {
             std::vector<SliceLayer>& layers = mesh.layers;
+            if (layers.size() > n_empty_first_layers)
+            {
+                // transfer initial layer thickness to new initial layer
+                layers[n_empty_first_layers].thickness = layers[0].thickness;
+            }
             layers.erase(layers.begin(), layers.begin() + n_empty_first_layers);
             for (SliceLayer& layer : layers)
             {
@@ -1018,8 +1016,18 @@ void FffPolygonGenerator::processDraftSh
         draft_shield = draft_shield.unionPolygons(storage.getLayerOutlines(layer_nr, around_support, around_prime_tower));
     }
 
-    const int draft_shield_dist = mesh_group_settings.get<coord_t>("draft_shield_dist");
+    const coord_t draft_shield_dist = mesh_group_settings.get<coord_t>("draft_shield_dist");
     storage.draft_protection_shield = draft_shield.approxConvexHull(draft_shield_dist);
+
+    //Extra offset has rounded joints, so simplify again.
+    coord_t maximum_resolution = 0; //Draft shield is printed with every extruder, so resolve with the max() or min() of them to meet the requirements of all extruders.
+    coord_t maximum_deviation = std::numeric_limits<coord_t>::max();
+    for(const ExtruderTrain& extruder : Application::getInstance().current_slice->scene.extruders)
+    {
+        maximum_resolution = std::max(maximum_resolution, extruder.settings.get<coord_t>("meshfix_maximum_resolution"));
+        maximum_deviation = std::min(maximum_deviation, extruder.settings.get<coord_t>("meshfix_maximum_deviation"));
+    }
+    storage.draft_protection_shield.simplify(maximum_resolution, maximum_deviation);
 }
 
 void FffPolygonGenerator::processPlatformAdhesion(SliceDataStorage& storage)
diff -pruN 1:4.6.2-1/src/gcodeExport.cpp 1:4.7.1-1/src/gcodeExport.cpp
--- 1:4.6.2-1/src/gcodeExport.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/gcodeExport.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -95,6 +95,7 @@ void GCodeExport::preSetup(const size_t
     machine_buildplate_type = mesh_group->settings.get<std::string>("machine_buildplate_type");
 
     relative_extrusion = mesh_group->settings.get<bool>("relative_extrusion");
+    always_write_active_tool = mesh_group->settings.get<bool>("machine_always_write_active_tool");
 
     if (flavor == EGCodeFlavor::BFB)
     {
@@ -1201,7 +1202,12 @@ void GCodeExport::writeTemperatureComman
         {
             if (extruder_nr != extruder)
             {
-                extruder_attr[extruder_nr].waited_for_temperature = wait;
+                // only reset the other extruders' waited_for_temperature state when the new temperature
+                // is greater than the old temperature
+                if (wait || temperature > extruder_attr[extruder_nr].currentTemperature)
+                {
+                    extruder_attr[extruder_nr].waited_for_temperature = wait;
+                }
                 extruder_attr[extruder_nr].currentTemperature = temperature;
             }
         }
@@ -1234,6 +1240,11 @@ void GCodeExport::writeTemperatureComman
     assert(temperature >= 0);
 #endif // ASSERT_INSANE_OUTPUT
     *output_stream << " S" << PrecisionedDouble{1, temperature} << new_line;
+    if (extruder != current_extruder && always_write_active_tool)
+    {
+        //Some firmwares (ie Smoothieware) change tools every time a "T" command is read - even on a M104 line, so we need to switch back to the active tool.
+        *output_stream << "T" << current_extruder << new_line;
+    }
     if (wait && flavor == EGCodeFlavor::MAKERBOT)
     {
         //Makerbot doesn't use M109 for heat-and-wait. Instead, use M104 and then wait using M116.
@@ -1364,7 +1375,7 @@ void GCodeExport::finalize(const char* e
     int64_t print_time = getSumTotalPrintTimes();
     int mat_0 = getTotalFilamentUsed(0);
     log("Print time (s): %d\n", print_time);
-    log("Print time (hr|min|s): %dh %dm %ds\n", print_time / 60 / 60, (print_time / 60) % 60, print_time % 60);
+    log("Print time (hr|min|s): %dh %dm %ds\n", int(print_time / 60 / 60), int((print_time / 60) % 60), int(print_time % 60));
     log("Filament (mm^3): %d\n", mat_0);
     for(int n=1; n<MAX_EXTRUDERS; n++)
         if (getTotalFilamentUsed(n) > 0)
diff -pruN 1:4.6.2-1/src/gcodeExport.h 1:4.7.1-1/src/gcodeExport.h
--- 1:4.6.2-1/src/gcodeExport.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/gcodeExport.h	2020-08-14 10:34:26.000000000 +0000
@@ -151,6 +151,7 @@ private:
 
     bool is_volumetric;
     bool relative_extrusion; //!< whether to use relative extrusion distances rather than absolute
+    bool always_write_active_tool; //!< whether to write the active tool after sending commands to inactive tool
 
     Temperature initial_bed_temp; //!< bed temperature at the beginning of the print.
     Temperature build_volume_temperature;  //!< build volume temperature
diff -pruN 1:4.6.2-1/src/infill/SpaghettiInfill.cpp 1:4.7.1-1/src/infill/SpaghettiInfill.cpp
--- 1:4.6.2-1/src/infill/SpaghettiInfill.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill/SpaghettiInfill.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,219 +0,0 @@
-//Copyright (c) 2018 Ultimaker B.V.
-//CuraEngine is released under the terms of the AGPLv3 or higher.
-
-#include "SpaghettiInfill.h"
-#include "../sliceDataStorage.h"
-#include "../settings/types/AngleDegrees.h" //For the infill angle.
-#include "../settings/types/AngleRadians.h" //For the infill angle.
-#include "../utils/logoutput.h"
-
-namespace cura {
-
-void SpaghettiInfill::generateTotalSpaghettiInfill(SliceMeshStorage& mesh)
-{
-    double total_volume_mm3 = 0.0;
-
-    const int max_layer = mesh.layers.size() - 1 - mesh.settings.get<size_t>("top_layers");
-    for (int layer_idx = 0; layer_idx <= max_layer; layer_idx++)
-    {
-        const coord_t layer_height = (layer_idx == 0) ? mesh.settings.get<coord_t>("layer_height_0") : mesh.settings.get<coord_t>("layer_height");
-        if (layer_idx < static_cast<LayerIndex>(mesh.settings.get<size_t>("bottom_layers"))
-            && layer_idx < static_cast<LayerIndex>(mesh.settings.get<size_t>("initial_bottom_layers")))
-        { // nothing to add
-            continue;
-        }
-        const SliceLayer& layer = mesh.layers[layer_idx];
-        for (const SliceLayerPart& slice_layer_part : layer.parts)
-        {
-            const Polygons& part_infill = slice_layer_part.getOwnInfillArea();
-            total_volume_mm3 += INT2MM(INT2MM(part_infill.area())) * INT2MM(layer_height);
-        }
-    }
-
-    // find top most filling area
-    SliceLayerPart* top_filling_layer_part = nullptr;
-    for (int layer_idx = mesh.layers.size() - 1; layer_idx >= 0; layer_idx--)
-    {
-        SliceLayer& layer = mesh.layers[layer_idx];
-        for (SliceLayerPart& part : layer.parts)
-        {
-            if (part.getOwnInfillArea().size() > 0)
-            { // WARNING: we just use the very first part we encounter; there's no way for the user to choose which filling area will be used
-                top_filling_layer_part = &part;
-                break;
-            }
-        }
-        if (top_filling_layer_part)
-        {
-            break; // it's already found
-        }
-    }
-
-    if (!top_filling_layer_part)
-    { // there is no infill in the whole mesh!
-        logError("Spaghetti Infill mesh doesn't have any volume!\n");
-        return;
-    }
-    assert(top_filling_layer_part->getOwnInfillArea().size() > 0);
-    const PolygonsPart top_infill_part = top_filling_layer_part->getOwnInfillArea().splitIntoParts()[0]; // WARNING: we just use the very first part we encounter; there's no way for the user to choose which filling area will be used
-
-    const coord_t filling_area_inset = mesh.settings.get<coord_t>("spaghetti_inset");
-    const coord_t line_width = mesh.settings.get<coord_t>("infill_line_width");
-    const Polygons filling_area = SpaghettiInfill::getFillingArea(top_infill_part, filling_area_inset, line_width);
-
-    // add total volume spaghetti infill to top of print
-    top_filling_layer_part->spaghetti_infill_volumes.emplace_back(filling_area, total_volume_mm3);
-}
-
-void SpaghettiInfill::generateSpaghettiInfill(SliceMeshStorage& mesh)
-{
-    const bool total_volume_at_once = !mesh.settings.get<bool>("spaghetti_infill_stepped");
-
-    if (total_volume_at_once)
-    {
-        generateTotalSpaghettiInfill(mesh);
-        return;
-    }
-
-    const coord_t line_width = mesh.settings.get<coord_t>("infill_line_width");
-    coord_t spaghetti_max_height = mesh.settings.get<coord_t>("spaghetti_max_height");
-
-    const coord_t filling_area_inset = mesh.settings.get<coord_t>("spaghetti_inset");
-
-    std::list<SpaghettiInfill::InfillPillar> pillar_base;
-    coord_t current_z = 0;
-
-    LayerIndex max_layer = mesh.layers.size() - 1 - mesh.settings.get<size_t>("top_layers");
-    for (LayerIndex layer_idx = 0; layer_idx <= max_layer; layer_idx++) //Skip every few layers, but extrude more.
-    {
-        const coord_t layer_height = (layer_idx == 0) ? mesh.settings.get<coord_t>("layer_height_0") : mesh.settings.get<coord_t>("layer_height");
-        current_z += layer_height;
-        if (layer_idx < static_cast<LayerIndex>(mesh.settings.get<size_t>("bottom_layers"))
-            && layer_idx < static_cast<LayerIndex>(mesh.settings.get<size_t>("initial_bottom_layers")))
-        { // nothing to add to pillar base
-            continue;
-        }
-        SliceLayer& layer = mesh.layers[layer_idx];
-
-        // add infill parts to pillar_base
-        for (SliceLayerPart& slice_layer_part : layer.parts)
-        {
-            std::vector<PolygonsPart> part_infill_parts = slice_layer_part.getOwnInfillArea().splitIntoParts();
-
-            // add parts to pillar_base
-            for (PolygonsPart& infill_part : part_infill_parts)
-            {
-                coord_t bottom_z = current_z - layer_height;
-                SpaghettiInfill::InfillPillar& pillar = addPartToPillarBase(mesh, infill_part, pillar_base, layer_height, bottom_z);
-                pillar.top_slice_layer_part = &slice_layer_part;
-                pillar.last_layer_added = layer_idx;
-            }
-        }
-
-
-        // handle finished pillars
-        for (auto pillar_it = pillar_base.begin(); pillar_it != pillar_base.end();)
-        {
-            InfillPillar& pillar = *pillar_it;
-            if (current_z - pillar.bottom_z >= spaghetti_max_height
-                || pillar.last_layer_added < layer_idx
-            )
-            {
-                pillar.addToTopSliceLayerPart(filling_area_inset, line_width);
-                auto to_be_erased = pillar_it;
-                ++pillar_it;
-                pillar_base.erase(to_be_erased);
-            }
-            else
-            {
-                ++pillar_it;
-            }
-        }
-    }
-    // handle unfinished pillars
-    for (auto it = pillar_base.begin(); it != pillar_base.end(); ++it)
-    {
-        it->addToTopSliceLayerPart(filling_area_inset, line_width);
-    }
-}
-
-Polygons SpaghettiInfill::getFillingArea(const PolygonsPart& infill_area, const coord_t filling_area_inset, const coord_t line_width)
-{
-    Polygons filling_area = infill_area.offset(-filling_area_inset);
-    assert(infill_area.size() > 0 && infill_area[0].size() > 0 && "the top part must be a non-zero area!");
-    if (filling_area.size() == 0)
-    {
-        AABB aabb(infill_area);
-        Point inside = (aabb.min + aabb.max) / 2;
-        PolygonUtils::moveInside(infill_area, inside);
-
-        filling_area = PolygonsPart();
-        PolygonRef poly = filling_area.newPoly();
-        poly.emplace_back(inside + Point(-line_width / 2 - 10, line_width / 2 + 10));
-        poly.emplace_back(inside + Point(line_width / 2 + 10, line_width / 2 + 10));
-        poly.emplace_back(inside + Point(line_width / 2 + 10, -line_width / 2 - 10));
-        poly.emplace_back(inside + Point(-line_width / 2 - 10, -line_width / 2 - 10));
-    }
-    return filling_area;
-}
-
-SpaghettiInfill::InfillPillar::InfillPillar(const SliceMeshStorage& mesh, const PolygonsPart& _top_part, const coord_t layer_height, const coord_t bottom_z)
-: top_part(_top_part) // TODO: prevent copy construction! Is that possible?
-, total_volume_mm3(INT2MM(INT2MM(top_part.area())) * INT2MM(layer_height))
-, connection_inset_dist(mesh.settings.get<AngleDegrees>("spaghetti_max_infill_angle") >= 90 ? MM2INT(500) : (tan(mesh.settings.get<AngleRadians>("spaghetti_max_infill_angle")) * mesh.settings.get<coord_t>("layer_height")))
-, bottom_z(bottom_z)
-{
-}
-
-void SpaghettiInfill::InfillPillar::addToTopSliceLayerPart(const coord_t filling_area_inset, const coord_t line_width)
-{
-    SliceLayerPart& slice_layer_part = *top_slice_layer_part;
-    double volume = total_volume_mm3;
-    assert(volume > 0.0);
-
-    // get filling area
-    Polygons filling_area = SpaghettiInfill::getFillingArea(top_part, filling_area_inset, line_width);
-    slice_layer_part.spaghetti_infill_volumes.emplace_back(filling_area, volume);
-}
-
-bool SpaghettiInfill::InfillPillar::isConnected(const PolygonsPart& infill_part) const
-{
-    Polygons insetted = infill_part.offset(-connection_inset_dist);
-    if (insetted.intersection(top_part).size() > 0)
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
-}
-
-SpaghettiInfill::InfillPillar& SpaghettiInfill::addPartToPillarBase(const SliceMeshStorage& mesh, const PolygonsPart& infill_part, std::list<SpaghettiInfill::InfillPillar>& pillar_base, const coord_t layer_height, const coord_t bottom_z)
-{
-    std::list<SpaghettiInfill::InfillPillar>::iterator ret = pillar_base.end();
-    for (auto it = pillar_base.begin(); it != pillar_base.end(); ++it)
-    {
-        InfillPillar& pillar = *it;
-        if (pillar.isConnected(infill_part))
-        {
-            pillar.total_volume_mm3 += INT2MM(INT2MM(infill_part.area())) * INT2MM(layer_height);
-            pillar.top_part = infill_part;
-            if (ret != pillar_base.end())
-            { // connecting two pillars of the layer below via one area on this layer
-                pillar.total_volume_mm3 += ret->total_volume_mm3;
-                pillar_base.erase(ret);
-            }
-            ret = it;
-        }
-    }
-    if (ret == pillar_base.end())
-    { // couldn't connect to any existing pillar
-        pillar_base.emplace_back(mesh, infill_part, layer_height, bottom_z);
-        return pillar_base.back();
-    }
-    return *ret;
-}
-
-
-}//namespace cura
diff -pruN 1:4.6.2-1/src/infill/SpaghettiInfill.h 1:4.7.1-1/src/infill/SpaghettiInfill.h
--- 1:4.6.2-1/src/infill/SpaghettiInfill.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill/SpaghettiInfill.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,116 +0,0 @@
-//Copyright (c) 2018 Ultimaker B.V.
-//CuraEngine is released under the terms of the AGPLv3 or higher.
-
-#ifndef INFILL_SPAGHETTI_INFILL_H
-#define INFILL_SPAGHETTI_INFILL_H
-
-#include <list>
-#include "../settings/types/LayerIndex.h"
-#include "../utils/polygon.h"
-
-namespace cura
-{
-
-class SliceLayerPart;
-class SliceMeshStorage;
-
-/*!
- * Spaghetti infill is a type of infill which fills every so many layers, but extrudes as much filament corresponding to the total unfilled volume under the filling area.
- * 
- * A filling layer is inserted when a a pillar of infill areas is becoming too high, or when the angle between the filling areas is too shallow.
- * 
- * The filling area might be smaller than the actual infill area, so that we fill the pillar from a smaller top area.
- * 
- * Infill pillars can join each other if they are connected on the top. The total volume will then be extruded from the top.
- * 
- * Where the model spits into two from bottom to top, one of the top pieces will be connected to the lower part as one big pillar, while a new pillar will be generated for the other top part.
- * Which part the base will be connected to is arbitrary.
- * 
- */
-class SpaghettiInfill
-{
-public:
-    /*!
-     * Generate the filling areas and corresponding volume to extrude over such areas for spaghetti infill.
-     */
-    static void generateSpaghettiInfill(SliceMeshStorage& mesh);
-
-protected:
-    /*!
-     * Generate spaghetti infill for the total volume of the mesh,
-     * extrude all filament from the top of the print.
-     * 
-     * \param mesh The mesh for which to generate spaghetti infill
-     */
-    static void generateTotalSpaghettiInfill(SliceMeshStorage& mesh);
-
-    class InfillPillar
-    {
-    public:
-        SliceLayerPart* top_slice_layer_part = nullptr; //!< A reference to the slice_layer_part from which the top part is generated
-        PolygonsPart top_part; //!< The top area of this pillar
-        double total_volume_mm3; //!< The total volume of the pillar
-        const coord_t connection_inset_dist; //!< Horizontal component of the spaghetti_max_infill_angle: the distance insetted corresponding to the maximum angle which can be filled by spaghetti infill.
-        const coord_t bottom_z; //!< The z coordinate of the bottom of the first layer this pillar is present in
-        LayerIndex last_layer_added = -1; //!< The last layer from which areas got added to this pillar
-
-        /*!
-         * Basic constructor of a pillar from a single area, which is to be the top of the new pillar
-         * 
-         * \param mesh The mesh that this infill belongs to.
-         * \param _top_part The area which is the base and the top of the new pillar
-         * \param layer_height The layer height of the layer which contains the \p _top_part
-         * \param bottom_z The z coordinate of the bottom of layer which contains \p _top_part
-         */
-        InfillPillar(const SliceMeshStorage& mesh, const PolygonsPart& _top_part, const coord_t layer_height, const coord_t bottom_z);
-
-        /*!
-         * Check whether the top of this pillar is connected (enough) to the given \p infill_part.
-         * It is assumed the infill_part is on the layer directly above the top part of this pillar.
-         * 
-         * \param infill_part The part to check for connectivity
-         * \return Whether the infill part can be incorporated in this pillar
-         */
-        bool isConnected(const PolygonsPart& infill_part) const;
-
-        /*!
-         * Register the volume of this infill pillar in the sliceDataStorage.
-         * The filling area and the volume are saved in \ref SliceLayerPart::spaghetti_infill_volumes
-         * 
-         * Note that the filling area is different from the infill area, because the spaghetti can curl toward the sides.
-         * 
-         * \param filling_area_inset The inset from the boundary of the walls to get from the infill area to the filling area
-         * \param line_width The line width used to generate an area just large enough for infill lines to be generated, when the infill area would otherwise be too small to get infill
-         */
-        void addToTopSliceLayerPart(const coord_t filling_area_inset, const coord_t line_width);
-    };
-
-    /*!
-     * Compute the area within which to generate the spaghetti infill.
-     * 
-     * \param infill_area The area of normal infill
-     * \param fill_area_inset The distance between the normal infill and the spaghetti infill area
-     * \param line_width The line width of the infill lines
-     * \return The offsetted area, or a generated area as small as possible
-     */
-    static Polygons getFillingArea(const PolygonsPart& infill_area, const coord_t filling_area_inset, const coord_t line_width);
-private:
-    /*!
-     * Add an area to the pillar base:
-     * - add it to an existing pillar if possible
-     * - otherwise create a new pillar for this area
-     * The pillar to which the area was added is returned
-     *
-     * \param mesh The mesh that the infill belongs to.
-     * \param infill_part The area to add to the base
-     * \param pillar_base The collection of pillars used up till the current layer
-     * \param connection_inset_dist The distance insetted corresponding to the maximum angle which can be filled by spaghetti infill
-     * \param layer_height The layer height of the added area
-     * \param bottom_z The z coordinate of the bottom of the layer which contains the \p infill_part
-     */
-    static InfillPillar& addPartToPillarBase(const SliceMeshStorage& mesh, const PolygonsPart& infill_part, std::list<InfillPillar>& pillar_base, const coord_t layer_height, const coord_t bottom_z);
-};
-
-}//namespace cura
-
-#endif//INFILL_SPAGHETTI_INFILL_H
diff -pruN 1:4.6.2-1/src/infill/SpaghettiInfillPathGenerator.cpp 1:4.7.1-1/src/infill/SpaghettiInfillPathGenerator.cpp
--- 1:4.6.2-1/src/infill/SpaghettiInfillPathGenerator.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill/SpaghettiInfillPathGenerator.cpp	1970-01-01 00:00:00.000000000 +0000
@@ -1,114 +0,0 @@
-//Copyright (c) 2018 Ultimaker B.V.
-//CuraEngine is released under the terms of the AGPLv3 or higher.
-
-#include "SpaghettiInfillPathGenerator.h"
-#include "../ExtruderTrain.h"
-#include "../FffGcodeWriter.h"
-#include "../infill.h"
-#include "../LayerPlan.h"
-#include "../sliceDataStorage.h"
-#include "../utils/math.h" //For round_divide.
-
-namespace cura {
-
-
-bool SpaghettiInfillPathGenerator::processSpaghettiInfill(const SliceDataStorage& storage, const FffGcodeWriter& fff_gcode_writer, LayerPlan& gcode_layer, const SliceMeshStorage& mesh, const size_t extruder_nr, const PathConfigStorage::MeshPathConfigs& mesh_config, const SliceLayerPart& part)
-{
-    if (extruder_nr != mesh.settings.get<ExtruderTrain&>("infill_extruder_nr").extruder_nr)
-    {
-        return false;
-    }
-    bool added_something = false;
-    const GCodePathConfig& config = mesh_config.infill_config[0];
-    const EFillMethod pattern = mesh.settings.get<EFillMethod>("infill_pattern");
-    const bool zig_zaggify_infill = mesh.settings.get<bool>("zig_zaggify_infill");
-    const coord_t infill_overlap = mesh.settings.get<coord_t>("infill_overlap_mm");
-    const coord_t infill_line_distance = mesh.settings.get<coord_t>("infill_line_distance");
-    const bool connect_polygons = true; //Spaghetti infill should have as few as possible travel moves.
-    const unsigned int infill_line_width = config.getLineWidth();
-    constexpr int infill_multiplier = 1;
-    const int64_t infill_shift = 0;
-    constexpr int wall_line_count = 0;
-    const int64_t outline_offset = 0;
-    const double layer_height_mm = (gcode_layer.getLayerNr() == 0) ? mesh.settings.get<double>("layer_height_0") : mesh.settings.get<double>("layer_height");
-    AngleDegrees infill_angle = 45; //Original default. This will get updated to an element from mesh->infill_angles.
-    if (mesh.infill_angles.size() > 0)
-    {
-        const size_t combined_infill_layers = std::max(unsigned(1), round_divide(mesh.settings.get<coord_t>("infill_sparse_thickness"), std::max(mesh.settings.get<coord_t>("layer_height"), coord_t(1))));
-        infill_angle = mesh.infill_angles.at((gcode_layer.getLayerNr() / combined_infill_layers) % mesh.infill_angles.size());
-    }
-    const Point3 mesh_middle = mesh.bounding_box.getMiddle();
-    const Point infill_origin(mesh_middle.x + mesh.settings.get<coord_t>("infill_offset_x"), mesh_middle.y + mesh.settings.get<coord_t>("infill_offset_y"));
-
-    // For each part on this layer which is used to fill that part and parts below:
-    for (const std::pair<Polygons, double>& filling_area : part.spaghetti_infill_volumes)
-    {
-        Polygons infill_lines;
-        Polygons infill_polygons;
-
-        const Polygons& area = filling_area.first; // Area of the top within which to move while extruding (might be empty if the spaghetti_inset was too large)
-        const double total_volume = filling_area.second * mesh.settings.get<Ratio>("spaghetti_flow") + mesh.settings.get<double>("spaghetti_infill_extra_volume"); // volume to be extruded
-        if (total_volume <= 0.0)
-        {
-            continue;
-        }
-
-        // generate zigzag print head paths
-        Polygons* perimeter_gaps_output = nullptr;
-        const bool connected_zigzags = true;
-        const bool use_endpieces = false;
-        Infill infill_comp(pattern, zig_zaggify_infill, connect_polygons, area, outline_offset
-            , infill_line_width, infill_line_distance, infill_overlap, infill_multiplier, infill_angle, gcode_layer.z,
-            infill_shift, wall_line_count, infill_origin, perimeter_gaps_output, connected_zigzags, use_endpieces
-            , mesh.settings.get<coord_t>("cross_infill_pocket_size"));
-        // cross_fill_patterns is only generated when spaghetti infill is not used,
-        // so we pass nullptr here.
-        infill_comp.generate(infill_polygons, infill_lines, nullptr, &mesh);
-
-        // add paths to plan with a higher flow ratio in order to extrude the required amount.
-        const coord_t total_length = infill_polygons.polygonLength() + infill_lines.polyLineLength();
-        if (total_length > 0)
-        { // zigzag path generation actually generated paths
-            // calculate the normal volume extruded when using the layer height and line width to calculate extrusion
-            const double normal_volume = INT2MM(INT2MM(total_length * infill_line_width)) * layer_height_mm;
-            assert(normal_volume > 0.0);
-            const float flow_ratio = total_volume / normal_volume;
-            assert(flow_ratio / mesh.settings.get<Ratio>("spaghetti_flow") >= 0.9);
-            assert(!std::isnan(flow_ratio) && !std::isinf(flow_ratio));
-
-            if (!infill_polygons.empty() || !infill_lines.empty())
-            {
-                added_something = true;
-                fff_gcode_writer.setExtruder_addPrime(storage, gcode_layer, extruder_nr);
-                if (!infill_polygons.empty())
-                {
-                    constexpr bool force_comb_retract = false;
-                    gcode_layer.addTravel(infill_polygons[0][0], force_comb_retract);
-                    gcode_layer.addPolygonsByOptimizer(infill_polygons, config, nullptr, ZSeamConfig(), 0, false, flow_ratio);
-                }
-                const bool is_zigzag = mesh.settings.get<bool>("zig_zaggify_infill") || pattern == EFillMethod::ZIG_ZAG;
-                const coord_t wipe_dist = is_zigzag ? 0 : -mesh.settings.get<coord_t>("infill_wipe_dist");
-                const SpaceFillType line_type = is_zigzag ? SpaceFillType::Lines : SpaceFillType::PolyLines;
-                gcode_layer.addLinesByOptimizer(infill_lines, config, line_type, false, wipe_dist, flow_ratio);
-            }
-        }
-        else
-        { // zigzag path generation couldn't generate paths, probably because the area was too small
-            // generate small path near the middle of the filling area
-            // note that we need a path with positive length because that is currently the only way to insert an extrusion in a layer plan
-            constexpr int path_length = 10;
-            Point middle = AABB(area).getMiddle();
-            if (!area.inside(middle))
-            {
-                PolygonUtils::ensureInsideOrOutside(area, middle, infill_line_width / 2);
-            }
-            const double normal_volume = INT2MM(INT2MM(path_length * infill_line_width)) * layer_height_mm;
-            const float flow_ratio = total_volume / normal_volume;
-            gcode_layer.addTravel(middle);
-            gcode_layer.addExtrusionMove(middle + Point(0, path_length), config, SpaceFillType::Lines, flow_ratio);
-        }
-    }
-    return added_something;
-}
-
-}//namespace cura
diff -pruN 1:4.6.2-1/src/infill/SpaghettiInfillPathGenerator.h 1:4.7.1-1/src/infill/SpaghettiInfillPathGenerator.h
--- 1:4.6.2-1/src/infill/SpaghettiInfillPathGenerator.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill/SpaghettiInfillPathGenerator.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,59 +0,0 @@
-//Copyright (c) 2018 Ultimaker B.V.
-//CuraEngine is released under the terms of the AGPLv3 or higher.
-
-#ifndef INFILL_SPAGHETTI_INFILL_PATH_GENERATOR_H
-#define INFILL_SPAGHETTI_INFILL_PATH_GENERATOR_H
-
-#include <list>
-#include "../settings/PathConfigStorage.h" //For the MeshPathConfigs subclass.
-
-namespace cura
-{
-
-class FffGcodeWriter;
-class LayerPlan;
-class SliceDataStorage;
-class SliceLayerPart;
-class SliceMeshStorage;
-
-/*!
- * Spaghetti infill is a type of infill which fills every so many layers, but extrudes as much filament corresponding to the total unfilled volume under the filling area.
- * 
- * A filling layer is inserted when a a pillar of infill areas is becoming too high, or when the angle between the filling areas is too shallow.
- * 
- * The filling area might be smaller than the actual infill area, so that we fill the pillar from a smaller top area.
- * 
- * Infill pillars can join each other if they are connected on the top. The total volume will then be extruded from the top.
- * 
- * Where the model spits into two from bottom to top, one of the top pieces will be connected to the lower part as one big pillar, while a new pillar will be generated for the other top part.
- * Which part the base will be connected to is arbitrary.
- * 
- */
-class SpaghettiInfillPathGenerator
-{
-public:
-    /*!
-     * Add spaghetti infill for a given part in a layer plan.
-     * 
-     * Move over the infill region with a zigzag pattern and
-     * extrude as much material as needed for the current part
-     * and all parts below which should be filled with this spaghetti.
-     * 
-     * \param storage Where to get the secondary brim lines from if we are
-     * adding spaghetti on the very first layer and we need to prime first.
-     * \param fff_gcode_writer The FffGcodeWriter for which the function
-     * setExtruder_addPrime needs to be called when on the first layer.
-     * \param gcode_layer The initial planning of the gcode of the layer.
-     * \param mesh The mesh for which to add to the layer plan \p gcode_layer.
-     * \param extruder_nr The extruder for which to print all features of the
-     * mesh which should be printed with this extruder.
-     * \param mesh_config the line config with which to print a print feature.
-     * \param part The part for which to create gcode.
-     * \return Whether this function added anything to the layer plan
-     */
-    static bool processSpaghettiInfill(const SliceDataStorage& storage, const FffGcodeWriter& fff_gcode_writer, LayerPlan& gcode_layer, const SliceMeshStorage& mesh, const size_t extruder_nr, const PathConfigStorage::MeshPathConfigs& mesh_config, const SliceLayerPart& part);
-};
-
-}//namespace cura
-
-#endif//INFILL_SPAGHETTI_INFILL_PATH_GENERATOR_H
diff -pruN 1:4.6.2-1/src/infill/SubDivCube.cpp 1:4.7.1-1/src/infill/SubDivCube.cpp
--- 1:4.6.2-1/src/infill/SubDivCube.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill/SubDivCube.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -34,10 +34,13 @@ SubDivCube::~SubDivCube()
     }
 }
 
-void SubDivCube::precomputeOctree(SliceMeshStorage& mesh)
+void SubDivCube::precomputeOctree(SliceMeshStorage& mesh, const Point& infill_origin)
 {
     radius_addition = mesh.settings.get<coord_t>("sub_div_rad_add");
-    AngleRadians infill_angle = 45;
+
+    // if infill_angles is not empty use the first value, otherwise use 0
+    const std::vector<AngleDegrees> infill_angles = mesh.settings.get<std::vector<AngleDegrees>>("infill_angles");
+    const AngleDegrees infill_angle = (!infill_angles.empty()) ? infill_angles[0] : AngleDegrees(0);
 
     const coord_t furthest_dist_from_origin = std::sqrt(square(mesh.settings.get<coord_t>("machine_height")) + square(mesh.settings.get<coord_t>("machine_depth") / 2) + square(mesh.settings.get<coord_t>("machine_width") / 2));
     const coord_t max_side_length = furthest_dist_from_origin * 2;
@@ -58,7 +61,7 @@ void SubDivCube::precomputeOctree(SliceM
             curr_recursion_depth++;
         }
     }
-    Point3 center(0, 0, 0);
+    Point3 center(infill_origin.X, infill_origin.Y, 0);
 
     Point3Matrix tilt; // rotation matrix to get from axis aligned cubes to cubes standing on their tip
     // The Z axis is transformed to go in positive Y direction
diff -pruN 1:4.6.2-1/src/infill/SubDivCube.h 1:4.7.1-1/src/infill/SubDivCube.h
--- 1:4.6.2-1/src/infill/SubDivCube.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill/SubDivCube.h	2020-08-14 10:34:26.000000000 +0000
@@ -32,7 +32,7 @@ public:
      * Precompute the octree of subdivided cubes
      * \param mesh contains infill layer data and settings
      */
-    static void precomputeOctree(SliceMeshStorage& mesh);
+    static void precomputeOctree(SliceMeshStorage& mesh, const Point& infill_origin);
 
     /*!
      * Generates the lines of subdivision of the specific cube at the specific layer. It recursively calls itself, so it ends up drawing all the subdivision lines of sub-cubes too.
diff -pruN 1:4.6.2-1/src/infill.cpp 1:4.7.1-1/src/infill.cpp
--- 1:4.6.2-1/src/infill.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/infill.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -100,8 +100,7 @@ void Infill::_generate(Polygons& result_
 
     if (pattern == EFillMethod::ZIG_ZAG || (zig_zaggify && (pattern == EFillMethod::LINES || pattern == EFillMethod::TRIANGLES || pattern == EFillMethod::GRID || pattern == EFillMethod::CUBIC || pattern == EFillMethod::TETRAHEDRAL || pattern == EFillMethod::QUARTER_CUBIC || pattern == EFillMethod::TRIHEXAGON || pattern == EFillMethod::GYROID)))
     {
-        const float width_scale = (mesh) ? (float)mesh->settings.get<coord_t>("layer_height") / mesh->settings.get<coord_t>("infill_sparse_thickness") : 1;
-        outline_offset -= width_scale * infill_line_width / 2; // the infill line zig zag connections must lie next to the border, not on it
+        outline_offset -= infill_line_width / 2; // the infill line zig zag connections must lie next to the border, not on it
     }
 
     switch(pattern)
diff -pruN 1:4.6.2-1/src/InsetOrderOptimizer.cpp 1:4.7.1-1/src/InsetOrderOptimizer.cpp
--- 1:4.6.2-1/src/InsetOrderOptimizer.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/InsetOrderOptimizer.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -357,7 +357,6 @@ void InsetOrderOptimizer::processOuterWa
 
     ConstPolygonRef outer_wall = *inset_polys[0][0];
     Polygons part_inner_walls;
-    int num_level_1_insets = 0;
 
     if (include_inners)
     {
@@ -367,7 +366,6 @@ void InsetOrderOptimizer::processOuterWa
             ConstPolygonRef inner = *inset_polys[1][level_1_wall_idx];
             if (PolygonUtils::polygonsIntersect(inner, outer_wall))
             {
-                ++num_level_1_insets;
                 part_inner_walls.add(inner);
                 // consume the level 1 inset
                 inset_polys[1].erase(inset_polys[1].begin() + level_1_wall_idx);
@@ -413,35 +411,38 @@ void InsetOrderOptimizer::processOuterWa
         const unsigned outer_poly_start_idx = gcode_layer.locateFirstSupportedVertex(*inset_polys[0][0], order_optimizer.polyStart[0]);
         const Point z_seam_location = (*inset_polys[0][0])[outer_poly_start_idx];
 
+        std::function<void(void)> addInnerWalls = [this, part_inner_walls, outer_inset_first, z_seam_location]()
+        {
+            Polygons boundary(*gcode_layer.getCombBoundaryInside());
+            ZSeamConfig inner_walls_z_seam_config;
+            PathOrderOptimizer orderOptimizer(z_seam_location, inner_walls_z_seam_config, &boundary);
+            orderOptimizer.addPolygons(part_inner_walls);
+            orderOptimizer.optimize();
+            if (!outer_inset_first)
+            {
+                // reverse the optimized order so we end up as near to the outline z-seam as possible
+                std::reverse(orderOptimizer.polyOrder.begin(), orderOptimizer.polyOrder.end());
+            }
+            constexpr coord_t wall_0_wipe_dist = 0;
+            constexpr float flow_ratio = 1.0;
+            constexpr bool always_retract = false;
+            for (unsigned int wall_idx : orderOptimizer.polyOrder)
+            {
+                gcode_layer.addWall(part_inner_walls[wall_idx], orderOptimizer.polyStart[wall_idx], mesh, mesh_config.insetX_config, mesh_config.bridge_insetX_config, wall_overlapper_x, wall_0_wipe_dist, flow_ratio, always_retract);
+            }
+        };
+
         if (outer_inset_first)
         {
             if (include_outer && extruder_nr == mesh.settings.get<ExtruderTrain&>("wall_0_extruder_nr").extruder_nr)
             {
                 gcode_layer.addWall(*inset_polys[0][0], outer_poly_start_idx, mesh, mesh_config.inset0_config, mesh_config.bridge_inset0_config, wall_overlapper_0, wall_0_wipe_dist, flow, retract_before_outer_wall);
             }
-            else
-            {
-                // as we may have been printing holes after the outer inset was printed, add this move to the start point of the inner wall we want to be printed first
-                const Point dest = part_inner_walls[0][PolygonUtils::findNearestVert(z_seam_location, part_inner_walls[0])];
-                gcode_layer.addTravel(dest);
-            }
-            gcode_layer.addWalls(part_inner_walls, mesh, mesh_config.insetX_config, mesh_config.bridge_insetX_config, wall_overlapper_x);
+            addInnerWalls();
         }
         else
         {
-            // reverse order of inner walls to increase chance of them being printed from inside to outside
-            std::reverse(part_inner_walls.begin(), part_inner_walls.end());
-
-            // just like we did for the holes, ensure that a single outer wall inset is started close to the z seam position
-            // but if there is more than one outer wall level 1 inset, don't bother to move as it may actually be a waste of time because
-            // there may not be an inset immediately inside of where the z seam is located so we would end up moving again anyway
-            if (num_level_1_insets == 1)
-            {
-                // move to the location of the vertex in the innermost inset that's closest to the z seam location
-                const Point dest = part_inner_walls[0][PolygonUtils::findNearestVert(z_seam_location, part_inner_walls[0])];
-                gcode_layer.addTravel(dest);
-            }
-            gcode_layer.addWalls(part_inner_walls, mesh, mesh_config.insetX_config, mesh_config.bridge_insetX_config, wall_overlapper_x);
+            addInnerWalls();
             if (include_outer && extruder_nr == mesh.settings.get<ExtruderTrain&>("wall_0_extruder_nr").extruder_nr)
             {
                 gcode_layer.addWall(*inset_polys[0][0], outer_poly_start_idx, mesh, mesh_config.inset0_config, mesh_config.bridge_inset0_config, wall_overlapper_0, wall_0_wipe_dist, flow, retract_before_outer_wall);
diff -pruN 1:4.6.2-1/src/LayerPlanBuffer.cpp 1:4.7.1-1/src/LayerPlanBuffer.cpp
--- 1:4.6.2-1/src/LayerPlanBuffer.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/LayerPlanBuffer.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -101,7 +101,14 @@ void LayerPlanBuffer::addConnectingTrave
         const bool force_retract = extruder_settings.get<bool>("retract_at_layer_change") ||
           (mesh_group_settings.get<bool>("travel_retract_before_outer_wall") && (mesh_group_settings.get<bool>("outer_inset_first") || mesh_group_settings.get<size_t>("wall_line_count") == 1)); //Moving towards an outer wall.
         prev_layer->final_travel_z = newest_layer->z;
-        prev_layer->addTravel(first_location_new_layer, force_retract);
+        GCodePath &path = prev_layer->addTravel(first_location_new_layer, force_retract);
+        if (force_retract && !path.retract)
+        {
+            // addTravel() won't use retraction if the travel distance is less than retraction minimum travel setting
+            // so to avoid blobs when moving to the new layer height, which can occur if the z-axis speed is very slow,
+            // we force the path to use retraction
+            path.retract = true;
+        }
     }
 }
 
diff -pruN 1:4.6.2-1/src/LayerPlan.cpp 1:4.7.1-1/src/LayerPlan.cpp
--- 1:4.6.2-1/src/LayerPlan.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/LayerPlan.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -1464,7 +1464,8 @@ void LayerPlan::writeGCode(GCodeExport&
     const Settings& mesh_group_settings = Application::getInstance().current_slice->scene.current_mesh_group->settings;
     gcode.setFlowRateExtrusionSettings(mesh_group_settings.get<double>("flow_rate_max_extrusion_offset"), mesh_group_settings.get<Ratio>("flow_rate_extrusion_offset_factor")); //Offset is in mm.
 
-    if (layer_nr == 1 - static_cast<LayerIndex>(Raft::getTotalExtraLayers()) && mesh_group_settings.get<bool>("machine_heated_bed") && mesh_group_settings.get<Temperature>("material_bed_temperature") != 0)
+    static LayerIndex layer_1 {1 - static_cast<LayerIndex>(Raft::getTotalExtraLayers())};
+    if (layer_nr == layer_1 && mesh_group_settings.get<bool>("machine_heated_bed") && mesh_group_settings.get<Temperature>("material_bed_temperature") != mesh_group_settings.get<Temperature>("material_bed_temperature_layer_0"))
     {
         constexpr bool wait = false;
         gcode.writeBedTemperatureCommand(mesh_group_settings.get<Temperature>("material_bed_temperature"), wait);
@@ -1654,7 +1655,7 @@ void LayerPlan::writeGCode(GCodeExport&
             }
 
             bool spiralize = path.spiralize;
-            if (!spiralize) // normal (extrusion) move (with coasting
+            if (!spiralize) // normal (extrusion) move (with coasting)
             {
                 // if path provides a valid (in range 0-100) fan speed, use it
                 const double path_fan_speed = path.getFanSpeed();
@@ -1853,7 +1854,7 @@ bool LayerPlan::writePathWithCoasting(GC
         actual_coasting_dist = accumulated_dist * coasting_dist / coasting_min_dist;
         for (acc_dist_idx_gt_coast_dist = 0 ; acc_dist_idx_gt_coast_dist < accumulated_dist_per_point.size() ; acc_dist_idx_gt_coast_dist++)
         { // search for the correct coast_dist_idx
-            if (accumulated_dist_per_point[acc_dist_idx_gt_coast_dist] > actual_coasting_dist)
+            if (accumulated_dist_per_point[acc_dist_idx_gt_coast_dist] >= actual_coasting_dist)
             {
                 break;
             }
diff -pruN 1:4.6.2-1/src/MeshGroup.cpp 1:4.7.1-1/src/MeshGroup.cpp
--- 1:4.6.2-1/src/MeshGroup.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/MeshGroup.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -195,7 +195,7 @@ bool loadMeshSTL_binary(Mesh* mesh, cons
 
 bool loadMeshSTL(Mesh* mesh, const char* filename, const FMatrix3x3& matrix)
 {
-    FILE* f = fopen(filename, "r");
+    FILE* f = fopen(filename, "rb");
     if (f == nullptr)
     {
         return false;
diff -pruN 1:4.6.2-1/src/settings/EnumSettings.h 1:4.7.1-1/src/settings/EnumSettings.h
--- 1:4.6.2-1/src/settings/EnumSettings.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/settings/EnumSettings.h	2020-08-14 10:34:26.000000000 +0000
@@ -51,6 +51,15 @@ enum class ESupportType
     EVERYWHERE
 };
 
+/*!
+ * Structure of the support, such as Tree Support
+ */
+enum class ESupportStructure
+{
+    NORMAL,
+    TREE
+};
+
 enum class EZSeamType
 {
     RANDOM,
diff -pruN 1:4.6.2-1/src/settings/PathConfigStorage.cpp 1:4.7.1-1/src/settings/PathConfigStorage.cpp
--- 1:4.6.2-1/src/settings/PathConfigStorage.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/settings/PathConfigStorage.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -141,9 +141,9 @@ PathConfigStorage::MeshPathConfigs::Mesh
     {
         infill_config.emplace_back(
                 PrintFeatureType::Infill
-                , mesh.settings.get<coord_t>("infill_line_width") * (combine_idx + 1) * line_width_factor_per_extruder[mesh.settings.get<ExtruderTrain&>("infill_extruder_nr").extruder_nr]
+                , mesh.settings.get<coord_t>("infill_line_width") * line_width_factor_per_extruder[mesh.settings.get<ExtruderTrain&>("infill_extruder_nr").extruder_nr]
                 , layer_thickness
-                , mesh.settings.get<Ratio>("infill_material_flow") * ((layer_nr == 0) ? mesh.settings.get<Ratio>("material_flow_layer_0") : Ratio(1.0))
+                , mesh.settings.get<Ratio>("infill_material_flow") * ((layer_nr == 0) ? mesh.settings.get<Ratio>("material_flow_layer_0") : Ratio(1.0)) * (combine_idx + 1)
                 , GCodePathConfig::SpeedDerivatives{mesh.settings.get<Velocity>("speed_infill"), mesh.settings.get<Acceleration>("acceleration_infill"), mesh.settings.get<Velocity>("jerk_infill")}
             );
     }
@@ -239,9 +239,9 @@ PathConfigStorage::PathConfigStorage(con
     {
         support_infill_config.emplace_back(
             PrintFeatureType::Support
-            , support_infill_train.settings.get<coord_t>("support_line_width") * (combine_idx + 1) * support_infill_line_width_factor
+            , support_infill_train.settings.get<coord_t>("support_line_width") * support_infill_line_width_factor
             , layer_thickness
-            , support_infill_train.settings.get<Ratio>("support_material_flow") * ((layer_nr == 0) ? support_infill_train.settings.get<Ratio>("material_flow_layer_0") : Ratio(1.0))
+            , support_infill_train.settings.get<Ratio>("support_material_flow") * ((layer_nr == 0) ? support_infill_train.settings.get<Ratio>("material_flow_layer_0") : Ratio(1.0)) * (combine_idx + 1)
             , GCodePathConfig::SpeedDerivatives{support_infill_train.settings.get<Velocity>("speed_support_infill"), support_infill_train.settings.get<Acceleration>("acceleration_support_infill"), support_infill_train.settings.get<Velocity>("jerk_support_infill")}
         );
     }
diff -pruN 1:4.6.2-1/src/settings/Settings.cpp 1:4.7.1-1/src/settings/Settings.cpp
--- 1:4.6.2-1/src/settings/Settings.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/settings/Settings.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -382,6 +382,24 @@ template<> ESupportType Settings::get<ES
     }
 }
 
+template<> ESupportStructure Settings::get<ESupportStructure>(const std::string& key) const
+{
+    const std::string& value = get<std::string>(key);
+    if (value == "normal")
+    {
+        return ESupportStructure::NORMAL;
+    }
+    else if (value == "tree")
+    {
+        return ESupportStructure::TREE;
+    }
+    else //Default.
+    {
+        return ESupportStructure::NORMAL;
+    }
+}
+
+
 template<> EZSeamType Settings::get<EZSeamType>(const std::string& key) const
 {
     const std::string& value = get<std::string>(key);
diff -pruN 1:4.6.2-1/src/skin.cpp 1:4.7.1-1/src/skin.cpp
--- 1:4.6.2-1/src/skin.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/skin.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -354,7 +354,13 @@ void SkinInfillAreaComputation::generate
 {
     for (SkinPart& skin_part : part->skin_parts)
     {
-        generateSkinInsets(skin_part);
+        // Do not generate insets if the Bottom Pattern Initial Layer (for layer 0) and the Top/Bottom Layer Pattern
+        // (for the rest of the layers) are concentric
+        if ((layer_nr == 0 && mesh.settings.get<EFillMethod>("top_bottom_pattern_0") != EFillMethod::CONCENTRIC)
+            || (layer_nr > 0 && mesh.settings.get<EFillMethod>("top_bottom_pattern") != EFillMethod::CONCENTRIC))
+        {
+            generateSkinInsets(skin_part);
+        }
         generateInnerSkinInfill(skin_part);
     }
 }
@@ -452,7 +458,7 @@ void SkinInfillAreaComputation::generate
     }
     Polygons infill = part.insets.back().offset(offset_from_inner_wall);
 
-    infill = infill.difference(skin);
+    infill = infill.difference(skin.offset(infill_skin_overlap));
     infill.removeSmallAreas(MIN_AREA_SIZE);
 
     part.infill_area = infill.offset(infill_skin_overlap);
@@ -467,42 +473,97 @@ void SkinInfillAreaComputation::generate
 void SkinInfillAreaComputation::generateRoofing(SliceLayerPart& part)
 {
     const size_t roofing_layer_count = mesh.settings.get<size_t>("roofing_layer_count");
-    const size_t wall_idx = std::min(size_t(2), mesh.settings.get<size_t>("wall_line_count"));
 
     for (SkinPart& skin_part : part.skin_parts)
     {
         Polygons roofing;
         if (roofing_layer_count > 0)
         {
-            Polygons no_air_above = getWalls(part, layer_nr + roofing_layer_count, wall_idx);
-            if (!no_small_gaps_heuristic)
+            Polygons no_air_above = generateNoAirAbove(part);
+            skin_part.roofing_fill = skin_part.inner_infill.difference(no_air_above);
+            skin_part.inner_infill = skin_part.inner_infill.intersection(no_air_above);
+
+            // Insets are NOT generated for any layer if the top/bottom pattern is concentric.
+            // In this case, we still want to generate insets for the roofing layers based on the extra skin wall count,
+            // if the roofing pattern is not concentric.
+            if (!skin_part.roofing_fill.empty()
+                && layer_nr > 0
+                && mesh.settings.get<EFillMethod>("roofing_pattern") != EFillMethod::CONCENTRIC
+                && mesh.settings.get<EFillMethod>("top_bottom_pattern") == EFillMethod::CONCENTRIC)
             {
-                for (int layer_nr_above = layer_nr + 1; layer_nr_above < layer_nr + roofing_layer_count; layer_nr_above++)
-                {
-                    Polygons outlines_above = getWalls(part, layer_nr_above, wall_idx);
-                    no_air_above = no_air_above.intersection(outlines_above);
-                }
+                // Generate skin insets, regenerate the no_air_above, and recalculate the inner and roofing infills, 
+                // taking into account the extra skin wall count (only for the roofing layers).
+                generateSkinInsets(skin_part);
+                regenerateRoofingFillAndInnerInfill(part, skin_part);
             }
-            if (layer_nr > 0)
+            // On the contrary, unwanted insets are generated for roofing layers because of the non-concentric top/bottom pattern.
+            // In such cases we want to clear the skin insets first and then regenerate the proper roofing fill and inner infill
+            // in the concentric roofing_pattern.
+            else if (!skin_part.roofing_fill.empty()
+                    && layer_nr > 0 
+                    && mesh.settings.get<EFillMethod>("roofing_pattern") == EFillMethod::CONCENTRIC
+                    && mesh.settings.get<EFillMethod>("top_bottom_pattern") != EFillMethod::CONCENTRIC)
             {
-                // if the skin has air below it then cutting it into regions could cause a region
-                // to be wholely or partly above air and it may not be printable so restrict
-                // the regions that have air above (the visible regions) to not include any area that
-                // has air below (fixes https://github.com/Ultimaker/Cura/issues/2656)
+                // Clear the skin insets for the roofing layers and regenerate the roofing fill and inner infill without taking into
+                // account the Extra Skin Wall Count.
+                skin_part.insets.clear();
+                regenerateRoofingFillAndInnerInfill(part, skin_part);
+            }
+        }
+    }
+}
 
-                // set air_below to the skin area for the current layer that has air below it
-                Polygons air_below = getWalls(part, layer_nr, wall_idx).difference(getWalls(part, layer_nr - 1, wall_idx));
+/*
+ * This function is executed in a parallel region based on layer_nr.
+ * When modifying make sure any changes does not introduce data races.
+ *
+ * this function may only read the skin and infill from the *current* layer.
+ */
+Polygons SkinInfillAreaComputation::generateNoAirAbove(SliceLayerPart& part)
+{
+    const size_t roofing_layer_count = mesh.settings.get<size_t>("roofing_layer_count");
+    const size_t wall_idx = std::min(size_t(2), mesh.settings.get<size_t>("wall_line_count"));
 
-                if (!air_below.empty())
-                {
-                    // add the polygons that have air below to the no air above polygons
-                    no_air_above = no_air_above.unionPolygons(air_below);
-                }
-            }
-            skin_part.roofing_fill = skin_part.inner_infill.difference(no_air_above);
-            skin_part.inner_infill = skin_part.inner_infill.intersection(no_air_above);
+    Polygons no_air_above = getWalls(part, layer_nr + roofing_layer_count, wall_idx);
+    if (!no_small_gaps_heuristic)
+    {
+        for (int layer_nr_above = layer_nr + 1; layer_nr_above < layer_nr + roofing_layer_count; layer_nr_above++)
+        {
+            Polygons outlines_above = getWalls(part, layer_nr_above, wall_idx);
+            no_air_above = no_air_above.intersection(outlines_above);
         }
     }
+    if (layer_nr > 0)
+    {
+        // if the skin has air below it then cutting it into regions could cause a region
+        // to be wholely or partly above air and it may not be printable so restrict
+        // the regions that have air above (the visible regions) to not include any area that
+        // has air below (fixes https://github.com/Ultimaker/Cura/issues/2656)
+
+        // set air_below to the skin area for the current layer that has air below it
+        Polygons air_below = getWalls(part, layer_nr, wall_idx).difference(getWalls(part, layer_nr - 1, wall_idx));
+
+        if (!air_below.empty())
+        {
+            // add the polygons that have air below to the no air above polygons
+            no_air_above = no_air_above.unionPolygons(air_below);
+        }
+    }
+    return no_air_above;
+}
+
+/*
+ * This function is executed in a parallel region based on layer_nr.
+ * When modifying make sure any changes does not introduce data races.
+ *
+ * this function may only read/write the skin and infill from the *current* layer.
+ */
+void SkinInfillAreaComputation::regenerateRoofingFillAndInnerInfill(SliceLayerPart& part, SkinPart& skin_part)
+{
+    generateInnerSkinInfill(skin_part);
+    Polygons no_air_above = generateNoAirAbove(part);
+    skin_part.roofing_fill = skin_part.inner_infill.difference(no_air_above);
+    skin_part.inner_infill = skin_part.inner_infill.intersection(no_air_above);
 }
 
 void SkinInfillAreaComputation::generateInfillSupport(SliceMeshStorage& mesh)
diff -pruN 1:4.6.2-1/src/skin.h 1:4.7.1-1/src/skin.h
--- 1:4.6.2-1/src/skin.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/skin.h	2020-08-14 10:34:26.000000000 +0000
@@ -127,14 +127,31 @@ protected:
     void generateInfill(SliceLayerPart& part, const Polygons& skin);
 
     /*!
-     * Calculate the areas which are 'directly' under air,
-     * remove them from the \ref SkinPart::inner_infill and save them in the \ref SkinPart::roofing_fill of the \p part
+     * Remove the areas which are 'directly' under air from the \ref SkinPart::inner_infill and 
+     * save them in the \ref SkinPart::roofing_fill of the \p part.
      * 
-     * \param[in,out] part Where to get the sSkinParts to get the outline info from and to store the roofing areas
+     * \param[in,out] part Where to get the SkinParts to get the outline info from and to store the roofing areas
      */
     void generateRoofing(SliceLayerPart& part);
 
     /*!
+     * Helper function to calculate and return the areas which are 'directly' under air.
+     *
+     * \param part Where to get the SkinParts to get the outline info from
+     */
+    Polygons generateNoAirAbove(SliceLayerPart& part);
+
+    /*!
+     * Helper function to recalculate the roofing fill and inner infill in roofing layers where the 
+     * insets have to be changed.
+     *
+     * \param part Where to get the SkinParts to get the outline info from
+     * \param skin_part The part where the skin outline information (input) is stored and
+     * where the inner infill and roofing infill areas (output) is stored.
+     */
+    void regenerateRoofingFillAndInnerInfill(SliceLayerPart& part, SkinPart& skin_part);
+
+    /*!
      * Generate the skin insets and the inner infill area
      * 
      * \param part The part where the skin outline information (input) is stored and
diff -pruN 1:4.6.2-1/src/SkirtBrim.cpp 1:4.7.1-1/src/SkirtBrim.cpp
--- 1:4.6.2-1/src/SkirtBrim.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/SkirtBrim.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -60,6 +60,9 @@ void SkirtBrim::getFirstLayerOutline(Sli
                 }
                 AABB model_brim_covered_area_boundary_box(model_brim_covered_area);
                 support_layer.excludeAreasFromSupportInfillAreas(model_brim_covered_area, model_brim_covered_area_boundary_box);
+
+                // If the gap between the model and the BP is small enough, support starts with the interface instead, so remove it there as well:
+                support_layer.support_roof = support_layer.support_roof.difference(model_brim_covered_area);
             }
             for (const SupportInfillPart& support_infill_part : support_layer.support_infill_parts)
             {
diff -pruN 1:4.6.2-1/src/sliceDataStorage.cpp 1:4.7.1-1/src/sliceDataStorage.cpp
--- 1:4.6.2-1/src/sliceDataStorage.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/sliceDataStorage.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -492,7 +492,7 @@ std::vector<bool> SliceDataStorage::getE
     // support is presupposed to be present...
     for (const SliceMeshStorage& mesh : meshes)
     {
-        if (mesh.settings.get<bool>("support_enable") || mesh.settings.get<bool>("support_tree_enable") || mesh.settings.get<bool>("support_mesh"))
+        if (mesh.settings.get<bool>("support_enable") || mesh.settings.get<bool>("support_mesh"))
         {
             ret[mesh_group_settings.get<ExtruderTrain&>("support_extruder_nr_layer_0").extruder_nr] = true;
             ret[mesh_group_settings.get<ExtruderTrain&>("support_infill_extruder_nr").extruder_nr] = true;
diff -pruN 1:4.6.2-1/src/sliceDataStorage.h 1:4.7.1-1/src/sliceDataStorage.h
--- 1:4.6.2-1/src/sliceDataStorage.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/sliceDataStorage.h	2020-08-14 10:34:26.000000000 +0000
@@ -136,8 +136,6 @@ public:
      * \return the own infill area
      */
     const Polygons& getOwnInfillArea() const;
-
-    std::vector<std::pair<Polygons, double>> spaghetti_infill_volumes; //!< For each filling volume on this layer, the area within which to fill and the total volume (in mm3) to fill over the area
 };
 
 /*!
diff -pruN 1:4.6.2-1/src/support.cpp 1:4.7.1-1/src/support.cpp
--- 1:4.6.2-1/src/support.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/support.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -779,7 +779,7 @@ void AreaSupport::precomputeCrossInfillT
 
 void AreaSupport::generateOverhangAreasForMesh(SliceDataStorage& storage, SliceMeshStorage& mesh)
 {
-    if (!mesh.settings.get<bool>("support_enable") && !mesh.settings.get<bool>("support_tree_enable") && !mesh.settings.get<bool>("support_mesh"))
+    if (!mesh.settings.get<bool>("support_enable") && !mesh.settings.get<bool>("support_mesh"))
     {
         return;
     }
@@ -841,8 +841,9 @@ void AreaSupport::generateSupportAreasFo
 {
     SliceMeshStorage& mesh = storage.meshes[mesh_idx];
 
+    const ESupportStructure support_structure = mesh.settings.get<ESupportStructure>("support_structure");
     const bool is_support_mesh_place_holder = mesh.settings.get<bool>("support_mesh"); // whether this mesh has empty SliceMeshStorage and this function is now called to only generate support for all support meshes
-    if (!mesh.settings.get<bool>("support_enable") && !is_support_mesh_place_holder)
+    if ((!mesh.settings.get<bool>("support_enable") || support_structure != ESupportStructure::NORMAL) && !is_support_mesh_place_holder)
     {
         return;
     }
@@ -865,6 +866,9 @@ void AreaSupport::generateSupportAreasFo
     //Compute the areas that are disallowed by the X/Y distance.
     std::vector<Polygons> xy_disallowed_per_layer;
     xy_disallowed_per_layer.resize(layer_count);
+    std::vector<Polygons> sloped_areas_per_layer;
+    sloped_areas_per_layer.resize(layer_count);
+    sloped_areas_per_layer[0] = Polygons();
     // simplified processing for bottom layer - just ensure support clears part by XY distance
     const coord_t xy_distance = infill_settings.get<coord_t>("support_xy_distance");
     const coord_t xy_distance_overhang = infill_settings.get<coord_t>("support_xy_distance_overhang");
@@ -874,16 +878,18 @@ void AreaSupport::generateSupportAreasFo
     constexpr bool no_support = false;
     constexpr bool no_prime_tower = false;
     const coord_t support_line_width = mesh_group_settings.get<ExtruderTrain&>("support_infill_extruder_nr").settings.get<coord_t>("support_line_width");
+    const double sloped_areas_angle = mesh.settings.get<AngleRadians>("support_bottom_stair_step_min_slope");
+    const coord_t sloped_area_detection_width = 10 + static_cast<coord_t>(layer_thickness / std::tan(sloped_areas_angle)) / 2;
     xy_disallowed_per_layer[0] = storage.getLayerOutlines(0, no_support, no_prime_tower).offset(xy_distance);
 
     // OpenMP compatibility fix for GCC <= 8 and GCC >= 9
     // See https://www.gnu.org/software/gcc/gcc-9/porting_to.html, section "OpenMP data sharing"
 #if defined(__GNUC__) && __GNUC__ <= 8
-    #pragma omp parallel for default(none) shared(xy_disallowed_per_layer, storage, mesh) schedule(dynamic)
+    #pragma omp parallel for default(none) shared(xy_disallowed_per_layer, sloped_areas_per_layer, storage, mesh) schedule(dynamic)
 #else
     #pragma omp parallel for default(none) \
-        shared(xy_disallowed_per_layer, storage, mesh, layer_count, is_support_mesh_place_holder,  \
-               use_xy_distance_overhang, z_distance_top, tan_angle, xy_distance, xy_distance_overhang, layer_thickness, support_line_width) \
+        shared(xy_disallowed_per_layer, sloped_areas_per_layer, storage, mesh, layer_count, is_support_mesh_place_holder,  \
+               use_xy_distance_overhang, z_distance_top, tan_angle, xy_distance, xy_distance_overhang, layer_thickness, support_line_width, sloped_area_detection_width) \
         schedule(dynamic)
 #endif // defined(__GNUC__) && __GNUC__ <= 8
 
@@ -891,7 +897,22 @@ void AreaSupport::generateSupportAreasFo
     // Use a signed type for the loop counter so MSVC compiles (because it uses OpenMP 2.0, an old version).
     for (int layer_idx = 1; layer_idx < static_cast<int>(layer_count); layer_idx++)
     {
-        Polygons outlines = storage.getLayerOutlines(layer_idx, no_support, no_prime_tower);
+        const Polygons outlines = storage.getLayerOutlines(layer_idx, no_support, no_prime_tower);
+
+        // Build sloped areas. We need this for the stair-stepping later on.
+        // Specifically, sloped areass are used in 'moveUpFromModel' to prevent a stair step happening over an area where there isn't a slope.
+        // This part here only concerns the slope between two layers. This will be post-processed later on (see the other parallel loop below).
+        sloped_areas_per_layer[layer_idx] =
+            // Take the outer areas of the previous layer, where the outer areas are (mostly) just _inside_ the shape.
+            storage.getLayerOutlines(layer_idx - 1, no_support, no_prime_tower).tubeShape(sloped_area_detection_width, 10)
+            // Intersect those with the outer areas of the current layer, where the outer areas are (mostly) _outside_ the shape.
+            // This will detect every slope (and some/most vertical walls) between those two layers.
+            .intersection(outlines.tubeShape(10, sloped_area_detection_width))
+            // Do an opening operation so we're not stuck with tiny patches.
+            // The later offset is extended with the line-width, so all patches are merged together if there's less than a line-width between them.
+            .offset(-10).offset(10 + sloped_area_detection_width);
+        // The sloped areas are now ready to be post-processed.
+
         if (!is_support_mesh_place_holder)
         { // don't compute overhang for support meshes
             if (use_xy_distance_overhang) //Z overrides XY distance.
@@ -976,6 +997,38 @@ void AreaSupport::generateSupportAreasFo
     const coord_t bottom_stair_step_height = std::max(static_cast<coord_t>(0), mesh.settings.get<coord_t>("support_bottom_stair_step_height"));
     const size_t bottom_stair_step_layer_count = bottom_stair_step_height / layer_thickness + 1; // the difference in layers between two stair steps. One is normal support (not stair-like)
 
+    // Post-process the sloped areas's. (Skip if no stair-stepping anyway.)
+    // The idea here is to 'add up' all the sloped 'areas' so they form actual areas per each stair-step height.
+    // (Only the 'top' sloped area for each step is actually used in the end, see 'moveUpFromModel'.)
+    if (bottom_stair_step_layer_count > 0)
+    {
+        // We can parallelize this part, which is needed since these are potentially expensive operations,
+        // but only in chunks of `bottom_stair_step_layer_count` steps, since, within such a chunk,
+        // the order of execution is important.
+        // Unless thinking about optimization & threading, you can just think of this as a single for-loop.
+
+        // OpenMP compatibility fix for GCC <= 8 and GCC >= 9
+        // See https://www.gnu.org/software/gcc/gcc-9/porting_to.html, section "OpenMP data sharing"
+#if defined(__GNUC__) && __GNUC__ <= 8
+#pragma omp parallel for default(none) shared(sloped_areas_per_layer) schedule(dynamic)
+#else
+#pragma omp parallel for default(none) shared(sloped_areas_per_layer, layer_count, bottom_stair_step_layer_count) schedule(dynamic)
+#endif // defined(__GNUC__) && __GNUC__ <= 8
+        for (int base_layer_idx = 1; base_layer_idx < static_cast<int>(layer_count); base_layer_idx += bottom_stair_step_layer_count)
+        {
+            // Add the sloped areas together for each stair of the stair stepping.
+            const int max_layer_stair_step = std::min(base_layer_idx + bottom_stair_step_layer_count, layer_count);
+            for (int layer_idx = base_layer_idx; layer_idx < max_layer_stair_step; ++layer_idx)
+            {
+                // Start a new stair every modulo bottom_stair_step_layer_count steps.
+                if (layer_idx % bottom_stair_step_layer_count != 1)
+                {
+                    sloped_areas_per_layer[layer_idx] = sloped_areas_per_layer[layer_idx].unionPolygons(sloped_areas_per_layer[layer_idx - 1]);
+                }
+            }
+        }
+    }
+
     for (size_t layer_idx = layer_count - 1 - layer_z_distance_top; layer_idx != static_cast<size_t>(-1); layer_idx--)
     {
         Polygons layer_this = mesh.full_overhang_areas[layer_idx + layer_z_distance_top];
@@ -1038,8 +1091,8 @@ void AreaSupport::generateSupportAreasFo
             layer_this = layer_this.unionPolygons(storage.support.supportLayers[layer_idx].support_mesh_drop_down);
         }
 
-        // Move up from model, while taking the (post-processed) x/y-disallowed area into account.
-        moveUpFromModel(storage, stair_removal, layer_this, layer_idx, bottom_empty_layer_count, bottom_stair_step_layer_count, bottom_stair_step_width);
+        // Move up from model, handle stair-stepping.
+        moveUpFromModel(storage, stair_removal, sloped_areas_per_layer[layer_idx], layer_this, layer_idx, bottom_empty_layer_count, bottom_stair_step_layer_count, bottom_stair_step_width);
 
         support_areas[layer_idx] = layer_this;
         Progress::messageProgress(Progress::Stage::SUPPORT, layer_count * (mesh_idx + 1) - layer_idx, layer_count * storage.meshes.size());
@@ -1143,7 +1196,7 @@ void AreaSupport::generateSupportAreasFo
     storage.support.generated = true;
 }
 
-void AreaSupport::moveUpFromModel(const SliceDataStorage& storage, Polygons& stair_removal, Polygons& support_areas, const size_t layer_idx, const size_t bottom_empty_layer_count, const size_t bottom_stair_step_layer_count, const coord_t support_bottom_stair_step_width)
+void AreaSupport::moveUpFromModel(const SliceDataStorage& storage, Polygons& stair_removal, Polygons& sloped_areas, Polygons& support_areas, const size_t layer_idx, const size_t bottom_empty_layer_count, const size_t bottom_stair_step_layer_count, const coord_t support_bottom_stair_step_width)
 {
 // The idea behind support bottom stairs:
 //
@@ -1214,7 +1267,7 @@ void AreaSupport::moveUpFromModel(const
         if (layer_idx % bottom_stair_step_layer_count == 0)
         { // update stairs for next step
             const Polygons supporting_bottom = storage.getLayerOutlines(bottom_layer_nr - 1, no_support, no_prime_tower);
-            const Polygons allowed_step_width = support_areas.intersection(supporting_bottom).offset(support_bottom_stair_step_width);
+            const Polygons allowed_step_width = supporting_bottom.offset(support_bottom_stair_step_width).intersection(sloped_areas);
 
             const int64_t step_bottom_layer_nr = bottom_layer_nr - bottom_stair_step_layer_count + 1;
             if (step_bottom_layer_nr >= 0)
diff -pruN 1:4.6.2-1/src/support.h 1:4.7.1-1/src/support.h
--- 1:4.6.2-1/src/support.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/support.h	2020-08-14 10:34:26.000000000 +0000
@@ -238,7 +238,7 @@ private:
      * \param bottom_stair_step_layer_count The max height (in nr of layers) of the support bottom stairs
      * \param support_bottom_stair_step_width The max width of the support bottom stairs
      */
-    static void moveUpFromModel(const SliceDataStorage& storage, Polygons& stair_removal, Polygons& support_areas, const size_t layer_idx, const size_t bottom_empty_layer_count, const size_t bottom_stair_step_layer_count, const coord_t support_bottom_stair_step_width);
+    static void moveUpFromModel(const SliceDataStorage& storage, Polygons& stair_removal, Polygons& sloped_areas, Polygons& support_areas, const size_t layer_idx, const size_t bottom_empty_layer_count, const size_t bottom_stair_step_layer_count, const coord_t support_bottom_stair_step_width);
 
     /*!
      * Joins the layer part outlines of all meshes and collects the overhang
diff -pruN 1:4.6.2-1/src/TopSurface.cpp 1:4.7.1-1/src/TopSurface.cpp
--- 1:4.6.2-1/src/TopSurface.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/TopSurface.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -37,7 +37,6 @@ bool TopSurface::ironing(const SliceMesh
     const bool zig_zaggify_infill = pattern == EFillMethod::ZIG_ZAG;
     constexpr bool connect_polygons = false; // midway connections can make the surface less smooth
     const coord_t line_spacing = mesh.settings.get<coord_t>("ironing_line_spacing");
-    const coord_t outline_offset = -mesh.settings.get<coord_t>("ironing_inset");
     const coord_t line_width = line_config.getLineWidth();
     const std::vector<AngleDegrees>& top_most_skin_angles = (mesh.settings.get<size_t>("roofing_layer_count") > 0) ? mesh.roofing_angles : mesh.skin_angles;
     assert(top_most_skin_angles.size() > 0);
@@ -45,6 +44,26 @@ bool TopSurface::ironing(const SliceMesh
     constexpr coord_t infill_overlap = 0;
     constexpr int infill_multiplier = 1;
     constexpr coord_t shift = 0;
+    const Ratio ironing_flow = mesh.settings.get<Ratio>("ironing_flow");
+
+    coord_t ironing_inset = -mesh.settings.get<coord_t>("ironing_inset");
+    if (pattern == EFillMethod::ZIG_ZAG)
+    {
+        //Compensate for the outline_offset decrease that takes place when using the infill generator to generate ironing with the zigzag pattern
+        const Ratio width_scale = (float)mesh.settings.get<coord_t>("layer_height") / mesh.settings.get<coord_t>("infill_sparse_thickness");
+        ironing_inset += width_scale * line_width / 2;
+        //Align the edge of the ironing line with the edge of the outer wall
+        ironing_inset -= ironing_flow * line_width / 2;
+    }
+    else if (pattern == EFillMethod::CONCENTRIC)
+    {
+        //Counteract the outline_offset increase that takes place when using the infill generator to generate ironing with the concentric pattern
+        ironing_inset += line_spacing - line_width / 2;
+        //Align the edge of the ironing line with the edge of the outer wall
+        ironing_inset -= ironing_flow * line_width / 2;
+    }
+    const coord_t outline_offset = ironing_inset;
+
     Infill infill_generator(pattern, zig_zaggify_infill, connect_polygons, areas, outline_offset, line_width, line_spacing, infill_overlap, infill_multiplier, direction, layer.z - 10, shift);
     Polygons ironing_polygons;
     Polygons ironing_lines;
diff -pruN 1:4.6.2-1/src/TreeSupport.cpp 1:4.7.1-1/src/TreeSupport.cpp
--- 1:4.6.2-1/src/TreeSupport.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/TreeSupport.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -44,22 +44,26 @@ TreeSupport::TreeSupport(const SliceData
 
 void TreeSupport::generateSupportAreas(SliceDataStorage& storage)
 {
-    const bool global_use_tree_support = Application::getInstance().current_slice->scene.current_mesh_group->settings.get<bool>("support_tree_enable");
+    const Settings& group_settings = Application::getInstance().current_slice->scene.current_mesh_group->settings;
+    const bool global_use_tree_support =
+        group_settings.get<bool>("support_enable")&&
+        group_settings.get<ESupportStructure>("support_structure") == ESupportStructure::TREE;
 
     if (!(global_use_tree_support || 
           std::any_of(storage.meshes.cbegin(),
                       storage.meshes.cend(),
                       [](const SliceMeshStorage& m) { 
-                          return m.settings.get<bool>("support_tree_enable");
+                          return m.settings.get<bool>("support_enable") &&
+                                 m.settings.get<ESupportStructure>("support_structure") == ESupportStructure::TREE;
                       })))
     {
         return;
     }
 
-    std::vector<std::unordered_set<Node*>> contact_nodes(storage.support.supportLayers.size()); //Generate empty layers to store the points in.
+    std::vector<std::vector<Node*>> contact_nodes(storage.support.supportLayers.size()); //Generate empty layers to store the points in.
     for (SliceMeshStorage& mesh : storage.meshes)
     {
-        if (mesh.settings.get<bool>("support_tree_enable"))
+        if (mesh.settings.get<ESupportStructure>("support_structure") == ESupportStructure::TREE)
         {
             generateContactPoints(mesh, contact_nodes);
         }
@@ -84,7 +88,7 @@ void TreeSupport::generateSupportAreas(S
     storage.support.generated = true;
 }
 
-void TreeSupport::drawCircles(SliceDataStorage& storage, const std::vector<std::unordered_set<Node*>>& contact_nodes)
+void TreeSupport::drawCircles(SliceDataStorage& storage, const std::vector<std::vector<Node*>>& contact_nodes)
 {
     const Settings& mesh_group_settings = Application::getInstance().current_slice->scene.current_mesh_group->settings;
     const coord_t branch_radius = mesh_group_settings.get<coord_t>("support_tree_branch_diameter") / 2;
@@ -98,7 +102,7 @@ void TreeSupport::drawCircles(SliceDataS
     const coord_t circle_side_length = 2 * branch_radius * sin(M_PI / CIRCLE_RESOLUTION); //Side length of a regular polygon.
     const coord_t z_distance_bottom = mesh_group_settings.get<coord_t>("support_bottom_distance");
     const coord_t layer_height = mesh_group_settings.get<coord_t>("layer_height");
-    const size_t z_distance_bottom_layers = round_up_divide(z_distance_bottom, layer_height);
+    const size_t z_distance_bottom_layers = round_up_divide(z_distance_bottom, layer_height) > 0 ? round_up_divide(z_distance_bottom, layer_height) : 1;
     const size_t tip_layers = branch_radius / layer_height; //The number of layers to be shrinking the circle to create a tip. This produces a 45 degree angle.
     const double diameter_angle_scale_factor = sin(mesh_group_settings.get<AngleRadians>("support_tree_branch_diameter_angle")) * layer_height / branch_radius; //Scale factor per layer to produce the desired angle.
     const coord_t line_width = mesh_group_settings.get<coord_t>("support_line_width");
@@ -132,7 +136,7 @@ void TreeSupport::drawCircles(SliceDataS
                 }
                 circle.add(node.position + corner);
             }
-            if (node.support_roof_layers_below >= 0)
+            if (node.support_roof_layers_below > 0)
             {
                 roof_layer.add(circle);
             }
@@ -143,10 +147,10 @@ void TreeSupport::drawCircles(SliceDataS
         }
         support_layer = support_layer.unionPolygons();
         roof_layer = roof_layer.unionPolygons();
-        support_layer = support_layer.difference(roof_layer);
         const size_t z_collision_layer = static_cast<size_t>(std::max(0, static_cast<int>(layer_nr) - static_cast<int>(z_distance_bottom_layers) + 1)); //Layer to test against to create a Z-distance.
         support_layer = support_layer.difference(volumes_.getCollision(0, z_collision_layer)); //Subtract the model itself (sample 0 is with 0 diameter but proper X/Y offset).
-        roof_layer = roof_layer.difference(volumes_.getCollision(0, z_collision_layer));
+        roof_layer = roof_layer.difference(volumes_.getCollision(branch_radius, z_collision_layer));
+        support_layer = support_layer.difference(roof_layer);
         //We smooth this support as much as possible without altering single circles. So we remove any line less than the side length of those circles.
         const double diameter_angle_scale_factor_this_layer = static_cast<double>(storage.support.supportLayers.size() - layer_nr - tip_layers) * diameter_angle_scale_factor; //Maximum scale factor.
         support_layer.simplify(circle_side_length * (1 + diameter_angle_scale_factor_this_layer), resolution); //Don't deviate more than the collision resolution so that the lines still stack properly.
@@ -176,12 +180,12 @@ void TreeSupport::drawCircles(SliceDataS
             support_layer = support_layer.difference(floor_layer.offset(10)); //Subtract the support floor from the normal support.
         }
 
-        for (PolygonRef part : support_layer) //Convert every part into a PolygonsPart for the support.
+        std::vector<PolygonsPart> support_layer_parts = support_layer.splitIntoParts();
+        for (PolygonsPart& part : support_layer_parts) //Convert every part into a PolygonsPart for the support.
         {
-            PolygonsPart outline;
-            outline.add(part);
-            storage.support.supportLayers[layer_nr].support_infill_parts.emplace_back(outline, line_width, wall_count);
+            storage.support.supportLayers[layer_nr].support_infill_parts.emplace_back(part, line_width, wall_count);
         }
+
 #pragma omp critical (support_max_layer_nr)
         {
             if (!storage.support.supportLayers[layer_nr].support_infill_parts.empty() || !storage.support.supportLayers[layer_nr].support_roof.empty())
@@ -201,7 +205,7 @@ void TreeSupport::drawCircles(SliceDataS
     }
 }
 
-void TreeSupport::dropNodes(std::vector<std::unordered_set<Node*>>& contact_nodes)
+void TreeSupport::dropNodes(std::vector<std::vector<Node*>>& contact_nodes)
 {
     const Settings& mesh_group_settings = Application::getInstance().current_slice->scene.current_mesh_group->settings;
     //Use Minimum Spanning Tree to connect the points on each layer and move them while dropping them down.
@@ -273,15 +277,16 @@ void TreeSupport::dropNodes(std::vector<
             }
             //Put it in the best one.
             nodes_per_part[closest_part + 1][node.position] = p_node; //Index + 1 because the 0th index is the outside part.
+
         }
         //Create a MST for every part.
         std::vector<MinimumSpanningTree> spanning_trees;
         for (const std::unordered_map<Point, Node*>& group : nodes_per_part)
         {
-            std::unordered_set<Point> points_to_buildplate;
+            std::vector<Point> points_to_buildplate;
             for (const std::pair<Point, Node*>& entry : group)
             {
-                points_to_buildplate.insert(entry.first); //Just the position of the node.
+                points_to_buildplate.emplace_back(entry.first); //Just the position of the node.
             }
             spanning_trees.emplace_back(points_to_buildplate);
         }
@@ -464,11 +469,17 @@ void TreeSupport::dropNodes(std::vector<
             Node* i_node = entry.second;
             for (size_t i_layer = entry.first; i_node != nullptr; ++i_layer, i_node = i_node->parent)
             {
-                contact_nodes[i_layer].erase(i_node);
-                to_free_node_set.insert(i_node);
-                for (Node* neighbour : i_node->merged_neighbours)
+                std::vector<Node*>::iterator to_erase = std::find(contact_nodes[i_layer].begin(), contact_nodes[i_layer].end(), i_node);
+                if (to_erase != contact_nodes[i_layer].end())
                 {
-                    unsupported_branch_leaves.push_front({i_layer, neighbour});
+                    to_free_node_set.insert(*to_erase);
+                    contact_nodes[i_layer].erase(to_erase);
+                    to_free_node_set.insert(i_node);
+                    
+                    for (Node* neighbour : i_node->merged_neighbours)
+                    {
+                        unsupported_branch_leaves.push_front({ i_layer, neighbour });
+                    }
                 }
             }
         }
@@ -485,7 +496,7 @@ void TreeSupport::dropNodes(std::vector<
     to_free_node_set.clear();
 }
 
-void TreeSupport::generateContactPoints(const SliceMeshStorage& mesh, std::vector<std::unordered_set<TreeSupport::Node*>>& contact_nodes)
+void TreeSupport::generateContactPoints(const SliceMeshStorage& mesh, std::vector<std::vector<TreeSupport::Node*>>& contact_nodes)
 {
     const coord_t point_spread = mesh.settings.get<coord_t>("support_tree_branch_distance");
 
@@ -528,6 +539,7 @@ void TreeSupport::generateContactPoints(
         }
     }
 
+
     const coord_t layer_height = mesh.settings.get<coord_t>("layer_height");
     const coord_t z_distance_top = mesh.settings.get<coord_t>("support_top_distance");
     const size_t z_distance_top_layers = round_up_divide(z_distance_top, layer_height) + 1; //Support must always be 1 layer below overhang.
@@ -568,7 +580,7 @@ void TreeSupport::generateContactPoints(
                         constexpr size_t distance_to_top = 0;
                         constexpr bool to_buildplate = true;
                         Node* contact_node = new Node(candidate, distance_to_top, (layer_nr + z_distance_top_layers) % 2, support_roof_layers, to_buildplate, Node::NO_PARENT);
-                        contact_nodes[layer_nr].insert(contact_node);
+                        contact_nodes[layer_nr].emplace_back(contact_node);
                         added = true;
                     }
                 }
@@ -580,7 +592,7 @@ void TreeSupport::generateContactPoints(
                 constexpr size_t distance_to_top = 0;
                 constexpr bool to_buildplate = true;
                 Node* contact_node = new Node(candidate, distance_to_top, layer_nr % 2, support_roof_layers, to_buildplate, Node::NO_PARENT);
-                contact_nodes[layer_nr].insert(contact_node);
+                contact_nodes[layer_nr].emplace_back(contact_node);
             }
         }
         for (const ConstPolygonRef overhang_part : overhang)
@@ -603,12 +615,12 @@ void TreeSupport::generateContactPoints(
     }
 }
 
-void TreeSupport::insertDroppedNode(std::unordered_set<Node*>& nodes_layer, Node* p_node)
+void TreeSupport::insertDroppedNode(std::vector<Node*>& nodes_layer, Node* p_node)
 {
-    std::unordered_set<Node*>::iterator conflicting_node_it = nodes_layer.find(p_node);
+    std::vector<Node*>::iterator conflicting_node_it = std::find(nodes_layer.begin(), nodes_layer.end(), p_node);
     if (conflicting_node_it == nodes_layer.end()) //No conflict.
     {
-        nodes_layer.insert(p_node);
+        nodes_layer.emplace_back(p_node);
         return;
     }
 
@@ -751,4 +763,4 @@ Polygons ModelVolumes::calculateMachineB
     return machine_volume_border;
 }
 
-} //namespace cura
\ No newline at end of file
+} //namespace cura
diff -pruN 1:4.6.2-1/src/TreeSupport.h 1:4.7.1-1/src/TreeSupport.h
--- 1:4.6.2-1/src/TreeSupport.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/TreeSupport.h	2020-08-14 10:34:26.000000000 +0000
@@ -307,7 +307,7 @@ private:
      * save the resulting support polygons to.
      * \param contact_nodes The nodes to draw as support.
      */
-    void drawCircles(SliceDataStorage& storage, const std::vector<std::unordered_set<Node*>>& contact_nodes);
+    void drawCircles(SliceDataStorage& storage, const std::vector<std::vector<Node*>>& contact_nodes);
 
     /*!
      * \brief Drops down the nodes of the tree support towards the build plate.
@@ -321,7 +321,7 @@ private:
      * dropped down. The nodes are dropped to lower layers inside the same
      * vector of layers.
      */
-    void dropNodes(std::vector<std::unordered_set<Node*>>& contact_nodes);
+    void dropNodes(std::vector<std::vector<Node*>>& contact_nodes);
 
     /*!
      * \brief Creates points where support contacts the model.
@@ -336,14 +336,14 @@ private:
      * \return For each layer, a list of points where the tree should connect
      * with the model.
      */
-    void generateContactPoints(const SliceMeshStorage& mesh, std::vector<std::unordered_set<Node*>>& contact_nodes);
+    void generateContactPoints(const SliceMeshStorage& mesh, std::vector<std::vector<Node*>>& contact_nodes);
 
     /*!
      * \brief Add a node to the next layer.
      *
      * If a node is already at that position in the layer, the nodes are merged.
      */
-    void insertDroppedNode(std::unordered_set<Node*>& nodes_layer, Node* node);
+    void insertDroppedNode(std::vector<Node*>& nodes_layer, Node* node);
 };
 
 }
diff -pruN 1:4.6.2-1/src/utils/MinimumSpanningTree.cpp 1:4.7.1-1/src/utils/MinimumSpanningTree.cpp
--- 1:4.6.2-1/src/utils/MinimumSpanningTree.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/utils/MinimumSpanningTree.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -9,12 +9,12 @@
 namespace cura
 {
 
-MinimumSpanningTree::MinimumSpanningTree(std::unordered_set<Point> vertices) : adjacency_graph(prim(vertices))
+MinimumSpanningTree::MinimumSpanningTree(std::vector<Point> vertices) : adjacency_graph(prim(vertices))
 {
     //Just copy over the fields.
 }
 
-auto MinimumSpanningTree::prim(std::unordered_set<Point> vertices) const -> AdjacencyGraph_t
+auto MinimumSpanningTree::prim(std::vector<Point> vertices) const -> AdjacencyGraph_t
 {
     AdjacencyGraph_t result;
     if (vertices.empty())
diff -pruN 1:4.6.2-1/src/utils/MinimumSpanningTree.h 1:4.7.1-1/src/utils/MinimumSpanningTree.h
--- 1:4.6.2-1/src/utils/MinimumSpanningTree.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/utils/MinimumSpanningTree.h	2020-08-14 10:34:26.000000000 +0000
@@ -42,7 +42,7 @@ public:
     /*!
      * \brief Constructs a minimum spanning tree that spans all given vertices.
      */
-    MinimumSpanningTree(std::unordered_set<Point> vertices);
+    MinimumSpanningTree(std::vector<Point> vertices);
 
     /*!
      * \brief Gets the nodes that are adjacent to the specified node.
@@ -73,7 +73,7 @@ private:
      * \param vertices The vertices to span.
      * \return An adjacency graph with for each point one or more edges.
      */
-    AdjacencyGraph_t prim(std::unordered_set<Point> vertices) const;
+    AdjacencyGraph_t prim(std::vector<Point> vertices) const;
 };
 
 }
diff -pruN 1:4.6.2-1/src/utils/polygon.cpp 1:4.7.1-1/src/utils/polygon.cpp
--- 1:4.6.2-1/src/utils/polygon.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/utils/polygon.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -308,91 +308,83 @@ void PolygonRef::simplify(const coord_t
     }
 
     ClipperLib::Path new_path;
-    Point previous = path->at(0);
-    Point current = path->at(1);
-    /* When removing a vertex, we'll check if the delta area of the polygon
-     * remains below allowed_error_distance_squared. However when removing
-     * multiple consecutive vertices, each individual vertex may result in a
-     * delta area below the threshold, while the total effect of removing all of
-     * those vertices results in too much area being removed. So we accumulate
-     * the area that is going to be removed by a streak of consecutive vertices
-     * and don't allow that to exceed allowed_error_distance_squared. */
-    coord_t accumulated_area_removed = previous.X * current.Y - previous.Y * current.X; //Shoelace formula for area of polygon per line segment.
+    Point previous = path->back();
+    Point current = path->at(0);
 
-    for (size_t point_idx = 1; point_idx <= size(); point_idx++)
+    /* When removing a vertex, we check the height of the triangle of the area
+     being removed from the original polygon by the simplification. However,
+     when consecutively removing multiple vertices the height of the previously
+     removed vertices w.r.t. the shortcut path changes.
+     In order to not recompute the new height value of previously removed
+     vertices we compute the height of a representative triangle, which covers
+     the same amount of area as the area being cut off. We use the Shoelace
+     formula to accumulate the area under the removed segments. This works by
+     computing the area in a 'fan' where each of the blades of the fan go from
+     the origin to one of the segments. While removing vertices the area in
+     this fan accumulates. By subtracting the area of the blade connected to
+     the short-cutting segment we obtain the total area of the cutoff region.
+     From this area we compute the height of the representative triangle using
+     the standard formula for a triangle area: A = .5*b*h
+     */
+    coord_t accumulated_area_removed = previous.X * current.Y - previous.Y * current.X; // Twice the Shoelace formula for area of polygon per line segment.
+
+    for (size_t point_idx = 0; point_idx < size(); point_idx++)
     {
         current = path->at(point_idx % size());
 
-        const coord_t length2 = vSize2(current - previous);
-
         //Check if the accumulated area doesn't exceed the maximum.
         Point next;
         if (point_idx + 1 < size())
         {
             next = path->at(point_idx + 1);
         }
-        else if (!new_path.empty())
-        {
+        else if (point_idx + 1 == size() && new_path.size() > 1)
+        { // don't spill over if the [next] vertex will then be equal to [previous]
             next = new_path[0]; //Spill over to new polygon for checking removed area.
         }
         else
         {
-            break; //New polygon also doesn't have any vertices yet, meaning we've completed the loop without adding any vertices. The entire polygon is too small to be significant.
+            next = path->at((point_idx + 1) % size());
         }
-        accumulated_area_removed += current.X * next.Y - current.Y * next.X; //Shoelace formula for area of polygon per line segment.
 
-        const coord_t area_removed_so_far = accumulated_area_removed + next.X * previous.Y - next.Y * previous.X; //Close the polygon.
+        const coord_t removed_area_next = current.X * next.Y - current.Y * next.X; // Twice the Shoelace formula for area of polygon per line segment.
+        const coord_t negative_area_closing = next.X * previous.Y - next.Y * previous.X; // area between the origin and the short-cutting segment
+        accumulated_area_removed += removed_area_next;
+        
+        const coord_t length2 = vSize2(current - previous);
+        const coord_t next_length2 = vSize2(current - next);
+
+        const coord_t area_removed_so_far = accumulated_area_removed + negative_area_closing; // close the shortcut area polygon
         const coord_t base_length_2 = vSize2(next - previous);
+
         if (base_length_2 == 0) //Two line segments form a line back and forth with no area.
         {
             continue; //Remove the vertex.
         }
         //We want to check if the height of the triangle formed by previous, current and next vertices is less than allowed_error_distance_squared.
+        //1/2 L = A           [actual area is half of the computed shoelace value] // Shoelace formula is .5*(...) , but we simplify the computation and take out the .5
         //A = 1/2 * b * h     [triangle area formula]
-        //2A = b * h          [multiply by 2]
-        //h = 2A / b          [divide by b]
-        //h^2 = (2A / b)^2    [square it]
-        //h^2 = (2A)^2 / b^2  [factor the divisor]
-        //h^2 = 4A^2 / b^2    [remove brackets of (2A)^2]
-        const coord_t height_2 = (4 * area_removed_so_far * area_removed_so_far) / base_length_2;
-        if (length2 < smallest_line_segment_squared && height_2 <= allowed_error_distance_squared) //Line is small and removing it doesn't introduce too much error.
+        //L = b * h           [apply above two and take out the 1/2]
+        //h = L / b           [divide by b]
+        //h^2 = (L / b)^2     [square it]
+        //h^2 = L^2 / b^2     [factor the divisor]
+        const coord_t height_2 = area_removed_so_far * area_removed_so_far / base_length_2;
+        if ((height_2 <= 1 //Almost exactly colinear (barring rounding errors).
+            && LinearAlg2D::getDist2FromLine(current, previous, next) <= 1) // make sure that height_2 is not small because of cancellation of positive and negative areas
+            || (length2 < smallest_line_segment_squared
+                && next_length2 < smallest_line_segment_squared // Segments are small
+                && height_2 <= allowed_error_distance_squared) // removing the vertex doesn't introduce too much error.
+        )
         {
             continue; //Remove the vertex.
         }
-        else if (length2 >= smallest_line_segment_squared && new_path.size() > 2 &&
-                (vSize2(new_path[new_path.size() - 2] - new_path.back()) == 0 || LinearAlg2D::getDist2FromLine(current, new_path[new_path.size() - 2], new_path.back()) <= 25)) //Almost exactly straight (barring rounding errors).
-        {
-            new_path.pop_back(); //Remove the previous vertex but still add the new one.
-        }
+
         //Don't remove the vertex.
 
-        accumulated_area_removed = current.X * next.Y - current.Y * next.X;
+        accumulated_area_removed = removed_area_next; // so that in the next iteration it's the area between the origin, [previous] and [current]
         previous = current; //Note that "previous" is only updated if we don't remove the vertex.
         new_path.push_back(current);
     }
-
-    //For the last/first vertex, we didn't check the connection that closes the polygon yet. Add the first vertex back if this connection is too long, or remove it if it's too short.
-    if(!new_path.empty() && vSize2(new_path.back() - new_path[0]) > smallest_line_segment_squared
-        && vSize2(new_path.back() - path->at(0)) >= smallest_line_segment_squared
-        && vSize2(new_path[0] - path->at(0)) >= smallest_line_segment_squared)
-    {
-        new_path.push_back(path->at(0));
-    }
-    if(new_path.size() > 2 && (vSize2(new_path.back() - new_path[0]) < smallest_line_segment_squared || vSize2(new_path.back() - new_path[new_path.size() - 2]) < smallest_line_segment_squared))
-    {
-        if (LinearAlg2D::getDist2FromLine(new_path.back(), new_path[new_path.size() - 2], new_path[0]) < allowed_error_distance_squared)
-        {
-            new_path.pop_back();
-        }
-    }
-    for(size_t i = 0; i < 2; i++) //For the first two points we haven't checked yet if they are almost exactly straight.
-    {
-        if(new_path.size() > 2 && LinearAlg2D::getDist2FromLine(new_path[0], new_path.back(), new_path[1]) <= 25)
-        {
-            new_path.erase(new_path.begin());
-        }
-    }
-
     *path = new_path;
 }
 
@@ -1187,6 +1179,11 @@ void Polygons::splitIntoParts_processPol
     }
 }
 
+Polygons Polygons::tubeShape(const coord_t inner_offset, const coord_t outer_offset) const
+{
+    return this->offset(outer_offset).difference(this->offset(-inner_offset));
+}
+
 unsigned int PartsView::getPartContaining(unsigned int poly_idx, unsigned int* boundary_poly_idx) const
 {
     const PartsView& partsView = *this;
diff -pruN 1:4.6.2-1/src/utils/polygon.h 1:4.7.1-1/src/utils/polygon.h
--- 1:4.6.2-1/src/utils/polygon.h	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/utils/polygon.h	2020-08-14 10:34:26.000000000 +0000
@@ -451,6 +451,13 @@ public:
      * 
      * Removes verts which are connected to line segments which are both too small.
      * Removes verts which detour from a direct line from the previous and next vert by a too small amount.
+     *
+     * Criteria:
+     * 1. Never remove a vertex if either of the connceted segments is larger than \p smallest_line_segment
+     * 2. Never remove a vertex if the distance between that vertex and the final resulting polygon would be higher than \p allowed_error_distance
+     * 3. Simplify uses a heuristic and doesn't neccesarily remove all removable vertices under the above criteria.
+     * 4. But simplify may never violate these criteria.
+     * 5. Unless the segments or the distance is smaller than the rounding error of 5 micron
      * 
      * \param smallest_line_segment_squared maximal squared length of removed line segments
      * \param allowed_error_distance_squared The square of the distance of the middle point to the line segment of the consecutive and previous point for which the middle point is removed
@@ -889,6 +896,13 @@ public:
      * than the `smallest_line_segment`, unless that would introduce a deviation
      * in the contour of more than `allowed_error_distance`.
      *
+     * Criteria:
+     * 1. Never remove a vertex if either of the connceted segments is larger than \p smallest_line_segment
+     * 2. Never remove a vertex if the distance between that vertex and the final resulting polygon would be higher than \p allowed_error_distance
+     * 3. Simplify uses a heuristic and doesn't neccesarily remove all removable vertices under the above criteria.
+     * 4. But simplify may never violate these criteria.
+     * 5. Unless the segments or the distance is smaller than the rounding error of 5 micron
+     * 
      * Vertices which introduce an error of less than 5 microns are removed
      * anyway, even if the segments are longer than the smallest line segment.
      * This makes sure that (practically) colinear line segments are joined into
@@ -938,6 +952,15 @@ public:
      * Each PolygonsPart in the result has an outline as first polygon, whereas the rest are holes.
      */
     std::vector<PolygonsPart> splitIntoParts(bool unionAll = false) const;
+
+    /*!
+     * Utility method for creating the tube (or 'donut') of a shape.
+     * \param inner_offset Offset relative to the original shape-outline towards the inside of the shape. Sort-of like a negative normal offset, except it's the offset part that's kept, not the shape.
+     * \param outer_offset Offset relative to the original shape-outline towards the outside of the shape. Comparable to normal offset.
+     * \return The resulting polygons.
+     */
+    Polygons tubeShape(const coord_t inner_offset, const coord_t outer_offset) const;
+
 private:
     /*!
      * recursive part of \ref Polygons::removeEmptyHoles and \ref Polygons::getEmptyHoles
diff -pruN 1:4.6.2-1/src/utils/polygonUtils.cpp 1:4.7.1-1/src/utils/polygonUtils.cpp
--- 1:4.6.2-1/src/utils/polygonUtils.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/utils/polygonUtils.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -233,24 +233,27 @@ unsigned int PolygonUtils::moveInside(co
             continue;
         Point p0 = poly[poly.size()-2];
         Point p1 = poly.back();
+        // because we compare with vSize2 here (no division by zero), we also need to compare by vSize2 inside the loop
+        // to avoid integer rounding edge cases
         bool projected_p_beyond_prev_segment = dot(p1 - p0, from - p0) >= vSize2(p1 - p0);
         for(const Point& p2 : poly)
         {   
-            // X = A + Normal( B - A ) * ((( B - A ) dot ( P - A )) / VSize( A - B ));
+            // X = A + Normal(B-A) * (((B-A) dot (P-A)) / VSize(B-A));
+            //   = A +       (B-A) *  ((B-A) dot (P-A)) / VSize2(B-A);
             // X = P projected on AB
             const Point& a = p1;
             const Point& b = p2;
             const Point& p = from;
             Point ab = b - a;
             Point ap = p - a;
-            int64_t ab_length = vSize(ab);
-            if(ab_length <= 0) //A = B, i.e. the input polygon had two adjacent points on top of each other.
+            int64_t ab_length2 = vSize2(ab);
+            if(ab_length2 <= 0) //A = B, i.e. the input polygon had two adjacent points on top of each other.
             {
                 p1 = p2; //Skip only one of the points.
                 continue;
             }
-            int64_t ax_length = dot(ab, ap) / ab_length;
-            if (ax_length <= 0) // x is projected to before ab
+            int64_t dot_prod = dot(ab, ap);
+            if (dot_prod <= 0) // x is projected to before ab
             {
                 if (projected_p_beyond_prev_segment)
                 { //  case which looks like:   > .
@@ -280,7 +283,7 @@ unsigned int PolygonUtils::moveInside(co
                     continue;
                 }
             }
-            else if (ax_length >= ab_length) // x is projected to beyond ab
+            else if (dot_prod >= ab_length2) // x is projected to beyond ab
             {
                 projected_p_beyond_prev_segment = true;
                 p0 = p1;
@@ -290,7 +293,7 @@ unsigned int PolygonUtils::moveInside(co
             else 
             { // x is projected to a point properly on the line segment (not onto a vertex). The case which looks like | .
                 projected_p_beyond_prev_segment = false;
-                Point x = a + ab * ax_length / ab_length;
+                Point x = a + ab * dot_prod / ab_length2;
 
                 int64_t dist2 = vSize2(p - x);
                 if (dist2 < bestDist2)
@@ -352,24 +355,27 @@ unsigned int PolygonUtils::moveInside(co
     }
     Point p0 = polygon[polygon.size() - 2];
     Point p1 = polygon.back();
+    // because we compare with vSize2 here (no division by zero), we also need to compare by vSize2 inside the loop
+    // to avoid integer rounding edge cases
     bool projected_p_beyond_prev_segment = dot(p1 - p0, from - p0) >= vSize2(p1 - p0);
     for(const Point& p2 : polygon)
     {
-        // X = A + Normal( B - A ) * ((( B - A ) dot ( P - A )) / VSize( A - B ));
+        // X = A + Normal(B-A) * (((B-A) dot (P-A)) / VSize(B-A));
+        //   = A +       (B-A) *  ((B-A) dot (P-A)) / VSize2(B-A);
         // X = P projected on AB
         const Point& a = p1;
         const Point& b = p2;
         const Point& p = from;
         Point ab = b - a;
         Point ap = p - a;
-        int64_t ab_length = vSize(ab);
-        if(ab_length <= 0) //A = B, i.e. the input polygon had two adjacent points on top of each other.
+        int64_t ab_length2 = vSize2(ab);
+        if(ab_length2 <= 0) //A = B, i.e. the input polygon had two adjacent points on top of each other.
         {
             p1 = p2; //Skip only one of the points.
             continue;
         }
-        int64_t ax_length = dot(ab, ap) / ab_length;
-        if (ax_length <= 0) // x is projected to before ab
+        int64_t dot_prod = dot(ab, ap);
+        if (dot_prod <= 0) // x is projected to before ab
         {
             if (projected_p_beyond_prev_segment)
             { //  case which looks like:   > .
@@ -401,7 +407,7 @@ unsigned int PolygonUtils::moveInside(co
                 continue;
             }
         }
-        else if (ax_length >= ab_length) // x is projected to beyond ab
+        else if (dot_prod >= ab_length2) // x is projected to beyond ab
         {
             projected_p_beyond_prev_segment = true;
             p0 = p1;
@@ -411,7 +417,7 @@ unsigned int PolygonUtils::moveInside(co
         else
         { // x is projected to a point properly on the line segment (not onto a vertex). The case which looks like | .
             projected_p_beyond_prev_segment = false;
-            Point x = a + ab * ax_length / ab_length;
+            Point x = a + ab * dot_prod / ab_length2;
 
             int64_t dist2 = vSize2(p - x);
             if (dist2 < bestDist2)
diff -pruN 1:4.6.2-1/src/WallsComputation.cpp 1:4.7.1-1/src/WallsComputation.cpp
--- 1:4.6.2-1/src/WallsComputation.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/src/WallsComputation.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -5,6 +5,7 @@
 #include "sliceDataStorage.h"
 #include "WallsComputation.h"
 #include "settings/types/Ratio.h"
+#include "settings/EnumSettings.h"
 #include "utils/polygonUtils.h"
 
 namespace cura {
@@ -52,7 +53,9 @@ void WallsComputation::generateInsets(Sl
         line_width_x *= train_wall_x.settings.get<Ratio>("initial_layer_line_width_factor");
     }
 
-    const bool recompute_outline_based_on_outer_wall = (settings.get<bool>("support_enable") || settings.get<bool>("support_tree_enable")) && !settings.get<bool>("fill_outline_gaps");
+    const bool recompute_outline_based_on_outer_wall =
+        settings.get<bool>("support_enable") &&
+        !settings.get<bool>("fill_outline_gaps");
     for(size_t i = 0; i < inset_count; i++)
     {
         part->insets.push_back(Polygons());
diff -pruN 1:4.6.2-1/tests/integration/SlicePhaseTest.cpp 1:4.7.1-1/tests/integration/SlicePhaseTest.cpp
--- 1:4.6.2-1/tests/integration/SlicePhaseTest.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/tests/integration/SlicePhaseTest.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -39,6 +39,10 @@ class SlicePhaseTest : public testing::T
         scene.settings.add("meshfix_maximum_deviation", "0.02");
         scene.settings.add("xy_offset", "0");
         scene.settings.add("xy_offset_layer_0", "0");
+        scene.settings.add("support_mesh", "false");
+        scene.settings.add("anti_overhang_mesh", "false");
+        scene.settings.add("cutting_mesh", "false");
+        scene.settings.add("infill_mesh", "false");
     }
 };
 
diff -pruN 1:4.6.2-1/tests/test_global_settings.txt 1:4.7.1-1/tests/test_global_settings.txt
--- 1:4.6.2-1/tests/test_global_settings.txt	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/tests/test_global_settings.txt	2020-08-14 10:34:26.000000000 +0000
@@ -1,516 +1,509 @@
-bridge_skin_material_flow_3=110
-speed_wall_0=20
-infill_wipe_dist=0
-machine_extruder_count=2
-raft_surface_jerk=25
-material_bed_temperature_layer_0=60
-jerk_support_roof=5
-roofing_pattern=lines
-gradual_support_infill_step_height=1
-wireframe_up_half_speed=0.3
-support_angle=60
-top_bottom_pattern_0=lines
-support_bottom_extruder_nr=0
-wall_line_width_x=0.3
-skirt_brim_speed=20
-raft_fan_speed=0
-support_roof_enable=False
-ooze_shield_dist=2
-prime_blob_enable=True
-acceleration_support=2000
-machine_width=233
-skirt_brim_line_width=0.35
-raft_airgap=0.3
-infill_overlap=0
-magic_fuzzy_skin_point_dist=0.8
-material_extrusion_cool_down_speed=0.7
-cool_fan_speed=50
-support_tree_collision_resolution=0.175
-print_sequence=all_at_once
-conical_overhang_angle=50
-machine_show_variants=False
-raft_base_jerk=25
-wireframe_top_delay=0
-wireframe_flat_delay=0.1
-machine_acceleration=3000
-remove_empty_first_layers=True
-wireframe_fall_down=0.5
-bridge_skin_density_3=80
-platform_adhesion=0
-acceleration_wall_x=1000
-retraction_extra_prime_amount=0
-speed_topbottom=20
-support_roof_pattern=concentric
-travel=0
-alternate_carve_order=True
-adhesion_type=brim
-bridge_skin_density=100
-raft_base_thickness=0.2412
-bridge_settings_enabled=False
-support_bottom_stair_step_width=5.0
-support_tree_branch_diameter_angle=5
-jerk_topbottom=5
-bridge_skin_speed_2=10.0
-wireframe_roof_fall_down=2
-raft_smoothing=5
-support=0
-cutting_mesh=False
-relative_extrusion=False
-support_fan_enable=False
-support_infill_rate=0
-bridge_skin_material_flow=60
-infill_wall_line_count=0
-experimental=0
-machine_center_is_zero=False
-infill=0
-infill_enable_travel_optimization=False
-raft_base_acceleration=4000
-switch_extruder_prime_speed=15
-speed_travel=250
-support_minimal_diameter=3.0
-acceleration_support_interface=500
-material_flow=100
-connect_skin_polygons=False
-raft_base_line_spacing=1.6
-support_bottom_distance=0.2
-wall_thickness=1
-magic_fuzzy_skin_enabled=False
-raft_surface_thickness=0.2
-material_print_temperature=200
-raft_interface_line_spacing=0.8999999999999999
-wall_0_wipe_dist=0.2
-support_roof_height=1
-support_conical_angle=30
-speed_roofing=20
-anti_overhang_mesh=False
-meshfix_union_all_remove_holes=False
-wireframe_roof_inset=3
-wireframe_drag_along=0.6
-wireframe_flow_flat=100
-support_interface_skip_height=0.3
-draft_shield_height=10
-top_thickness=1
-machine_endstop_positive_direction_y=False
-adaptive_layer_height_enabled=False
-skin_line_width=0.35
-speed_support_bottom=23
-raft_surface_acceleration=4000
-carve_multiple_volumes=True
-start_layers_at_same_position=False
-coasting_enable=False
-filter_out_tiny_gaps=True
-support_bottom_line_width=0.35
-support_conical_enabled=False
-mesh_position_x=0
-raft_surface_speed=17.5
-material_adhesion_tendency=10
-bridge_fan_speed_3=0
-draft_shield_enabled=False
-switch_extruder_retraction_speed=20
-smooth_spiralized_contours=True
-raft_interface_line_width=0.7
-connect_infill_polygons=False
-top_skin_expand_distance=0.95
-speed_prime_tower=20
-retraction_min_travel=5
-infill_pattern=lines
-material_print_temp_prepend=True
-wall_line_width=0.35
-machine_name=Ultimaker 3
-retraction_hop_enabled=True
-fill_perimeter_gaps=everywhere
-z_seam_y=645
-meshfix_extensive_stitching=False
-ironing_enabled=False
-jerk_wall=10
-bridge_skin_speed=10.0
-top_bottom_thickness=1
-acceleration_support_bottom=500
-support_roof_line_distance=0.35
-wall_line_width_0=0.35
-machine_min_cool_heat_time_window=15
-support_interface_pattern=concentric
-zig_zaggify_infill=True
-support_tree_enable=True
-roofing_layer_count=0
-meshfix_keep_open_polygons=False
-support_interface_extruder_nr=0
-wall_0_extruder_nr=-1
-bridge_wall_min_length=5
-support_mesh_drop_down=True
-wall_line_count=3
-retract_at_layer_change=False
-machine_steps_per_mm_y=50
-skin_outline_count=1
-retraction_count_max=10
-material_guid=
-acceleration_infill=4000
-time=14:47:24
-layer_0_z_overlap=0.15
-speed_support_infill=20
-support_interface_line_width=0.35
-mold_roof_height=0.5
-machine_heat_zone_length=16
-support_tree_angle=40
-support_bottom_stair_step_height=0.3
-meshfix_maximum_resolution=0.04
-raft_interface_fan_speed=0
-machine_nozzle_id=unknown
-retraction_speed=25
-jerk_layer_0=5
-support_interface_enable=False
-speed_equalize_flow_max=150
-cool_min_speed=5
-magic_mesh_surface_mode=normal
-acceleration_roofing=500
-infill_sparse_thickness=0.2
-wireframe_strategy=compensate
-cross_infill_density_image=
-z_seam_relative=False
-raft_surface_fan_speed=0
-fill_outline_gaps=False
-support_join_distance=2.0
-machine_nozzle_heat_up_speed=1.4
-support_line_width=0.35
-bridge_enable_more_layers=True
-infill_mesh_order=0
-retraction_hop=2
-speed_layer_0=20
-prime_tower_line_width=0.35
-ironing_line_spacing=0.1
-jerk_print_layer_0=5
-dual=0
-machine_max_feedrate_x=300
-max_skin_angle_for_expansion=90
-jerk_infill=25
-machine_endstop_positive_direction_z=True
-bridge_fan_speed_2=0
-wall_extruder_nr=-1
-retraction_amount=6.5
-travel_avoid_distance=3
-coasting_speed=90
-support_z_distance=0.4
-blackmagic=0
-raft_surface_layers=2
-gantry_height=60
-raft_interface_jerk=25
-acceleration_topbottom=500
-infill_sparse_density=100
-wireframe_printspeed_flat=5
-speed_wall=30
-skin_overlap=10
-jerk_skirt_brim=5
-limit_support_retractions=True
-switch_extruder_retraction_speeds=20
-skirt_brim_minimal_length=250
-cool_fan_speed_min=50
-machine_disallowed_areas=[[[92.8, -53.4], [92.8, -97.5], [116.5, -97.5], [116.5, -53.4]], [[73.8, 107.5], [73.8, 100.5], [116.5, 100.5], [116.5, 107.5]], [[74.6, 107.5], [74.6, 100.5], [116.5, 100.5], [116.5, 107.5]], [[74.9, -97.5], [74.9, -107.5], [116.5, -107.5], [116.5, -97.5]], [[-116.5, -103.5], [-116.5, -107.5], [-100.9, -107.5], [-100.9, -103.5]], [[-116.5, 105.8], [-96.9, 105.8], [-96.9, 107.5], [-116.5, 107.5]]]
-draft_shield_height_limitation=full
-travel_retract_before_outer_wall=True
-date=30-08-2018
-travel_compensate_overlapping_walls_enabled=True
-support_offset=0.2
-wireframe_enabled=False
-support_use_towers=True
-mold_angle=40
-infill_line_width=0.42
-prime_tower_min_volume=6
-bridge_skin_speed_3=10.0
-bottom_skin_preshrink=0.95
-gradual_support_infill_steps=0
-top_bottom_pattern=lines
-acceleration_ironing=500
-spaghetti_infill_enabled=False
-conical_overhang_enabled=False
-material_standby_temperature=100
-skin_overlap_mm=0.032499999999999994
-raft_base_fan_speed=0
-raft_base_line_width=0.8
-mesh_rotation_matrix=[[1,0,0], [0,1,0], [0,0,1]]
-support_pattern=zigzag
-cooling=0
-wireframe_printspeed_bottom=5
-support_roof_line_width=0.35
-skirt_gap=3
-wireframe_top_jump=0.6
-speed_support=20
-acceleration_print=4000
-speed_wall_x=30
-support_xy_distance_overhang=0.35
-speed_equalize_flow_enabled=False
-material_bed_temp_wait=True
-acceleration_print_layer_0=500
-material_surface_energy=100
-speed_print_layer_0=20
-brim_outside_only=True
-support_tower_roof_angle=65
-extruder_prime_pos_x=0
-meshfix_union_all=True
-machine_head_with_fans_polygon=[[-41.9, -45.8], [-41.9, 33.9], [59.9, 33.9], [59.9, -45.8]]
-command_line_settings=0
-z_seam_corner=z_seam_corner_inner
-machine_steps_per_mm_x=50
-default_material_bed_temperature=60
-cool_min_layer_time=5
-retraction_prime_speed=15
-flow_rate_max_extrusion_offset=0
-magic_fuzzy_skin_point_density=1.25
-material_final_print_temperature=185
-spaghetti_max_height=2.0
-coasting_volume=0.064
-skirt_line_count=1
-machine_max_feedrate_e=45
-wireframe_height=3
-acceleration_prime_tower=2000
-machine_gcode_flavor=Griffin
-machine_height=200
-jerk_travel=30
-machine_max_feedrate_y=300
-prime_tower_position_y=184.56
-machine_max_feedrate_z=40
-infill_extruder_nr=1
-infill_before_walls=True
-resolution=0
-mold_width=5
-line_width=0.35
-raft_surface_line_width=0.35
-jerk_ironing=5
-retraction_combing_max_distance=0
-acceleration_layer_0=500
-coasting_min_volume=0.8
-raft_margin=15
-support_tower_diameter=3.0
-wireframe_roof_outer_delay=0.2
-cool_fan_speed_max=100
-machine_endstop_positive_direction_x=False
-speed_support_roof=23
-ironing_only_highest_layer=False
-support_conical_min_width=5.0
-bridge_wall_coast=100
-alternate_extra_perimeter=False
-support_zag_skip_count=0
-initial_extruder_nr=0
-roofing_angles=[ ]
-zig_zaggify_support=False
-wireframe_nozzle_clearance=1
-wireframe_printspeed=5
-jerk_print=25
-infill_offset_x=0
-machine_max_acceleration_e=10000
-bottom_skin_expand_distance=0.95
-raft_interface_speed=13.125
-acceleration_wall_0=500
-spaghetti_max_infill_angle=10
-support_bottom_line_distance=0.35
-machine_nozzle_tip_outer_diameter=1
-prime_tower_flow=100
-optimize_wall_printing_order=True
-support_infill_extruder_nr=0
-switch_extruder_retraction_amount=8
-bottom_layers=999999
-support_mesh=False
-support_infill_sparse_thickness=0.2
-expand_skins_expand_distance=0.95
-retraction_combing=off
-support_initial_layer_line_distance=0
-support_enable=False
-jerk_enabled=True
-extruder_prime_pos_abs=True
-z_seam_x=116.5
-min_skin_width_for_expansion=0.0
-print_bed_temperature=60
-travel_avoid_other_parts=True
-support_connect_zigzags=True
-acceleration_support_roof=500
-magic_fuzzy_skin_thickness=0.3
-support_line_distance=0
-acceleration_support_infill=2000
-min_infill_area=0
-bridge_skin_support_threshold=50
-draft_shield_dist=10
-machine_max_acceleration_x=9000
-infill_offset_y=0
-prime_tower_size=20
-material_print_temp_wait=True
-minimum_polygon_circumference=1.0
-support_interface_density=100
-infill_support_angle=40
-support_roof_extruder_nr=0
-machine_shape=rectangular
-initial_layer_line_width_factor=120
-default_material_print_temperature=200
-infill_mesh=False
-machine_nozzle_expansion_angle=45
-skin_angles=[ ]
-brim_line_count=17
-machine_settings=0
-support_extruder_nr_layer_0=0
-meshfix_maximum_travel_resolution=0.2857142857142857
-infill_angles=[ ]
-ironing_inset=0.175
-cool_fan_speed_0=0
-machine_max_jerk_xy=20.0
-max_feedrate_z_override=0
-nozzle_disallowed_areas=[]
-xy_offset_layer_0=0
-machine_buildplate_type=glass
-z_seam_type=sharpest_corner
-jerk_prime_tower=15
-extruder_prime_pos_y=0
-brim_width=7
-jerk_support=15
-adhesion_extruder_nr=0
-jerk_travel_layer_0=6.0
-support_tree_branch_diameter=2
-outer_inset_first=False
-gradual_infill_steps=0
-extruder_prime_pos_z=0
-support_bottom_density=100
-travel_compensate_overlapping_walls_0_enabled=True
-support_bottom_enable=False
-machine_max_acceleration_y=9000
-raft_surface_line_spacing=0.35
-bridge_wall_material_flow=50
-wall_min_flow=0
-cool_fan_full_at_height=1.0010000000000001
-center_object=False
-adaptive_layer_height_threshold=200.0
-speed_travel_layer_0=142.85714285714286
-support_bottom_height=1
-travel_avoid_supports=False
-speed_support_interface=20
-machine_start_gcode=
-prime_tower_position_x=175.70000000000002
-infill_overlap_mm=0
-multiple_mesh_overlap=0
-machine_nozzle_cool_down_speed=0.8
-prime_tower_wipe_enabled=False
-prime_tower_enable=False
-speed_print=35
-raft_base_speed=13.125
-retraction_retract_speed=25
-machine_end_gcode=G91 ;Relative movement\nG0 F15000 X8.0 Z0.5 E-4.5 ;Wiping+material retraction\nG0 F10000 Z1.5 E4.5 ;Compensation for the retraction\nG90 ;Disable relative movement
-support_tree_wall_count=1
-wireframe_roof_drag_along=0.8
-material_shrinkage_percentage=0
-machine_steps_per_mm_e=1600
-xy_offset=0
-cross_support_density_image=
-print_temperature=200
-spaghetti_inset=0.2
-spaghetti_infill_stepped=True
-machine_max_acceleration_z=100
-magic_spiralize=False
-top_bottom_extruder_nr=-1
-support_extruder_nr=0
-support_xy_overrides_z=z_overrides_xy
-material_flow_layer_0=100
-day=Thu
-bottom_thickness=1
-wall_min_flow_retract=False
-machine_use_extruder_offset_to_offset_coords=True
-raft_acceleration=4000
-cool_lift_head=False
-ooze_shield_angle=60
-shell=0
-layer_start_x=213.0
-material_print_temperature_layer_0=205
-machine_minimum_feedrate=0.0
-flow_rate_extrusion_offset_factor=100
-acceleration_enabled=True
-wireframe_straight_before_down=20
-machine_nozzle_temp_enabled=True
-speed_infill=35
-jerk_roofing=5
-material=0
-jerk_support_bottom=5
-raft_interface_acceleration=4000
-raft_jerk=25
-wireframe_flow=100
-ooze_shield_enabled=True
-support_bottom_pattern=concentric
-gradual_infill_step_height=1.5
-acceleration_travel_layer_0=625.0
-mesh_position_y=0
-roofing_line_width=0.35
-machine_nozzle_size=0.4
-machine_head_polygon=[[-1, 1], [-1, -1], [1, -1], [1, 1]]
-wireframe_flow_connection=100
-adaptive_layer_height_variation=0.1
-wall_0_inset=0
-travel_compensate_overlapping_walls_x_enabled=True
-support_skip_some_zags=False
-speed=0
-layer_start_y=198.0
-spaghetti_infill_extra_volume=0
-acceleration_wall=1000
-extruders_enabled_count=2
-machine_depth=215
-machine_firmware_retract=False
-wireframe_printspeed_down=5
-roofing_extruder_nr=-1
-adaptive_layer_height_variation_step=0.01
-jerk_wall_x=10
-machine_max_jerk_z=0.4
-infill_line_distance=0.42
-bridge_fan_speed=100
-material_bed_temp_prepend=True
-cool_fan_full_layer=6
-jerk_support_interface=5
-skin_preshrink=0.95
-support_tree_branch_distance=1
-infill_multiplier=1
-spaghetti_flow=20
-machine_max_jerk_e=5.0
-material_bed_temperature=60
-sub_div_rad_add=0.3
-bridge_skin_material_flow_2=100
-cool_fan_enabled=True
-machine_steps_per_mm_z=50
-bridge_skin_density_2=75
-speed_slowdown_layers=2
-support_type=buildplate
-acceleration_travel=5000
-cool_min_layer_time_fan_speed_max=10
-infill_support_enabled=False
-material_initial_print_temperature=190
-wireframe_bottom_delay=0
-bridge_wall_speed=10.0
-mold_enabled=False
-bridge_wall_max_overhang=100
-skin_alternate_rotation=False
-slicing_tolerance=middle
-layer_height=0.2
-retraction_extrusion_window=1
-raft_speed=17.5
-mesh_position_z=0
-cross_infill_pocket_size=0.42
-support_supported_skin_fan_speed=100
-support_roof_density=100
-jerk_wall_0=5
-support_wall_count=0
-ironing_pattern=zigzag
-top_layers=0
-support_xy_distance=0.875
-wireframe_printspeed_up=5
-machine_feeder_wheel_diameter=10.0
-material_flow_dependent_temperature=False
-skin_no_small_gaps_heuristic=True
-speed_ironing=13.333333333333334
-wall_x_extruder_nr=-1
-top_skin_preshrink=0.95
-support_skip_zag_per_mm=20
-meshfix=0
-machine_heated_bed=True
-support_tree_wall_thickness=0.35
-support_top_distance=0.4
-retraction_hop_after_extruder_switch=True
-layer_height_0=0.201
-acceleration_skirt_brim=500
-jerk_support_infill=15
-material_flow_temp_graph=[[3.5,200],[7.0,240]]
-retraction_enable=True
-support_interface_height=1
-raft_interface_thickness=0.30000000000000004
-retraction_hop_only_when_collides=True
-ironing_flow=10.0
+bridge_skin_material_flow_3=110
+speed_wall_0=20
+infill_wipe_dist=0
+machine_extruder_count=2
+raft_surface_jerk=25
+material_bed_temperature_layer_0=60
+jerk_support_roof=5
+roofing_pattern=lines
+gradual_support_infill_step_height=1
+wireframe_up_half_speed=0.3
+support_angle=60
+top_bottom_pattern_0=lines
+support_bottom_extruder_nr=0
+wall_line_width_x=0.3
+skirt_brim_speed=20
+raft_fan_speed=0
+support_roof_enable=False
+ooze_shield_dist=2
+prime_blob_enable=True
+acceleration_support=2000
+machine_width=233
+skirt_brim_line_width=0.35
+raft_airgap=0.3
+infill_overlap=0
+magic_fuzzy_skin_point_dist=0.8
+material_extrusion_cool_down_speed=0.7
+cool_fan_speed=50
+support_tree_collision_resolution=0.175
+print_sequence=all_at_once
+conical_overhang_angle=50
+machine_show_variants=False
+raft_base_jerk=25
+wireframe_top_delay=0
+wireframe_flat_delay=0.1
+machine_acceleration=3000
+remove_empty_first_layers=True
+wireframe_fall_down=0.5
+bridge_skin_density_3=80
+platform_adhesion=0
+acceleration_wall_x=1000
+retraction_extra_prime_amount=0
+speed_topbottom=20
+support_roof_pattern=concentric
+travel=0
+alternate_carve_order=True
+adhesion_type=brim
+bridge_skin_density=100
+raft_base_thickness=0.2412
+bridge_settings_enabled=False
+support_bottom_stair_step_width=5.0
+support_tree_branch_diameter_angle=5
+jerk_topbottom=5
+bridge_skin_speed_2=10.0
+wireframe_roof_fall_down=2
+raft_smoothing=5
+support=0
+cutting_mesh=False
+relative_extrusion=False
+support_fan_enable=False
+support_infill_rate=0
+bridge_skin_material_flow=60
+infill_wall_line_count=0
+experimental=0
+machine_center_is_zero=False
+infill=0
+infill_enable_travel_optimization=False
+raft_base_acceleration=4000
+switch_extruder_prime_speed=15
+speed_travel=250
+support_minimal_diameter=3.0
+acceleration_support_interface=500
+material_flow=100
+connect_skin_polygons=False
+raft_base_line_spacing=1.6
+support_bottom_distance=0.2
+wall_thickness=1
+magic_fuzzy_skin_enabled=False
+raft_surface_thickness=0.2
+material_print_temperature=200
+raft_interface_line_spacing=0.8999999999999999
+wall_0_wipe_dist=0.2
+support_roof_height=1
+support_conical_angle=30
+speed_roofing=20
+anti_overhang_mesh=False
+meshfix_union_all_remove_holes=False
+wireframe_roof_inset=3
+wireframe_drag_along=0.6
+wireframe_flow_flat=100
+support_interface_skip_height=0.3
+draft_shield_height=10
+top_thickness=1
+machine_endstop_positive_direction_y=False
+adaptive_layer_height_enabled=False
+skin_line_width=0.35
+speed_support_bottom=23
+raft_surface_acceleration=4000
+carve_multiple_volumes=True
+start_layers_at_same_position=False
+coasting_enable=False
+filter_out_tiny_gaps=True
+support_bottom_line_width=0.35
+support_conical_enabled=False
+mesh_position_x=0
+raft_surface_speed=17.5
+material_adhesion_tendency=10
+bridge_fan_speed_3=0
+draft_shield_enabled=False
+switch_extruder_retraction_speed=20
+smooth_spiralized_contours=True
+raft_interface_line_width=0.7
+connect_infill_polygons=False
+top_skin_expand_distance=0.95
+speed_prime_tower=20
+retraction_min_travel=5
+infill_pattern=lines
+material_print_temp_prepend=True
+wall_line_width=0.35
+machine_name=Ultimaker 3
+retraction_hop_enabled=True
+fill_perimeter_gaps=everywhere
+z_seam_y=645
+meshfix_extensive_stitching=False
+ironing_enabled=False
+jerk_wall=10
+bridge_skin_speed=10.0
+top_bottom_thickness=1
+acceleration_support_bottom=500
+support_roof_line_distance=0.35
+wall_line_width_0=0.35
+machine_min_cool_heat_time_window=15
+support_interface_pattern=concentric
+zig_zaggify_infill=True
+support_structure=normal
+roofing_layer_count=0
+meshfix_keep_open_polygons=False
+support_interface_extruder_nr=0
+wall_0_extruder_nr=-1
+bridge_wall_min_length=5
+support_mesh_drop_down=True
+wall_line_count=3
+retract_at_layer_change=False
+machine_steps_per_mm_y=50
+skin_outline_count=1
+retraction_count_max=10
+material_guid=
+acceleration_infill=4000
+time=14:47:24
+layer_0_z_overlap=0.15
+speed_support_infill=20
+support_interface_line_width=0.35
+mold_roof_height=0.5
+machine_heat_zone_length=16
+support_tree_angle=40
+support_bottom_stair_step_height=0.3
+meshfix_maximum_resolution=0.04
+raft_interface_fan_speed=0
+machine_nozzle_id=unknown
+retraction_speed=25
+jerk_layer_0=5
+support_interface_enable=False
+speed_equalize_flow_max=150
+cool_min_speed=5
+magic_mesh_surface_mode=normal
+acceleration_roofing=500
+infill_sparse_thickness=0.2
+wireframe_strategy=compensate
+cross_infill_density_image=
+z_seam_relative=False
+raft_surface_fan_speed=0
+fill_outline_gaps=False
+support_join_distance=2.0
+machine_nozzle_heat_up_speed=1.4
+support_line_width=0.35
+bridge_enable_more_layers=True
+infill_mesh_order=0
+retraction_hop=2
+speed_layer_0=20
+prime_tower_line_width=0.35
+ironing_line_spacing=0.1
+jerk_print_layer_0=5
+dual=0
+machine_max_feedrate_x=300
+max_skin_angle_for_expansion=90
+jerk_infill=25
+machine_endstop_positive_direction_z=True
+bridge_fan_speed_2=0
+wall_extruder_nr=-1
+retraction_amount=6.5
+travel_avoid_distance=3
+coasting_speed=90
+support_z_distance=0.4
+blackmagic=0
+raft_surface_layers=2
+gantry_height=60
+raft_interface_jerk=25
+acceleration_topbottom=500
+infill_sparse_density=100
+wireframe_printspeed_flat=5
+speed_wall=30
+skin_overlap=10
+jerk_skirt_brim=5
+limit_support_retractions=True
+switch_extruder_retraction_speeds=20
+skirt_brim_minimal_length=250
+cool_fan_speed_min=50
+machine_disallowed_areas=[[[92.8, -53.4], [92.8, -97.5], [116.5, -97.5], [116.5, -53.4]], [[73.8, 107.5], [73.8, 100.5], [116.5, 100.5], [116.5, 107.5]], [[74.6, 107.5], [74.6, 100.5], [116.5, 100.5], [116.5, 107.5]], [[74.9, -97.5], [74.9, -107.5], [116.5, -107.5], [116.5, -97.5]], [[-116.5, -103.5], [-116.5, -107.5], [-100.9, -107.5], [-100.9, -103.5]], [[-116.5, 105.8], [-96.9, 105.8], [-96.9, 107.5], [-116.5, 107.5]]]
+draft_shield_height_limitation=full
+travel_retract_before_outer_wall=True
+date=30-08-2018
+travel_compensate_overlapping_walls_enabled=True
+support_offset=0.2
+wireframe_enabled=False
+support_use_towers=True
+mold_angle=40
+infill_line_width=0.42
+prime_tower_min_volume=6
+bridge_skin_speed_3=10.0
+bottom_skin_preshrink=0.95
+gradual_support_infill_steps=0
+top_bottom_pattern=lines
+acceleration_ironing=500
+conical_overhang_enabled=False
+material_standby_temperature=100
+skin_overlap_mm=0.032499999999999994
+raft_base_fan_speed=0
+raft_base_line_width=0.8
+mesh_rotation_matrix=[[1,0,0], [0,1,0], [0,0,1]]
+support_pattern=zigzag
+cooling=0
+wireframe_printspeed_bottom=5
+support_roof_line_width=0.35
+skirt_gap=3
+wireframe_top_jump=0.6
+speed_support=20
+acceleration_print=4000
+speed_wall_x=30
+support_xy_distance_overhang=0.35
+speed_equalize_flow_enabled=False
+material_bed_temp_wait=True
+acceleration_print_layer_0=500
+material_surface_energy=100
+speed_print_layer_0=20
+brim_outside_only=True
+support_tower_roof_angle=65
+extruder_prime_pos_x=0
+meshfix_union_all=True
+machine_head_with_fans_polygon=[[-41.9, -45.8], [-41.9, 33.9], [59.9, 33.9], [59.9, -45.8]]
+command_line_settings=0
+z_seam_corner=z_seam_corner_inner
+machine_steps_per_mm_x=50
+default_material_bed_temperature=60
+cool_min_layer_time=5
+retraction_prime_speed=15
+flow_rate_max_extrusion_offset=0
+magic_fuzzy_skin_point_density=1.25
+material_final_print_temperature=185
+coasting_volume=0.064
+skirt_line_count=1
+machine_max_feedrate_e=45
+wireframe_height=3
+acceleration_prime_tower=2000
+machine_gcode_flavor=Griffin
+machine_height=200
+jerk_travel=30
+machine_max_feedrate_y=300
+prime_tower_position_y=184.56
+machine_max_feedrate_z=40
+infill_extruder_nr=1
+infill_before_walls=True
+resolution=0
+mold_width=5
+line_width=0.35
+raft_surface_line_width=0.35
+jerk_ironing=5
+retraction_combing_max_distance=0
+acceleration_layer_0=500
+coasting_min_volume=0.8
+raft_margin=15
+support_tower_diameter=3.0
+wireframe_roof_outer_delay=0.2
+cool_fan_speed_max=100
+machine_endstop_positive_direction_x=False
+speed_support_roof=23
+ironing_only_highest_layer=False
+support_conical_min_width=5.0
+bridge_wall_coast=100
+alternate_extra_perimeter=False
+support_zag_skip_count=0
+initial_extruder_nr=0
+roofing_angles=[ ]
+zig_zaggify_support=False
+wireframe_nozzle_clearance=1
+wireframe_printspeed=5
+jerk_print=25
+infill_offset_x=0
+machine_max_acceleration_e=10000
+bottom_skin_expand_distance=0.95
+raft_interface_speed=13.125
+acceleration_wall_0=500
+support_bottom_line_distance=0.35
+machine_nozzle_tip_outer_diameter=1
+prime_tower_flow=100
+optimize_wall_printing_order=True
+support_infill_extruder_nr=0
+switch_extruder_retraction_amount=8
+bottom_layers=999999
+support_mesh=False
+support_infill_sparse_thickness=0.2
+expand_skins_expand_distance=0.95
+retraction_combing=off
+support_initial_layer_line_distance=0
+support_enable=False
+jerk_enabled=True
+extruder_prime_pos_abs=True
+z_seam_x=116.5
+min_skin_width_for_expansion=0.0
+print_bed_temperature=60
+travel_avoid_other_parts=True
+support_connect_zigzags=True
+acceleration_support_roof=500
+magic_fuzzy_skin_thickness=0.3
+support_line_distance=0
+acceleration_support_infill=2000
+min_infill_area=0
+bridge_skin_support_threshold=50
+draft_shield_dist=10
+machine_max_acceleration_x=9000
+infill_offset_y=0
+prime_tower_size=20
+material_print_temp_wait=True
+minimum_polygon_circumference=1.0
+support_interface_density=100
+infill_support_angle=40
+support_roof_extruder_nr=0
+machine_shape=rectangular
+initial_layer_line_width_factor=120
+default_material_print_temperature=200
+infill_mesh=False
+machine_nozzle_expansion_angle=45
+skin_angles=[ ]
+brim_line_count=17
+machine_settings=0
+support_extruder_nr_layer_0=0
+meshfix_maximum_travel_resolution=0.2857142857142857
+infill_angles=[ ]
+ironing_inset=0.175
+cool_fan_speed_0=0
+machine_max_jerk_xy=20.0
+max_feedrate_z_override=0
+nozzle_disallowed_areas=[]
+xy_offset_layer_0=0
+machine_buildplate_type=glass
+z_seam_type=sharpest_corner
+jerk_prime_tower=15
+extruder_prime_pos_y=0
+brim_width=7
+jerk_support=15
+adhesion_extruder_nr=0
+jerk_travel_layer_0=6.0
+support_tree_branch_diameter=2
+outer_inset_first=False
+gradual_infill_steps=0
+extruder_prime_pos_z=0
+support_bottom_density=100
+travel_compensate_overlapping_walls_0_enabled=True
+support_bottom_enable=False
+machine_max_acceleration_y=9000
+raft_surface_line_spacing=0.35
+bridge_wall_material_flow=50
+wall_min_flow=0
+cool_fan_full_at_height=1.0010000000000001
+center_object=False
+adaptive_layer_height_threshold=200.0
+speed_travel_layer_0=142.85714285714286
+support_bottom_height=1
+travel_avoid_supports=False
+speed_support_interface=20
+machine_start_gcode=
+prime_tower_position_x=175.70000000000002
+infill_overlap_mm=0
+multiple_mesh_overlap=0
+machine_nozzle_cool_down_speed=0.8
+prime_tower_wipe_enabled=False
+prime_tower_enable=False
+speed_print=35
+raft_base_speed=13.125
+retraction_retract_speed=25
+machine_end_gcode=G91 ;Relative movement\nG0 F15000 X8.0 Z0.5 E-4.5 ;Wiping+material retraction\nG0 F10000 Z1.5 E4.5 ;Compensation for the retraction\nG90 ;Disable relative movement
+support_tree_wall_count=1
+wireframe_roof_drag_along=0.8
+material_shrinkage_percentage=0
+machine_steps_per_mm_e=1600
+xy_offset=0
+cross_support_density_image=
+print_temperature=200
+machine_max_acceleration_z=100
+magic_spiralize=False
+top_bottom_extruder_nr=-1
+support_extruder_nr=0
+support_xy_overrides_z=z_overrides_xy
+material_flow_layer_0=100
+day=Thu
+bottom_thickness=1
+wall_min_flow_retract=False
+machine_use_extruder_offset_to_offset_coords=True
+raft_acceleration=4000
+cool_lift_head=False
+ooze_shield_angle=60
+shell=0
+layer_start_x=213.0
+material_print_temperature_layer_0=205
+machine_minimum_feedrate=0.0
+flow_rate_extrusion_offset_factor=100
+acceleration_enabled=True
+wireframe_straight_before_down=20
+machine_nozzle_temp_enabled=True
+speed_infill=35
+jerk_roofing=5
+material=0
+jerk_support_bottom=5
+raft_interface_acceleration=4000
+raft_jerk=25
+wireframe_flow=100
+ooze_shield_enabled=True
+support_bottom_pattern=concentric
+gradual_infill_step_height=1.5
+acceleration_travel_layer_0=625.0
+mesh_position_y=0
+roofing_line_width=0.35
+machine_nozzle_size=0.4
+machine_head_polygon=[[-1, 1], [-1, -1], [1, -1], [1, 1]]
+wireframe_flow_connection=100
+adaptive_layer_height_variation=0.1
+wall_0_inset=0
+travel_compensate_overlapping_walls_x_enabled=True
+support_skip_some_zags=False
+speed=0
+layer_start_y=198.0
+acceleration_wall=1000
+extruders_enabled_count=2
+machine_depth=215
+machine_firmware_retract=False
+wireframe_printspeed_down=5
+roofing_extruder_nr=-1
+adaptive_layer_height_variation_step=0.01
+jerk_wall_x=10
+machine_max_jerk_z=0.4
+infill_line_distance=0.42
+bridge_fan_speed=100
+material_bed_temp_prepend=True
+cool_fan_full_layer=6
+jerk_support_interface=5
+skin_preshrink=0.95
+support_tree_branch_distance=1
+infill_multiplier=1
+machine_max_jerk_e=5.0
+material_bed_temperature=60
+sub_div_rad_add=0.3
+bridge_skin_material_flow_2=100
+cool_fan_enabled=True
+machine_steps_per_mm_z=50
+bridge_skin_density_2=75
+speed_slowdown_layers=2
+support_type=buildplate
+acceleration_travel=5000
+cool_min_layer_time_fan_speed_max=10
+infill_support_enabled=False
+material_initial_print_temperature=190
+wireframe_bottom_delay=0
+bridge_wall_speed=10.0
+mold_enabled=False
+bridge_wall_max_overhang=100
+skin_alternate_rotation=False
+slicing_tolerance=middle
+layer_height=0.2
+retraction_extrusion_window=1
+raft_speed=17.5
+mesh_position_z=0
+cross_infill_pocket_size=0.42
+support_supported_skin_fan_speed=100
+support_roof_density=100
+jerk_wall_0=5
+support_wall_count=0
+ironing_pattern=zigzag
+top_layers=0
+support_xy_distance=0.875
+wireframe_printspeed_up=5
+machine_feeder_wheel_diameter=10.0
+material_flow_dependent_temperature=False
+skin_no_small_gaps_heuristic=True
+speed_ironing=13.333333333333334
+wall_x_extruder_nr=-1
+top_skin_preshrink=0.95
+support_skip_zag_per_mm=20
+meshfix=0
+machine_heated_bed=True
+support_tree_wall_thickness=0.35
+support_top_distance=0.4
+retraction_hop_after_extruder_switch=True
+layer_height_0=0.201
+acceleration_skirt_brim=500
+jerk_support_infill=15
+material_flow_temp_graph=[[3.5,200],[7.0,240]]
+retraction_enable=True
+support_interface_height=1
+raft_interface_thickness=0.30000000000000004
+retraction_hop_only_when_collides=True
+ironing_flow=10.0
diff -pruN 1:4.6.2-1/tests/utils/MinimumSpanningTreeTest.cpp 1:4.7.1-1/tests/utils/MinimumSpanningTreeTest.cpp
--- 1:4.6.2-1/tests/utils/MinimumSpanningTreeTest.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/tests/utils/MinimumSpanningTreeTest.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -6,7 +6,6 @@
 #include <algorithm>
 #include <vector>
 #include <unordered_map>
-#include <unordered_set>
 
 #include "../src/utils/MinimumSpanningTree.h"
 
@@ -36,7 +35,7 @@ namespace cura
                 Point(12, 12),
                 Point(12, 13),
             };
-            std::unordered_set<Point> pts_set(pts.begin(), pts.end());
+            std::vector<Point> pts_set(pts.begin(), pts.end());
             p_mst = new MinimumSpanningTree(pts_set);
         }
 
@@ -52,7 +51,7 @@ namespace cura
 
     TEST(SimpleMinimumSpanningTreeTest, TestConstructEmpty)
     {
-        std::unordered_set<Point> vertices;
+        std::vector<Point> vertices;
         MinimumSpanningTree tree(vertices);
 
         ASSERT_TRUE(tree.leaves().empty()) << "Empty tree should be empty.";
@@ -61,7 +60,7 @@ namespace cura
     TEST(SimpleMinimumSpanningTreeTest, TestConstructOne)
     {
         const Point pt_a(1, 1);
-        std::unordered_set<Point> vertices = { pt_a };
+        std::vector<Point> vertices = { pt_a };
         MinimumSpanningTree tree(vertices);
 
         ASSERT_FALSE(tree.leaves().empty()) << "Tree with one point shouldn't have no vertices.";
@@ -76,7 +75,7 @@ namespace cura
         const Point pt_b(2, 2);
         const Point pt_c(3, 3);
         const Point pt_d(4, 4);
-        std::unordered_set<Point> vertices = { pt_a, pt_b, pt_c, pt_d };
+        std::vector<Point> vertices = { pt_a, pt_b, pt_c, pt_d };
         MinimumSpanningTree tree(vertices);
 
         std::vector<Point> adjacent;
@@ -103,7 +102,7 @@ namespace cura
         const Point pt_b(5, 2);
         const Point pt_c(2, 5);
         const Point pt_d(3, 3);
-        std::unordered_set<Point> vertices = { pt_a, pt_b, pt_c, pt_d };
+        std::vector<Point> vertices = { pt_a, pt_b, pt_c, pt_d };
         MinimumSpanningTree tree(vertices);
 
         std::vector<Point> leaves = tree.leaves();
diff -pruN 1:4.6.2-1/tests/utils/PolygonTest.cpp 1:4.7.1-1/tests/utils/PolygonTest.cpp
--- 1:4.6.2-1/tests/utils/PolygonTest.cpp	2020-04-24 11:44:52.000000000 +0000
+++ 1:4.7.1-1/tests/utils/PolygonTest.cpp	2020-08-14 10:34:26.000000000 +0000
@@ -5,6 +5,8 @@
 #include <gmock/gmock.h>
 
 #include <../src/utils/polygon.h> //The class under test.
+#include <../src/utils/polygonUtils.h> // helper functions
+#include <../src/utils/SVG.h> // helper functions
 
 namespace cura
 {
@@ -20,6 +22,8 @@ public:
     Polygon clockwise_small;
     Polygons clockwise_donut;
     Polygon line;
+    
+    static constexpr bool visualize = false;
 
     void SetUp()
     {
@@ -246,17 +250,29 @@ TEST_F(PolygonTest, simplifyZigzag)
     constexpr coord_t segment_length = 1000;
     const coord_t y_increment = segment_length / std::sqrt(2);
     coord_t x = y_increment / 2;
+    size_t zigzag_count = 100;
 
-    for (size_t i = 0; i < 100; i++)
+    for (size_t i = 0; i < zigzag_count; i++)
     {
         zigzag.add(Point(x, i * y_increment));
         x = 0 - x;
     }
 
-    constexpr coord_t maximum_error = 2 * segment_length * segment_length + 100; //Squared offset from baseline (and some margin for rounding).
-    zigzag_polygons.simplify(segment_length + 10, maximum_error);
+    Polygon zigzag_before = zigzag;
 
-    ASSERT_LE(zigzag.size(), 5) << "Zigzag should be removed since the total error compensates with each zag.";
+    // we make the smallest_line_segment just smaller than the line from the start to the second to last point
+    // so that we ensure the polygon does not get removed altogether
+    zigzag_polygons.simplify(y_increment * (zigzag_count - 2) - 100, y_increment);
+
+    if (visualize)
+    {
+        SVG svg("output/simplifyZigzag.svg", AABB(zigzag_before));
+        svg.writePolygon(zigzag_before);
+        svg.nextLayer();
+        svg.writePolygon(zigzag, SVG::Color::RED);
+    }
+    
+    EXPECT_THAT(zigzag.size(), testing::AllOf(testing::Ge(3), testing::Le(5))) << "All but the last zigzag should be removed.";
 }
 
 TEST_F(PolygonTest, simplifyLimitedLength)
@@ -287,14 +303,19 @@ TEST_F(PolygonTest, simplifyLimitedLengt
 
 TEST_F(PolygonTest, simplifyLimitedError)
 {
-    //Generate a square spiral with increasingly large corners until the area exceeds the limit.
+    // Generate a large polygon with a small region with arbitrary simplifiable geometry
+    // We choose a spiral for that arbitrary geometry
+    
+    //Generate a square spiral with increasingly large corners
     Polygons spiral_polygons;
     PolygonRef spiral = spiral_polygons.newPoly();
-    spiral.add(Point());
+    spiral.emplace_back(-15000, 11000); // introduce points that may never be simplified so that we know the simplification should start at 0,0
+    spiral.emplace_back(-15000, 1000);
+    spiral.emplace_back(0, 0);
 
     //Generate a square spiral, 90 degree corners to make it easy to compute the area loss while retaining a positive area per corner.
     coord_t segment_length = 1000;
-    Point last_position;
+    Point last_position(0, 0);
     double angle = 0;
     for (size_t i = 0; i < 10; i++)
     {
@@ -305,18 +326,263 @@ TEST_F(PolygonTest, simplifyLimitedError
         segment_length += 100;
         angle += M_PI / 2;
     }
+    Polygon spiral_before = spiral;
 
-    //We want it to not merge the lines 1400 and 1500 any more, but do merge all lines before it.
-    //Take the area of the 1400 by 1500 and plug it into the formula for the height to get at the baseline height, which is our allowed error.
-    constexpr coord_t area = 1400 * 1500 / 2;
-    const coord_t diagonal_length = std::sqrt(1400 * 1400 + 1500 * 1500); //Pythagoras.
-    //A = 0.5 * b * h. diagonal_length is the base line in this case.
-    //2A = b * h
-    //2A / b = h
-    const coord_t height = 4 * area / diagonal_length; //Error of the first vertex we want to keep, so we must set the limit to something slightly lower than this.
-    spiral_polygons.simplify(999999999, height - 10);
+    coord_t max_height = segment_length * std::sqrt(2.0); // the diameter of the circle along the diagonal
 
-    EXPECT_THAT(spiral.size(), testing::AllOf(testing::Ge(11 - 5), testing::Le(11 - 4))) << "Should merge segments of length 1000 through 1400 and (optionally) first with last.";
+    for (size_t i = 0; i < spiral_before.size(); ++i)
+    {
+        // apply simplify iteratively for each point until nothing is simplifiable any more
+        spiral_polygons.simplify(10000, max_height);
+    }
+
+    EXPECT_THAT(spiral.size(), testing::Eq(4)) << "Should simplify all spiral points except those connected to far away geometry.";
+}
+
+
+TEST_F(PolygonTest, simplifyIncreasingLimitedError)
+{
+    // Generate a zigzag with bends in the outer ends with increasing height
+    //   _   /\                        .
+    //  | | | |
+    //  | | | |
+    //  | | | |
+    //  | | | |
+    //     v   \/
+    
+    Polygons zigzag_polygons;
+    PolygonRef zigzag = zigzag_polygons.newPoly();
+    
+    constexpr coord_t non_simplifiable_bound = 10000;
+    constexpr coord_t max_height = 562;
+    
+    coord_t long_segment = non_simplifiable_bound + 100;
+    
+    constexpr coord_t width = 1000;
+    
+    zigzag.emplace_back(0, 0);
+
+    size_t simplifiable_bend_count = 0;
+    
+    for (coord_t height = 100; height < 1000 || (height == 1000 && long_segment < 0); height += 25)
+    {
+        Point last_position = zigzag.back();
+        zigzag.emplace_back(last_position + Point(width / 2, height));
+        zigzag.emplace_back(last_position + Point(width, 0));
+        zigzag.emplace_back(last_position + Point(width, long_segment));
+        long_segment *= -1;
+        if (height < max_height)
+        {
+            simplifiable_bend_count++;
+        }
+    }
+    zigzag.emplace_back(zigzag.back() + Point(-non_simplifiable_bound, -non_simplifiable_bound)); // complete polygon with a point which enforces non-simplification to both its segments
+
+    Polygon zigzag_before = zigzag;
+
+    zigzag_polygons.simplify(non_simplifiable_bound, max_height);
+
+    if (visualize)
+    {
+        SVG svg("output/simplifyIncreasingLimitedError.svg", AABB(zigzag_before));
+        svg.writePolygon(zigzag_before);
+        svg.nextLayer();
+        svg.writePolygon(zigzag, SVG::Color::RED);
+    }
+    EXPECT_THAT(zigzag.size(), testing::Eq(zigzag_before.size() - simplifiable_bend_count)) << "Should simplify bends with height 100 up to 500";
+}
+
+
+TEST_F(PolygonTest, simplifySineLimitedError)
+{
+    // Generate a straight line with sinusoidal errors which should be simplified back into a more straight line
+    
+    // Hypothetically simplify() might replace each half period of the sine with a straight segment,
+    // but because simplify() is heuristic it introduces more segments.
+    // The function signature doesn't provide any guarantee about how much simplification will occur,
+    // but in practice it should at least simplify up to double the minimal segment count.
+    
+    Polygons sine_polygons;
+    PolygonRef sine = sine_polygons.newPoly();
+    
+    constexpr coord_t length = 10000;
+    constexpr coord_t deviation = 500;
+    constexpr size_t bulge_count = 5;
+    
+    sine.emplace_back(length, 0);
+    sine.emplace_back(length, length);
+    sine.emplace_back(0, length);
+    sine.emplace_back(0, 0);
+
+    for (coord_t x = 100; x < length; x += 100)
+    {
+        sine.emplace_back(x, std::sin(INT2MM(x) / INT2MM(length) * M_PI * bulge_count ) * deviation);
+    }
+    Polygon sine_before = sine;
+
+    sine_polygons.simplify(length / 2, 2 * deviation);
+    if (visualize)
+    {
+        SVG svg("output/simplifySineLimitedError.svg", AABB(sine_before));
+        svg.writePolygon(sine_before);
+        svg.nextLayer();
+        svg.writePolygon(sine, SVG::Color::RED);
+    }
+    const size_t max_simplified_sine_segments = bulge_count * 2; // * 2 because simplify() is not precise and might not optimally simplify
+    EXPECT_THAT(sine.size(), testing::AllOf(testing::Ge(4), testing::Le(4 + max_simplified_sine_segments))) << "Should simplify each outward and each inward bulge.";
+}
+
+TEST_F(PolygonTest, simplifySineHighPoly)
+{
+    // Generate a straight line with sinusoidal errors which should be simplified back into a more straight line
+    
+    // Hypothetically simplify() might replace each half period of the sine with a straight segment,
+    // but because simplify() is heuristic it introduces more segments.
+    // The function signature doesn't provide any guarantee about how much simplification will occur,
+    // but in practice it should at least simplify up to double the minimal segment count.
+    
+    Polygons sine_polygons;
+    PolygonRef sine = sine_polygons.newPoly();
+    
+    constexpr coord_t length = 1000;
+    constexpr coord_t deviation = 100;
+    constexpr size_t bulge_count = 17;
+    constexpr coord_t allowed_simplification_height = 30;
+    constexpr coord_t allowed_segment_length = 100;
+    
+    sine.emplace_back(length, 0);
+    sine.emplace_back(length, length);
+    sine.emplace_back(0, length);
+    sine.emplace_back(0, 0);
+
+    for (coord_t x = 1; x < length; x += 1)
+    {
+        coord_t y = std::sin(INT2MM(x) / INT2MM(length) * M_PI * bulge_count) * deviation;
+        if ( ! sine.empty())
+        {
+            coord_t y_mid = (y + sine.back().Y) / 2;
+            if (y_mid != y && y_mid != sine.back().Y
+                && sine.back().X == x - 1
+            )
+            {
+                sine.emplace_back(x, y_mid);
+            }
+        }
+        sine.emplace_back(x, y);
+        if (x % (allowed_segment_length * 3) == 0) x += allowed_segment_length + 5;
+    }
+    Polygon sine_before = sine;
+
+    sine_polygons.simplify(allowed_segment_length, allowed_simplification_height);
+    
+    // find largest height deviation
+    coord_t largest_dist = 0;
+    for (Point from : sine_before)
+    {
+        ClosestPolygonPoint cpp = PolygonUtils::findClosest(from, sine_polygons);
+        coord_t dist_between_polys = vSize(from - cpp.p());
+        largest_dist = std::max(largest_dist, dist_between_polys);
+    }
+    if (visualize)
+    {
+        SVG svg("output/simplifySineHighPoly.svg", AABB(sine_before));
+        svg.writePolygon(sine_before);
+        svg.nextLayer();
+        svg.writePolygon(sine, SVG::Color::RED);
+    }
+    EXPECT_THAT( largest_dist, testing::Le(allowed_simplification_height + 10)) << "Shouldn't exceed maximum error distance";
+}
+
+TEST_F(PolygonTest, simplifyCircleLimitedError)
+{
+    //Generate a circle with increasing resolution
+    Polygons circle_polygons;
+    PolygonRef circle = circle_polygons.newPoly();
+
+    coord_t radius = 20000;
+    coord_t segment_length = 100;
+    for (double angle = 0; angle < 2 * M_PI; )
+    {
+        const coord_t dx = std::cos(angle) * radius;
+        const coord_t dy = std::sin(angle) * radius;
+        Point new_point(dx, dy);
+        assert(circle.empty() || std::abs( vSize(circle.back() - new_point) - segment_length) < 10); // we should now add a segment of the prescribed length
+        circle.add(new_point);
+        segment_length += 100;
+        angle += 2.0 * std::asin(0.5 * INT2MM(segment_length) / INT2MM(radius));
+    }
+
+    Polygon circle_before = circle;
+
+    coord_t allowed_simplification_height = 1000;
+    Polygons circle_polygons_before = circle_polygons;
+    
+    circle_polygons.simplify(9999999, allowed_simplification_height);
+
+    // find largest height deviation
+    coord_t largest_dist = 0;
+    for (Point from : circle_before)
+    {
+        ClosestPolygonPoint cpp = PolygonUtils::findClosest(from, circle_polygons);
+        coord_t dist_between_polys = vSize(from - cpp.p());
+        largest_dist = std::max(largest_dist, dist_between_polys);
+    }
+    if (visualize)
+    {
+        SVG svg("output/simplifyCircleLimitedError.svg", AABB(circle_before));
+        svg.writePolygon(circle_before);
+        svg.nextLayer();
+        svg.writePolygon(circle, SVG::Color::RED);
+    }
+    EXPECT_THAT( largest_dist, testing::Le(allowed_simplification_height + 10)) << "Shouldn't exceed maximum error distance";
+}
+
+TEST_F(PolygonTest, simplifyCircleHighPoly)
+{
+    //Generate a circle with extremely high point count, such that all segments are within rounding distance 
+    Polygons circle_polygons;
+    PolygonRef circle = circle_polygons.newPoly();
+
+    coord_t radius = 2000;
+    coord_t segment_length = 1;
+    coord_t allowed_simplification_height = 50;
+
+    for (double angle = 0; angle < 2 * M_PI; )
+    {
+        const coord_t x = std::cos(angle) * radius;
+        const coord_t y = std::sin(angle) * radius;
+        Point new_point(x, y);
+        circle.add(new_point);
+        coord_t segment_length_here = segment_length;
+        if ( (x + y) % 5 == 0 )
+        {
+            segment_length_here = 500;
+        }
+        angle += 2.0 * std::asin(0.5 * INT2MM(segment_length_here) / INT2MM(radius));
+    }
+
+    Polygon circle_before = circle;
+
+    Polygons circle_polygons_before = circle_polygons;
+    
+    circle_polygons.simplify(9999999, allowed_simplification_height);
+
+    // find largest height deviation
+    coord_t largest_dist = 0;
+    for (Point from : circle_before)
+    {
+        ClosestPolygonPoint cpp = PolygonUtils::findClosest(from, circle_polygons);
+        coord_t dist_between_polys = vSize(from - cpp.p());
+        largest_dist = std::max(largest_dist, dist_between_polys);
+    }
+    if (visualize)
+    {
+        SVG svg("output/simplifyCircleHighPoly.svg", AABB(circle_before));
+        svg.writePolygon(circle_before);
+        svg.nextLayer();
+        svg.writePolygon(circle, SVG::Color::RED);
+    }
+    EXPECT_THAT( largest_dist, testing::Le(allowed_simplification_height + 5)) << "Shouldn't exceed maximum error distance";
 }
 
 TEST_F(PolygonTest, simplifyColinear)
@@ -331,20 +597,44 @@ TEST_F(PolygonTest, simplifyColinear)
     }
     colinear.add(Point(spacing * 9, 0)); //Make it a triangle so that the area is not 0 or anything.
 
+    Polygon colinear_before = colinear;
+
     colinear_polygons.simplify(20, 20); //Regardless of parameters, it should always remove vertices with less than 5 micron deviation.
-    ASSERT_EQ(colinear_polygons[0].size(), 3) << "Only the first vertex of the colinear segments, the last vertex of the colinear segments, and the extra triangle vertex should remain.";
-    size_t start_point = 0;
-    for(; start_point < 3; start_point++) //Find where in the new polygon it starts with (-1, -1).
+    if (visualize)
     {
-        if(colinear_polygons[0][start_point] == Point(-1, -1))
-        {
-            break;
-        }
+        SVG svg("output/simplifyColinear.svg", AABB(colinear_before));
+        svg.writePolygon(colinear_before);
+        svg.nextLayer();
+        svg.writePolygon(colinear, SVG::Color::RED);
+    }
+    ASSERT_EQ(colinear_polygons.size(), 1) << "Polygon shouldn't have gotten removed altogether";
+    ASSERT_LE(colinear_polygons[0].size(), 8) << "At least half of the colinear points should have been removed";
+}
+
+TEST_F(PolygonTest, simplifyDegenerateVertex)
+{
+    //Generate a line with several vertices halfway.
+    constexpr coord_t spacing = 100;
+    Polygons colinear_polygons;
+    PolygonRef colinear = colinear_polygons.newPoly();
+    colinear.emplace_back(0, 0);
+    colinear.emplace_back(spacing, 0);
+    colinear.emplace_back(spacing, spacing);
+    colinear.emplace_back(0, spacing);
+    colinear.emplace_back(0, -spacing); // degenerate vertex
+    
+    Polygon colinear_before = colinear;
+
+    colinear_polygons.simplify(20, 5); //Regardless of parameters, it should always remove the one vertex
+    if (visualize)
+    {
+        SVG svg("output/simplifyDegenerateVertex.svg", AABB(colinear_before));
+        svg.writePolygon(colinear_before);
+        svg.nextLayer();
+        svg.writePolygon(colinear, SVG::Color::RED);
     }
-    ASSERT_LT(start_point, 3) << "The starting point (-1, -1) must be in the resulting polygon somewhere. Doesn't matter where.";
-    EXPECT_EQ(colinear_polygons[0][start_point], Point(-1, -1));
-    EXPECT_EQ(colinear_polygons[0][(start_point + 1) % 3], Point(spacing * 9, spacing * 9));
-    EXPECT_EQ(colinear_polygons[0][(start_point + 2) % 3], Point(spacing * 9, 0));
+    ASSERT_EQ(colinear_polygons.size(), 1) << "Polygon shouldn't have gotten removed altogether";
+    ASSERT_EQ(colinear_polygons[0].size(), 4) << "The one colinear vertex should have gotten removed.";
 }
 
 /*
